SET SQL_MODE = "NO_AUTO_VALUE_ON_ZERO";
SET time_zone = "+00:00";


/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8 */;

--
-- Database: `stagger`
--

CREATE DATABASE `stagger` DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci;
USE `stagger`;

DELIMITER ;

-- --------------------------------------------------------

--
-- Table structure for table `clients`
--

CREATE TABLE IF NOT EXISTS `clients` (
`id` int(10) unsigned NOT NULL,
  `enabled` tinyint(1) NOT NULL DEFAULT '1',
  `host` varchar(255) COLLATE utf8_unicode_ci NOT NULL,
  `port` smallint(5) unsigned NOT NULL DEFAULT '22',
  `username` varchar(255) COLLATE utf8_unicode_ci NOT NULL DEFAULT 'Admin',
  `password` varchar(255) COLLATE utf8_unicode_ci NOT NULL DEFAULT 'Admin',
  `connect_attempt` timestamp NULL DEFAULT NULL COMMENT 'Last connection attempt',
  `connect_success` timestamp NULL DEFAULT NULL COMMENT 'Last connection success',
  `thread_id` int(11) unsigned DEFAULT NULL
) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

-- --------------------------------------------------------

--
-- Table structure for table `requests`
--

CREATE TABLE IF NOT EXISTS `requests` (
`id` int(11) NOT NULL,
  `client_id` int(11) NOT NULL,
  `timestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `request` text COLLATE utf8_unicode_ci NOT NULL,
  `state` enum('pending','processing','done','error') COLLATE utf8_unicode_ci NOT NULL DEFAULT 'pending',
  `response` text COLLATE utf8_unicode_ci
) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

-- --------------------------------------------------------

--
-- Table structure for table `st_general`
--

CREATE TABLE IF NOT EXISTS `st_general` (
  `client_id` int(10) unsigned NOT NULL,
  `timestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `actual` smallint(6) NOT NULL DEFAULT '2',
  `device_model` varchar(255) COLLATE utf8_unicode_ci DEFAULT NULL,
  `fw_version` varchar(255) COLLATE utf8_unicode_ci NOT NULL COMMENT 'Firmware version',
  `sys_time` datetime NOT NULL COMMENT 'System time',
  `uptime` int(11) NOT NULL COMMENT 'sec',
  `mem_total` int(11) NOT NULL COMMENT 'Total Memory, bytes',
  `mem_free` int(11) NOT NULL COMMENT 'Free Memory, bytes',
  `cpu_usage` float NOT NULL COMMENT 'CPU usage, %',
  `operation_mode` enum('Unknown','AP-Bridge','AP-Gateway','Client-Gateway','Client-AP-Gateway') COLLATE utf8_unicode_ci NOT NULL DEFAULT 'Unknown',
  `apcli_bridge_only` tinyint(1) NOT NULL DEFAULT '0'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

-- --------------------------------------------------------

--
-- Stand-in structure for view `st_general_current`
--
CREATE TABLE IF NOT EXISTS `st_general_current` (
`client_id` int(10) unsigned
,`timestamp` timestamp
,`actual` smallint(6)
,`device_model` varchar(255)
,`fw_version` varchar(255)
,`sys_time` datetime
,`uptime` int(11)
,`mem_total` int(11)
,`mem_free` int(11)
,`cpu_usage` float
,`operation_mode` enum('Unknown','AP-Bridge','AP-Gateway','Client-Gateway','Client-AP-Gateway')
,`apcli_bridge_only` tinyint(1)
);
-- --------------------------------------------------------

--
-- Table structure for table `st_interfaces`
--

CREATE TABLE IF NOT EXISTS `st_interfaces` (
  `client_id` int(10) unsigned NOT NULL,
  `ifname` varchar(255) COLLATE utf8_unicode_ci NOT NULL,
  `timestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `actual` smallint(6) NOT NULL DEFAULT '2',
  `rx_bytes` bigint(20) unsigned NOT NULL,
  `tx_bytes` bigint(20) unsigned NOT NULL,
  `rx_packets` bigint(20) unsigned NOT NULL,
  `tx_packets` bigint(20) unsigned NOT NULL,
  `rx_bytes_diff` bigint(20) unsigned NOT NULL,
  `tx_bytes_diff` bigint(20) unsigned NOT NULL,
  `rx_packets_diff` bigint(20) unsigned NOT NULL,
  `tx_packets_diff` bigint(20) unsigned NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

-- --------------------------------------------------------

--
-- Stand-in structure for view `st_interfaces_current`
--
CREATE TABLE IF NOT EXISTS `st_interfaces_current` (
`client_id` int(10) unsigned
,`ifname` varchar(255)
,`timestamp` timestamp
,`actual` smallint(6)
,`rx_bytes` bigint(20) unsigned
,`tx_bytes` bigint(20) unsigned
,`rx_packets` bigint(20) unsigned
,`tx_packets` bigint(20) unsigned
);
-- --------------------------------------------------------

--
-- Table structure for table `st_ipv6`
--

CREATE TABLE IF NOT EXISTS `st_ipv6` (
  `client_id` int(10) unsigned NOT NULL,
  `timestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `actual` smallint(6) NOT NULL DEFAULT '2',
  `ip_int` varchar(30) COLLATE utf8_unicode_ci NOT NULL COMMENT 'IPv6 Internal Address',
  `ip_ext` varchar(30) COLLATE utf8_unicode_ci NOT NULL COMMENT 'IPv6 External Address',
  `netmask_int` smallint(6) NOT NULL COMMENT 'IPv6 Internal Netmask',
  `netmask_ext` smallint(6) NOT NULL COMMENT 'IPv6 External Netmask',
  `mode` varchar(8) COLLATE utf8_unicode_ci NOT NULL COMMENT 'IPv6 Mode',
  `gw` varchar(255) COLLATE utf8_unicode_ci NOT NULL COMMENT 'IPv6 Default gateway',
  `dns_primary` varchar(255) COLLATE utf8_unicode_ci NOT NULL,
  `dns_secondary` varchar(255) COLLATE utf8_unicode_ci NOT NULL,
  `over_vpn` tinyint(1) NOT NULL COMMENT 'IPv6 over VPN',
  `dhcpra` tinyint(1) NOT NULL COMMENT 'IPv6 autoconfig by DHCP/RA',
  `inet_lan_access` tinyint(1) NOT NULL COMMENT 'Access to LAN from internet',
  `radvd_enabled` tinyint(1) NOT NULL COMMENT 'Router Advertisement',
  `dhcp6s_enabled` tinyint(1) NOT NULL COMMENT 'Dynamic IPv6 configuration'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

-- --------------------------------------------------------

--
-- Stand-in structure for view `st_ipv6_current`
--
CREATE TABLE IF NOT EXISTS `st_ipv6_current` (
`client_id` int(10) unsigned
,`timestamp` timestamp
,`actual` smallint(6)
,`ip_int` varchar(30)
,`ip_ext` varchar(30)
,`netmask_int` smallint(6)
,`netmask_ext` smallint(6)
,`mode` varchar(8)
,`gw` varchar(255)
,`dns_primary` varchar(255)
,`dns_secondary` varchar(255)
,`over_vpn` tinyint(1)
,`dhcpra` tinyint(1)
,`inet_lan_access` tinyint(1)
,`radvd_enabled` tinyint(1)
,`dhcp6s_enabled` tinyint(1)
);
-- --------------------------------------------------------

--
-- Table structure for table `st_lan`
--

CREATE TABLE IF NOT EXISTS `st_lan` (
  `client_id` int(10) unsigned NOT NULL,
  `timestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `actual` smallint(6) NOT NULL DEFAULT '2',
  `hostname` varchar(255) COLLATE utf8_unicode_ci NOT NULL COMMENT 'LAN Hostname',
  `ip` varchar(16) COLLATE utf8_unicode_ci NOT NULL COMMENT 'LAN IP Address',
  `netmask` varchar(16) COLLATE utf8_unicode_ci NOT NULL COMMENT 'LAN Netmask',
  `mac` varchar(20) COLLATE utf8_unicode_ci DEFAULT NULL COMMENT 'Physical LAN IP Addr'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

-- --------------------------------------------------------

--
-- Stand-in structure for view `st_lan_current`
--
CREATE TABLE IF NOT EXISTS `st_lan_current` (
`client_id` int(10) unsigned
,`timestamp` timestamp
,`actual` smallint(6)
,`hostname` varchar(255)
,`ip` varchar(16)
,`netmask` varchar(16)
,`mac` varchar(20)
);
-- --------------------------------------------------------

--
-- Table structure for table `st_ports`
--

CREATE TABLE IF NOT EXISTS `st_ports` (
  `client_id` int(10) unsigned NOT NULL,
  `port_id` int(11) NOT NULL,
  `timestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `actual` tinyint(4) NOT NULL DEFAULT '2',
  `link` tinyint(1) NOT NULL,
  `speed` int(11) NOT NULL,
  `duplex` tinyint(1) NOT NULL,
  `rx_bytes` bigint(20) NOT NULL,
  `tx_bytes` bigint(20) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

-- --------------------------------------------------------

--
-- Stand-in structure for view `st_ports_current`
--
CREATE TABLE IF NOT EXISTS `st_ports_current` (
`client_id` int(10) unsigned
,`port_id` int(11)
,`timestamp` timestamp
,`actual` tinyint(4)
,`link` tinyint(1)
,`speed` int(11)
,`duplex` tinyint(1)
,`rx_bytes` bigint(20)
,`tx_bytes` bigint(20)
);
-- --------------------------------------------------------

--
-- Table structure for table `st_ssid_list`
--

CREATE TABLE IF NOT EXISTS `st_ssid_list` (
  `client_id` int(10) unsigned NOT NULL,
  `entry_id` int(10) unsigned NOT NULL,
  `timestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `actual` smallint(6) NOT NULL DEFAULT '2',
  `bssid` varchar(32) COLLATE utf8_unicode_ci NOT NULL,
  `ssid` varchar(255) COLLATE utf8_unicode_ci NOT NULL,
  `hidden` tinyint(1) NOT NULL,
  `isolate_cl` tinyint(1) NOT NULL COMMENT 'Client Isolation',
  `isolate_bc` tinyint(1) NOT NULL COMMENT 'Broadcast Isolation'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

-- --------------------------------------------------------

--
-- Stand-in structure for view `st_ssid_list_current`
--
CREATE TABLE IF NOT EXISTS `st_ssid_list_current` (
`client_id` int(10) unsigned
,`entry_id` int(10) unsigned
,`timestamp` timestamp
,`actual` smallint(6)
,`bssid` varchar(32)
,`ssid` varchar(255)
,`hidden` tinyint(1)
,`isolate_cl` tinyint(1)
,`isolate_bc` tinyint(1)
);
-- --------------------------------------------------------

--
-- Table structure for table `st_vpn`
--

CREATE TABLE IF NOT EXISTS `st_vpn` (
  `client_id` int(10) unsigned NOT NULL,
  `timestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `actual` smallint(6) NOT NULL DEFAULT '2',
  `status` varchar(16) COLLATE utf8_unicode_ci NOT NULL,
  `ip_addr` varchar(16) COLLATE utf8_unicode_ci NOT NULL COMMENT 'Local VPN IP Address',
  `server` varchar(16) COLLATE utf8_unicode_ci NOT NULL,
  `interface` varchar(8) COLLATE utf8_unicode_ci NOT NULL COMMENT 'VPN Interface (LAN/WAN)',
  `service` varchar(255) COLLATE utf8_unicode_ci NOT NULL COMMENT 'VPN Service name',
  `username` varchar(255) COLLATE utf8_unicode_ci NOT NULL COMMENT 'VPN Username',
  `mode` varchar(8) COLLATE utf8_unicode_ci NOT NULL,
  `auth_method` varchar(8) COLLATE utf8_unicode_ci NOT NULL,
  `default_gw` tinyint(1) NOT NULL COMMENT 'VPN Default gateway',
  `pure_pppoe` tinyint(1) NOT NULL,
  `allow_mppe` tinyint(1) NOT NULL,
  `allow_debug` tinyint(1) NOT NULL,
  `adaptive_lcp` tinyint(1) NOT NULL,
  `peer_dns` tinyint(1) NOT NULL,
  `enable_nat` tinyint(1) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

-- --------------------------------------------------------

--
-- Stand-in structure for view `st_vpn_current`
--
CREATE TABLE IF NOT EXISTS `st_vpn_current` (
`client_id` int(10) unsigned
,`timestamp` timestamp
,`actual` smallint(6)
,`status` varchar(16)
,`ip_addr` varchar(16)
,`server` varchar(16)
,`interface` varchar(8)
,`service` varchar(255)
,`username` varchar(255)
,`mode` varchar(8)
,`auth_method` varchar(8)
,`default_gw` tinyint(1)
,`pure_pppoe` tinyint(1)
,`allow_mppe` tinyint(1)
,`allow_debug` tinyint(1)
,`adaptive_lcp` tinyint(1)
,`peer_dns` tinyint(1)
,`enable_nat` tinyint(1)
);
-- --------------------------------------------------------

--
-- Table structure for table `st_wan`
--

CREATE TABLE IF NOT EXISTS `st_wan` (
  `client_id` int(10) unsigned NOT NULL,
  `timestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `actual` smallint(6) NOT NULL DEFAULT '2',
  `conn_mode` varchar(16) COLLATE utf8_unicode_ci NOT NULL COMMENT 'Connection mode',
  `ip` varchar(16) COLLATE utf8_unicode_ci NOT NULL COMMENT 'Physical WAN IP Addr',
  `netmask` varchar(16) COLLATE utf8_unicode_ci NOT NULL COMMENT 'Physical WAN Netmask',
  `gw` varchar(32) COLLATE utf8_unicode_ci NOT NULL COMMENT 'Physical WAN Gateway interface',
  `mac` varchar(20) COLLATE utf8_unicode_ci NOT NULL,
  `dns_static` tinyint(1) NOT NULL,
  `dns_primary` varchar(16) COLLATE utf8_unicode_ci NOT NULL,
  `dns_secondary` varchar(16) COLLATE utf8_unicode_ci NOT NULL,
  `nat_enable` tinyint(1) NOT NULL DEFAULT '0'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

-- --------------------------------------------------------

--
-- Stand-in structure for view `st_wan_current`
--
CREATE TABLE IF NOT EXISTS `st_wan_current` (
`client_id` int(10) unsigned
,`timestamp` timestamp
,`actual` smallint(6)
,`conn_mode` varchar(16)
,`ip` varchar(16)
,`netmask` varchar(16)
,`gw` varchar(32)
,`mac` varchar(20)
,`dns_static` tinyint(1)
,`dns_primary` varchar(16)
,`dns_secondary` varchar(16)
,`nat_enable` tinyint(1)
);
-- --------------------------------------------------------

--
-- Table structure for table `st_wlan`
--

CREATE TABLE IF NOT EXISTS `st_wlan` (
  `client_id` int(10) unsigned NOT NULL,
  `timestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `actual` smallint(6) NOT NULL DEFAULT '2',
  `enabled` tinyint(1) NOT NULL,
  `enabled5` tinyint(1) NOT NULL DEFAULT '0',
  `bssid24` varchar(20) COLLATE utf8_unicode_ci DEFAULT NULL,
  `channel24` smallint(6) NOT NULL,
  `txpower24` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `mode24` enum('b-g','b','g','n','g-n','b-g-n') COLLATE utf8_unicode_ci DEFAULT NULL,
  `bssid5` varchar(32) COLLATE utf8_unicode_ci DEFAULT NULL,
  `channel5` int(11) NOT NULL,
  `txpower5` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `mode5` enum('a','a-an','an','a-an-ac','an-ac') COLLATE utf8_unicode_ci DEFAULT NULL,
  `apcli_status` smallint(6) NOT NULL,
  `apcli_addr` varchar(20) COLLATE utf8_unicode_ci DEFAULT NULL COMMENT 'APCli Address',
  `isolate_ssids` tinyint(1) NOT NULL COMMENT 'SSID to SSID isolation',
  `isolate_lan_wlan` tinyint(1) NOT NULL COMMENT 'LAN to WLAN isolation'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

-- --------------------------------------------------------

--
-- Stand-in structure for view `st_wlan_current`
--
CREATE TABLE IF NOT EXISTS `st_wlan_current` (
`client_id` int(10) unsigned
,`timestamp` timestamp
,`actual` smallint(6)
,`enabled` tinyint(1)
,`bssid24` varchar(20)
,`channel24` smallint(6)
,`bssid5` varchar(32)
,`channel5` int(11)
,`apcli_status` smallint(6)
,`apcli_addr` varchar(20)
,`isolate_ssids` tinyint(1)
,`isolate_lan_wlan` tinyint(1)
);
-- --------------------------------------------------------

--
-- Table structure for table `st_wlan_station_list`
--

CREATE TABLE IF NOT EXISTS `st_wlan_station_list` (
  `client_id` int(10) unsigned NOT NULL,
  `sta_mac` varchar(32) COLLATE utf8_unicode_ci NOT NULL,
  `timestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `bssid` varchar(32) COLLATE utf8_unicode_ci NOT NULL,
  `actual` tinyint(1) NOT NULL DEFAULT '2',
  `conn_time` int(11) unsigned NOT NULL COMMENT 'sec',
  `psm` tinyint(1) NOT NULL,
  `mimops` tinyint(1) NOT NULL,
  `mcs` smallint(6) NOT NULL,
  `bw` varchar(8) COLLATE utf8_unicode_ci NOT NULL,
  `sgi` tinyint(1) NOT NULL,
  `stbc` tinyint(1) NOT NULL,
  `ldpc` tinyint(1) NOT NULL,
  `mode` varchar(32) COLLATE utf8_unicode_ci NOT NULL,
  `tx_rate` int(11) NOT NULL,
  `rssi0` smallint(6) NOT NULL,
  `rssi1` smallint(6) NOT NULL,
  `quality0` smallint(6) NOT NULL,
  `quality1` smallint(6) NOT NULL,
  `rx_bytes` bigint(20) unsigned NOT NULL,
  `tx_bytes` bigint(20) unsigned NOT NULL,
  `rx_bytes_diff` bigint(20) unsigned NOT NULL,
  `tx_bytes_diff` bigint(20) unsigned NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

-- --------------------------------------------------------

--
-- Stand-in structure for view `st_wlan_station_list_current`
--
CREATE TABLE IF NOT EXISTS `st_wlan_station_list_current` (
`client_id` int(10) unsigned
,`sta_mac` varchar(32)
,`timestamp` timestamp
,`bssid` varchar(32)
,`actual` tinyint(1)
,`conn_time` int(11) unsigned
,`psm` tinyint(1)
,`mimops` tinyint(1)
,`mcs` smallint(6)
,`bw` varchar(8)
,`sgi` tinyint(1)
,`stbc` tinyint(1)
,`ldpc` tinyint(1)
,`mode` varchar(32)
,`tx_rate` int(11)
,`rssi0` smallint(6)
,`rssi1` smallint(6)
,`quality0` smallint(6)
,`quality1` smallint(6)
,`rx_bytes` bigint(20) unsigned
,`tx_bytes` bigint(20) unsigned
);


--
-- Indexes for dumped tables
--

--
-- Indexes for table `clients`
--
ALTER TABLE `clients`
ADD PRIMARY KEY (`id`);

--
-- Indexes for table `requests`
--
ALTER TABLE `requests`
ADD PRIMARY KEY (`id`,`client_id`);

--
-- Indexes for table `st_general`
--
ALTER TABLE `st_general`
 ADD PRIMARY KEY (`client_id`,`timestamp`), ADD KEY `timestamp` (`timestamp`), ADD KEY `actual` (`actual`), ADD KEY `client_id` (`client_id`), ADD KEY `id_and_actual` (`client_id`,`actual`), ADD KEY `id_ts_actual` (`client_id`,`timestamp`,`actual`);

--
-- Indexes for table `st_interfaces`
--
ALTER TABLE `st_interfaces`
 ADD PRIMARY KEY (`client_id`,`ifname`,`timestamp`), ADD KEY `timestamp` (`timestamp`), ADD KEY `actual` (`actual`), ADD KEY `client_id` (`client_id`), ADD KEY `id_and_actual` (`client_id`,`actual`);

--
-- Indexes for table `st_ipv6`
--
ALTER TABLE `st_ipv6`
 ADD PRIMARY KEY (`client_id`,`timestamp`), ADD KEY `timestamp` (`timestamp`), ADD KEY `actual` (`actual`), ADD KEY `client_id` (`client_id`), ADD KEY `id_and_actual` (`client_id`,`actual`);

--
-- Indexes for table `st_lan`
--
ALTER TABLE `st_lan`
 ADD PRIMARY KEY (`client_id`,`timestamp`), ADD KEY `timestamp` (`timestamp`), ADD KEY `actual` (`actual`), ADD KEY `client_id` (`client_id`), ADD KEY `id_and_actual` (`client_id`,`actual`), ADD KEY `mac` (`mac`);

--
-- Indexes for table `st_ports`
--
ALTER TABLE `st_ports`
 ADD PRIMARY KEY (`client_id`,`port_id`,`timestamp`), ADD KEY `timestamp` (`timestamp`), ADD KEY `actual` (`actual`), ADD KEY `client_id` (`client_id`), ADD KEY `id_and_actual` (`client_id`,`actual`);

--
-- Indexes for table `st_ssid_list`
--
ALTER TABLE `st_ssid_list`
 ADD PRIMARY KEY (`client_id`,`timestamp`,`bssid`,`ssid`), ADD KEY `timestamp` (`timestamp`), ADD KEY `actual` (`actual`), ADD KEY `client_id` (`client_id`), ADD KEY `id_and_actual` (`client_id`,`actual`), ADD KEY `bssid` (`bssid`), ADD KEY `client_id_2` (`client_id`,`bssid`);

--
-- Indexes for table `st_vpn`
--
ALTER TABLE `st_vpn`
 ADD PRIMARY KEY (`client_id`,`timestamp`), ADD KEY `timestamp` (`timestamp`), ADD KEY `actual` (`actual`), ADD KEY `client_id` (`client_id`), ADD KEY `id_and_actual` (`client_id`,`actual`);

--
-- Indexes for table `st_wan`
--
ALTER TABLE `st_wan`
 ADD PRIMARY KEY (`client_id`,`timestamp`), ADD KEY `timestamp` (`timestamp`), ADD KEY `actual` (`actual`), ADD KEY `client_id` (`client_id`), ADD KEY `id_and_actual` (`client_id`,`actual`);

--
-- Indexes for table `st_wlan`
--
ALTER TABLE `st_wlan`
 ADD PRIMARY KEY (`client_id`,`timestamp`), ADD KEY `timestamp` (`timestamp`), ADD KEY `actual` (`actual`), ADD KEY `client_id` (`client_id`), ADD KEY `id_and_actual` (`client_id`,`actual`);

--
-- Indexes for table `st_wlan_station_list`
--
ALTER TABLE `st_wlan_station_list`
 ADD PRIMARY KEY (`client_id`,`sta_mac`,`timestamp`,`bssid`), ADD KEY `timestamp` (`timestamp`), ADD KEY `client_id` (`client_id`), ADD KEY `bssid` (`bssid`), ADD KEY `sta_mac` (`sta_mac`), ADD KEY `actual` (`actual`), ADD KEY `client_id_2` (`client_id`), ADD KEY `id_and_actual` (`client_id`,`actual`);

--
-- AUTO_INCREMENT for dumped tables
--

--
-- AUTO_INCREMENT for table `clients`
--
ALTER TABLE `clients`
MODIFY `id` int(10) unsigned NOT NULL AUTO_INCREMENT,AUTO_INCREMENT=1;
--
-- AUTO_INCREMENT for table `requests`
--
ALTER TABLE `requests`
MODIFY `id` int(11) NOT NULL AUTO_INCREMENT,AUTO_INCREMENT=1;


-- --------------------------------------------------------

--
-- Structure for view `st_general_current`
--
DROP TABLE IF EXISTS `st_general_current`;

CREATE OR REPLACE ALGORITHM=MERGE VIEW `st_general_current` AS select * FROM `st_general` `t_tmp_general`
USE INDEX (`PRIMARY`,`timestamp`,`client_id`,`actual`) where `actual` = 2;

-- --------------------------------------------------------

--
-- Structure for view `st_interfaces_current`
--
DROP TABLE IF EXISTS `st_interfaces_current`;

-- CREATE ALGORITHM=UNDEFINED DEFINER=`root`@`localhost` SQL SECURITY DEFINER VIEW `st_interfaces_current` AS select `t_tmp_interfaces`.`client_id` AS `client_id`,`t_tmp_interfaces`.`ifname` AS `ifname`,`t_tmp_interfaces`.`timestamp` AS `timestamp`,`t_tmp_interfaces`.`actual` AS `actual`,`t_tmp_interfaces`.`rx_bytes` AS `rx_bytes`,`t_tmp_interfaces`.`tx_bytes` AS `tx_bytes`,`t_tmp_interfaces`.`rx_packets` AS `rx_packets`,`t_tmp_interfaces`.`tx_packets` AS `tx_packets` from `st_interfaces` `t_tmp_interfaces` USE INDEX (PRIMARY) USE INDEX (`id_and_actual`) USE INDEX (`actual`) where (`t_tmp_interfaces`.`actual` = 2);
CREATE OR REPLACE VIEW `st_interfaces_current` AS select * from `st_interfaces` `t_tmp_interfaces` USE INDEX (`PRIMARY`,`id_and_actual`,`actual`) where `actual` = 2;

-- --------------------------------------------------------

--
-- Structure for view `st_ipv6_current`
--
DROP TABLE IF EXISTS `st_ipv6_current`;

-- CREATE ALGORITHM=UNDEFINED DEFINER=`root`@`localhost` SQL SECURITY DEFINER VIEW `st_ipv6_current` AS select `t_tmp_ipv6`.`client_id` AS `client_id`,`t_tmp_ipv6`.`timestamp` AS `timestamp`,`t_tmp_ipv6`.`actual` AS `actual`,`t_tmp_ipv6`.`ip_int` AS `ip_int`,`t_tmp_ipv6`.`ip_ext` AS `ip_ext`,`t_tmp_ipv6`.`netmask_int` AS `netmask_int`,`t_tmp_ipv6`.`netmask_ext` AS `netmask_ext`,`t_tmp_ipv6`.`mode` AS `mode`,`t_tmp_ipv6`.`gw` AS `gw`,`t_tmp_ipv6`.`dns_primary` AS `dns_primary`,`t_tmp_ipv6`.`dns_secondary` AS `dns_secondary`,`t_tmp_ipv6`.`over_vpn` AS `over_vpn`,`t_tmp_ipv6`.`dhcpra` AS `dhcpra`,`t_tmp_ipv6`.`inet_lan_access` AS `inet_lan_access`,`t_tmp_ipv6`.`radvd_enabled` AS `radvd_enabled`,`t_tmp_ipv6`.`dhcp6s_enabled` AS `dhcp6s_enabled` from `st_ipv6` `t_tmp_ipv6` USE INDEX (PRIMARY) USE INDEX (`id_and_actual`) USE INDEX (`actual`) where (`t_tmp_ipv6`.`actual` = 1);
CREATE OR REPLACE VIEW `st_ipv6_current` AS select * from `st_ipv6` `t_tmp_ipv6` USE INDEX (`PRIMARY`,`id_and_actual`,`actual`) where `actual` = 1;

-- --------------------------------------------------------

--
-- Structure for view `st_lan_current`
--
DROP TABLE IF EXISTS `st_lan_current`;

-- CREATE ALGORITHM=UNDEFINED DEFINER=`root`@`localhost` SQL SECURITY DEFINER VIEW `st_lan_current` AS select `t1`.`client_id` AS `client_id`,`t1`.`timestamp` AS `timestamp`,`t1`.`actual` AS `actual`,`t1`.`hostname` AS `hostname`,`t1`.`ip` AS `ip`,`t1`.`netmask` AS `netmask`,`t1`.`mac` AS `mac` from `st_lan` `t1` where (`t1`.`timestamp` = (select max(`t2`.`timestamp`) from `st_lan` `t2` where (`t1`.`client_id` = `t2`.`client_id`))) group by `t1`.`client_id`;
CREATE OR REPLACE VIEW `st_lan_current` AS select * from `st_lan` `t_tmp_lan` USE INDEX (`PRIMARY`,`id_and_actual`,`timestamp`,`client_id`,`actual`) where `actual` = 1;

-- --------------------------------------------------------

--
-- Structure for view `st_ports_current`
--
DROP TABLE IF EXISTS `st_ports_current`;

-- CREATE ALGORITHM=UNDEFINED DEFINER=`root`@`localhost` SQL SECURITY DEFINER VIEW `st_ports_current` AS select `t_tmp_ports`.`client_id` AS `client_id`,`t_tmp_ports`.`port_id` AS `port_id`,`t_tmp_ports`.`timestamp` AS `timestamp`,`t_tmp_ports`.`actual` AS `actual`,`t_tmp_ports`.`link` AS `link`,`t_tmp_ports`.`speed` AS `speed`,`t_tmp_ports`.`duplex` AS `duplex`,`t_tmp_ports`.`rx_bytes` AS `rx_bytes`,`t_tmp_ports`.`tx_bytes` AS `tx_bytes` from `st_ports` `t_tmp_ports` USE INDEX (PRIMARY) USE INDEX (`id_and_actual`) USE INDEX (`actual`) where (`t_tmp_ports`.`actual` = 2);
CREATE OR REPLACE VIEW `st_ports_current` AS select * from `st_ports` `t_tmp_ports` USE INDEX (`PRIMARY`,`id_and_actual`,`actual`) where `actual` = 2;

-- --------------------------------------------------------

--
-- Structure for view `st_ssid_list_current`
--
DROP TABLE IF EXISTS `st_ssid_list_current`;

-- CREATE ALGORITHM=UNDEFINED DEFINER=`root`@`localhost` SQL SECURITY DEFINER VIEW `st_ssid_list_current` AS select `t_tmp_ssid_list`.`client_id` AS `client_id`,`t_tmp_ssid_list`.`entry_id` AS `entry_id`,`t_tmp_ssid_list`.`timestamp` AS `timestamp`,`t_tmp_ssid_list`.`actual` AS `actual`,`t_tmp_ssid_list`.`bssid` AS `bssid`,`t_tmp_ssid_list`.`ssid` AS `ssid`,`t_tmp_ssid_list`.`hidden` AS `hidden`,`t_tmp_ssid_list`.`isolate_cl` AS `isolate_cl`,`t_tmp_ssid_list`.`isolate_bc` AS `isolate_bc` from `st_ssid_list` `t_tmp_ssid_list` USE INDEX (PRIMARY) USE INDEX (`id_and_actual`) USE INDEX (`client_id`) USE INDEX (`bssid`) USE INDEX (`actual`) where (`t_tmp_ssid_list`.`actual` = 2);
CREATE OR REPLACE VIEW `st_ssid_list_current` AS select * from `st_ssid_list` `t_tmp_ssid_list` USE INDEX (`PRIMARY`,`id_and_actual`,`client_id`,`bssid`,`actual`) where `actual` = 2;

-- --------------------------------------------------------

--
-- Structure for view `st_vpn_current`
--
DROP TABLE IF EXISTS `st_vpn_current`;

-- CREATE ALGORITHM=UNDEFINED DEFINER=`root`@`localhost` SQL SECURITY DEFINER VIEW `st_vpn_current` AS select `t_tmp_vpn`.`client_id` AS `client_id`,`t_tmp_vpn`.`timestamp` AS `timestamp`,`t_tmp_vpn`.`actual` AS `actual`,`t_tmp_vpn`.`status` AS `status`,`t_tmp_vpn`.`ip_addr` AS `ip_addr`,`t_tmp_vpn`.`server` AS `server`,`t_tmp_vpn`.`interface` AS `interface`,`t_tmp_vpn`.`service` AS `service`,`t_tmp_vpn`.`username` AS `username`,`t_tmp_vpn`.`mode` AS `mode`,`t_tmp_vpn`.`auth_method` AS `auth_method`,`t_tmp_vpn`.`default_gw` AS `default_gw`,`t_tmp_vpn`.`pure_pppoe` AS `pure_pppoe`,`t_tmp_vpn`.`allow_mppe` AS `allow_mppe`,`t_tmp_vpn`.`allow_debug` AS `allow_debug`,`t_tmp_vpn`.`adaptive_lcp` AS `adaptive_lcp`,`t_tmp_vpn`.`peer_dns` AS `peer_dns`,`t_tmp_vpn`.`enable_nat` AS `enable_nat` from `st_vpn` `t_tmp_vpn` USE INDEX (PRIMARY) USE INDEX (`id_and_actual`) USE INDEX (`actual`) where (`t_tmp_vpn`.`actual` = 1);
CREATE OR REPLACE VIEW `st_vpn_current` AS select * from `st_vpn` `t_tmp_vpn` USE INDEX(`PRIMARY`,`id_and_actual`,`actual`) where `actual` = 1;

-- --------------------------------------------------------

--
-- Structure for view `st_wan_current`
--
DROP TABLE IF EXISTS `st_wan_current`;

-- CREATE ALGORITHM=MERGE DEFINER=`root`@`localhost` SQL SECURITY DEFINER VIEW `st_wan_current` AS select `t_tmp_wan`.`client_id` AS `client_id`,`t_tmp_wan`.`timestamp` AS `timestamp`,`t_tmp_wan`.`actual` AS `actual`,`t_tmp_wan`.`conn_mode` AS `conn_mode`,`t_tmp_wan`.`ip` AS `ip`,`t_tmp_wan`.`netmask` AS `netmask`,`t_tmp_wan`.`gw` AS `gw`,`t_tmp_wan`.`mac` AS `mac`,`t_tmp_wan`.`dns_static` AS `dns_static`,`t_tmp_wan`.`dns_primary` AS `dns_primary`,`t_tmp_wan`.`dns_secondary` AS `dns_secondary`,`t_tmp_wan`.`nat_enable` AS `nat_enable` from `st_wan` `t_tmp_wan` USE INDEX (PRIMARY) USE INDEX (`id_and_actual`) USE INDEX (`timestamp`) USE INDEX (`client_id`) USE INDEX (`actual`) where (`t_tmp_wan`.`actual` = 1);
CREATE OR REPLACE ALGORITHM=MERGE VIEW `st_wan_current` AS select * from `st_wan` `t_tmp_wan`
USE INDEX(`PRIMARY`,`id_and_actual`,`timestamp`,`client_id`,`actual`) where `actual` = 1;

-- --------------------------------------------------------

--
-- Structure for view `st_wlan_current`
--
DROP TABLE IF EXISTS `st_wlan_current`;

-- CREATE ALGORITHM=UNDEFINED DEFINER=`root`@`localhost` SQL SECURITY DEFINER VIEW `st_wlan_current` AS select `t_tmp_wlan`.`client_id` AS `client_id`,`t_tmp_wlan`.`timestamp` AS `timestamp`,`t_tmp_wlan`.`actual` AS `actual`,`t_tmp_wlan`.`enabled` AS `enabled`,`t_tmp_wlan`.`bssid24` AS `bssid24`,`t_tmp_wlan`.`channel24` AS `channel24`,`t_tmp_wlan`.`bssid5` AS `bssid5`,`t_tmp_wlan`.`channel5` AS `channel5`,`t_tmp_wlan`.`apcli_status` AS `apcli_status`,`t_tmp_wlan`.`apcli_addr` AS `apcli_addr`,`t_tmp_wlan`.`isolate_ssids` AS `isolate_ssids`,`t_tmp_wlan`.`isolate_lan_wlan` AS `isolate_lan_wlan` from `st_wlan` `t_tmp_wlan` USE INDEX (PRIMARY) USE INDEX (`id_and_actual`) USE INDEX (`timestamp`) USE INDEX (`client_id`) where (`t_tmp_wlan`.`actual` = 1);
CREATE OR REPLACE VIEW `st_wlan_current` AS select * from `st_wlan` `t_tmp_wlan` USE INDEX(`PRIMARY`,`id_and_actual`,`timestamp`,`client_id`) where `actual` = 1;

-- --------------------------------------------------------

--
-- Structure for view `st_wlan_station_list_current`
--
DROP TABLE IF EXISTS `st_wlan_station_list_current`;

-- CREATE ALGORITHM=UNDEFINED DEFINER=`root`@`localhost` SQL SECURITY DEFINER VIEW `st_wlan_station_list_current` AS select `t_tmp_wlan_station_list`.`client_id` AS `client_id`,`t_tmp_wlan_station_list`.`sta_mac` AS `sta_mac`,`t_tmp_wlan_station_list`.`timestamp` AS `timestamp`,`t_tmp_wlan_station_list`.`bssid` AS `bssid`,`t_tmp_wlan_station_list`.`actual` AS `actual`,`t_tmp_wlan_station_list`.`conn_time` AS `conn_time`,`t_tmp_wlan_station_list`.`psm` AS `psm`,`t_tmp_wlan_station_list`.`mimops` AS `mimops`,`t_tmp_wlan_station_list`.`mcs` AS `mcs`,`t_tmp_wlan_station_list`.`bw` AS `bw`,`t_tmp_wlan_station_list`.`sgi` AS `sgi`,`t_tmp_wlan_station_list`.`stbc` AS `stbc`,`t_tmp_wlan_station_list`.`ldpc` AS `ldpc`,`t_tmp_wlan_station_list`.`mode` AS `mode`,`t_tmp_wlan_station_list`.`tx_rate` AS `tx_rate`,`t_tmp_wlan_station_list`.`rssi0` AS `rssi0`,`t_tmp_wlan_station_list`.`rssi1` AS `rssi1`,`t_tmp_wlan_station_list`.`quality0` AS `quality0`,`t_tmp_wlan_station_list`.`quality1` AS `quality1`,`t_tmp_wlan_station_list`.`rx_bytes` AS `rx_bytes`,`t_tmp_wlan_station_list`.`tx_bytes` AS `tx_bytes` from `st_wlan_station_list` `t_tmp_wlan_station_list` USE INDEX (PRIMARY) USE INDEX (`id_and_actual`) USE INDEX (`sta_mac`) USE INDEX (`client_id`) USE INDEX (`timestamp`) USE INDEX (`bssid`) USE INDEX (`actual`) where (`t_tmp_wlan_station_list`.`actual` = 1);
CREATE OR REPLACE VIEW `st_wlan_station_list_current` AS select * from `st_wlan_station_list` `t_tmp_wlan_station_list`
    USE INDEX (`PRIMARY`,`id_and_actual`,`sta_mac`,`client_id`,`timestamp`,`bssid`,`actual`) where (`actual` = 1);


--
-- Constraints for dumped tables
--

--
-- Constraints for table `st_general`
--
ALTER TABLE `st_general`
ADD CONSTRAINT `status_to_clients_foreign_id` FOREIGN KEY (`client_id`) REFERENCES `clients` (`id`) ON DELETE CASCADE ON UPDATE CASCADE;

--
-- Constraints for table `st_interfaces`
--
ALTER TABLE `st_interfaces`
ADD CONSTRAINT `ifaces_to_clients_foreign_id` FOREIGN KEY (`client_id`) REFERENCES `clients` (`id`) ON DELETE CASCADE ON UPDATE CASCADE;

--
-- Constraints for table `st_ipv6`
--
ALTER TABLE `st_ipv6`
ADD CONSTRAINT `ipv6_to_clients_foreign_id` FOREIGN KEY (`client_id`) REFERENCES `clients` (`id`) ON DELETE CASCADE ON UPDATE CASCADE;

--
-- Constraints for table `st_lan`
--
ALTER TABLE `st_lan`
ADD CONSTRAINT `lan_to_clients_foreign_id` FOREIGN KEY (`client_id`) REFERENCES `clients` (`id`) ON DELETE CASCADE ON UPDATE CASCADE;

--
-- Constraints for table `st_ports`
--
ALTER TABLE `st_ports`
ADD CONSTRAINT `ports_to_clients_foreign_id` FOREIGN KEY (`client_id`) REFERENCES `clients` (`id`) ON DELETE CASCADE ON UPDATE CASCADE;

--
-- Constraints for table `st_ssid_list`
--
ALTER TABLE `st_ssid_list`
ADD CONSTRAINT `ssid_list_to_clients_foreign_id` FOREIGN KEY (`client_id`) REFERENCES `clients` (`id`) ON DELETE CASCADE ON UPDATE CASCADE;

--
-- Constraints for table `st_vpn`
--
ALTER TABLE `st_vpn`
ADD CONSTRAINT `vpn_to_clients_foreign_id` FOREIGN KEY (`client_id`) REFERENCES `clients` (`id`) ON DELETE CASCADE ON UPDATE CASCADE;

--
-- Constraints for table `st_wan`
--
ALTER TABLE `st_wan`
ADD CONSTRAINT `wan_to_clients_foreign_id` FOREIGN KEY (`client_id`) REFERENCES `clients` (`id`) ON DELETE CASCADE ON UPDATE CASCADE;

--
-- Constraints for table `st_wlan`
--
ALTER TABLE `st_wlan`
ADD CONSTRAINT `wlan_to_clients_foreign_id` FOREIGN KEY (`client_id`) REFERENCES `clients` (`id`) ON DELETE CASCADE ON UPDATE CASCADE;

--
-- Constraints for table `st_wlan_station_list`
--
ALTER TABLE `st_wlan_station_list`
ADD CONSTRAINT `wlan_stalist_to_clients_foreign_id` FOREIGN KEY (`client_id`) REFERENCES `clients` (`id`) ON DELETE CASCADE ON UPDATE CASCADE;

/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
