var firmware_tabpanel = new Ext.Panel({
	height:		center_panel_Height - 27,
	layout:		'column',
	border:		false,
	items:		[
					{
						xtype:			'panel',
						height:			center_panel_Height - 27,
						columnWidth:	0.4,
						border:			false,
						items:			[
											{
												xtype:			'grid',
												title:			'Firmware List',
												id:				'firmware_list_grid',
												height:			((center_panel_Height - 27) / 3),		// size - header
												scrollable:		true,
												border:			true,
												x:				-1,
												y:				-1,
												store:			{
																	fields:				[
																						{	name: 'id',			type: 'int'		},
																						{	name: 'version',	type: 'string'	},
																						{	name: 'model',		type: 'string'	},
																						{	name: 'md5',		type: 'string'	}
																					],
																	autoLoad: 		false,
																	remoteFilter:	true,
																	remoteSort:		false,
																	proxy: 			{
																						type:			'ajax',
																						url: 			'server/firmware.php',
																						extraParams:	{
																											cmd: 'getFirmwareList'
																										},
																						actionMethods:	{
																											create:		'POST',
																											read:		'POST',
																											update: 	'POST',
																											destroy:	'POST'
																										},
																						reader:			{	type:		'json'	}
																					}
												},
												dockedItems:	[
																	{
																		dock:	'top',
																		xtype:	'toolbar',
																		autoScroll: true,
																		items:	[
																					{
																						text:			'Add New',
																						id:				'firmware_addNew_button',
																						glyph:			'f067@FontAwesome',
																						handler:		function() {
																											new Ext.window.Window({
																												width:			400,
																												height:			150,
																												title:			'Add New Firmware',
																												id:				'firmware_window',
																												shadow:			true,
																												resizable:		false,
																												draggable:		true,
																												closable:		true,
																												autoShow:		true,
																												modal:			true,
																												items:			[
																																	{	
																																		xtype:		'form', 
																																		fileUpload: true,
																																		id:			'firmware_file_form',
																																		border:		false,
																																		items:		[
																																						{
																																							xtype:		'textfield',
																																							fieldLabel:	'Version',
																																							id:			'firmware_version',
																																							name:		'firmware_version',
																																							value:		'',
																																							editable:	false,
																																							allowBlank: false,
																																							width:		'90%',
																																							margin:		'20 0 5 20',
																																						},
																																						{
																																							xtype:		'filefield',
																																							fieldLabel:	'File',
																																							id:			'firmware_file',
																																							name:		'firmware_file',
																																							emptyText:	'Select firmware file',
																																							allowBlank: false,
																																							width:		'90%',
																																							margin:		'5 0 20 20',
																																							listeners:	{
																																											change:	function() {
																																														if (this.value.length > 0)
																																															if (this.value.match(/\.bin/) === null) {
																																																// clear field
																																																fileField	= document.getElementById('firmware_file');
																																																parentNod	= fileField.parentNode;
																																																tmpForm		= document.createElement("form");
																																																parentNod.replaceChild(tmpForm,fileField);
																																																tmpForm.appendChild(fileField);
																																																tmpForm.reset();
																																																parentNod.replaceChild(fileField,tmpForm);
																																																Ext.getCmp('firmware_version').setValue('');
																																																// show message
																																																Ext.MessageBox.show({
																																																	title:		'Firmware upload error!',
																																																	msg:		'File must have .bin extension',
																																																	buttons:	Ext.MessageBox.OK,
																																																});
																																															}
																																															else {
																																																if (this.value.match(/\d{1,2}\.\d{1,2}\.\d{1,2}\.RU\.\d{8}/) !== null)
																																																	Ext.getCmp('firmware_version').setValue(this.value.match(/\d{1,2}\.\d{1,2}\.\d{1,2}\.RU\.\d{8}/)[0]);
																																																else
																																																	Ext.getCmp('firmware_version').setValue('');
																																															}
																																													}
																																										}
																																						}
																																					]
																																	}
																																],
																													buttons:	[
																																	{	text:		'Upload',
																																		id:			'firmware_download',
																																		width:		100,
																																		handler:	function() {
																																						if (Ext.getCmp('firmware_file_form').isValid()) {
																																							var request	= {};
																																							request.cmd = 'uploadFirmware';
																																							Ext.getCmp('firmware_file_form').getForm().submit({ 
																																								url:		'server/firmware.php',
																																								params: 	{
																																												cmd: 'firmwareAdd'
																																											},
																																								waitMsg:	'Uploading firmware...',
																																								success:	function (form, action) { Ext.getCmp('firmware_window').close(); loadFirmwareList(); },
																																								failure:	function (form, action) { Ext.getCmp('firmware_window').close(); loadFirmwareList(); }
																																							});
																																						}
																																					}
																																	}
																																]

																											});
																										}
																					},
																					{
																						text:			'Delete',
																						id:				'firmware_delete_button',
																						glyph:			'f00d@FontAwesome',
																						disabled:		true,
																						handler:		function() {
																											var sel 	= Ext.getCmp('firmware_list_grid').getSelectionModel().getSelection()[0].data;
																											Ext.MessageBox.confirm('Delete', 'Are you sure to delete<br>Version: ' + sel.version + '<br>Model: ' + sel.model + '<br>?', 
																												function(btn){
																													if (btn === 'yes') {
																														var request	= {};
																														request.id	= sel.id;
																														request.cmd	= 'firmwareDel';
																														$.post('server/firmware.php', request, 
																															function(data) {
																																loadFirmwareList();
																															}
																														);
																													}
																											});
																										}
																					},
																					{ xtype: 'tbseparator' },
																					{
																						text:			'Server Settings',
																						id:				'firmware_settings_button',
																						glyph:			'f013@FontAwesome',
																						handler:		function() {
																											settingsFirmware();
																										}
																					}
																				]
																	}
																],
												viewConfig:		{
																	enableTextSelection:	true,
																	loadMask:				false,
																},
												selModel: 		{
																	type:		'rowmodel',
																	mode:		'SINGLE'
																},
												columns: 		[
																	{	xtype: 'rownumberer',	width: 30				},
																	{	text: 'Version',		dataIndex: 'version',	flex: 25 / 100	},
																	{	text: 'Model',			dataIndex: 'model',		flex: 30 / 100	}
																],
												listeners:		{
																	afterrender:		function () {
																							loadFirmwareList();
																						},
																	selectionChange:	function (view, selections, options) {
																							if (selections.length == 1)
																								Ext.getCmp('firmware_delete_button').enable();
																							else
																								Ext.getCmp('firmware_delete_button').disable();
																							Ext.getCmp('firmware_grid').getSelectionModel().deselectAll();
																						}
																}
											},
											{
												xtype:			'grid',
												title:			'Firmware change queue',
												id:				'firmware_queue_grid',
												height:			((center_panel_Height - 27) / 3) * 2 + 3,		// size - header
												scrollable:		true,
												border:			true,
												x:				-1,
												y:				-2,
												store:			{
																	fields:				[
																						{	name: 'id',			type: 'int'		},
																						{	name: 'timestamp',	type: 'string'	},
																						{	name: 'request',	type: 'string'	},
																						{	name: 'state',		type: 'string'	},
																						{	name: 'response',	type: 'string'	},
																						{	name: 'hostname',	type: 'string'	}
																					],
																	autoLoad: 		false,
																	remoteFilter:	true,
																	remoteSort:		false,
																	proxy: 			{
																						type:			'ajax',
																						url: 			'server/firmware.php',
																						extraParams:	{
																											cmd: 'getFirmwareQueue'
																										},
																						actionMethods:	{
																											create:		'POST',
																											read:		'POST',
																											update: 	'POST',
																											destroy:	'POST'
																										},
																						reader:			{	type:		'json'	}
																					}
												},
												dockedItems:	[
																	{
																		dock:	'top',
																		xtype:	'toolbar',
																		autoScroll: true,
																		items:	[
																					{
																						text:			'Info',
																						id:				'firmware_queue_info_button',
																						glyph:			'f129@FontAwesome',
																						disabled:		true,
																						handler:		function() {
																											var sel = Ext.getCmp('firmware_queue_grid').getSelectionModel().getSelection()[0].data;
																											Ext.MessageBox.show({
																												title:		'Request info',
																												msg:		'<b>Time:</b> ' + sel.timestamp + '<br><br>' +
																															'<b>Request:</b> ' + sel.request + '<br><br>' +
																															'<b>Response:</b> ' + sel.response + '<br><br>' +
																															'<b>Status:</b> ' + sel.state,
																												buttons:	Ext.MessageBox.OK,
																											});
																										}
																					},
																					{
																						text:			'Delete',
																						id:				'firmware_queue_delete_button',
																						glyph:			'f00d@FontAwesome',
																						disabled:		true,
																						handler:		function() {
																											Ext.MessageBox.confirm('Delete', 'Are you sure to delete?', 
																												function(btn){
																													if (btn === 'yes') {
																														var request = { id: Ext.getCmp('firmware_queue_grid').getSelectionModel().getSelection()[0].data.id };
																														$.post('server/del_requests.php', request)
																														.done(function() {
																															loadFirmwareAPlist();
																														})
																														.fail(function() {
																															Ext.MessageBox.show({
																																title:		'Delete request error!',
																																msg:		request.id + ' status: ajax fail',
																																buttons:	Ext.MessageBox.OK,
																															});
																														});	
																													}
																											});

																										}
																					},
																				]
																	}
																],
												viewConfig:		{
																	enableTextSelection:	true,
																	loadMask:				false,
																},
												selModel: 		{
																	type:		'rowmodel',
																	mode:		'SINGLE'
																},
												columns: 		[
																	{	text: 'Time',		dataIndex: 'timestamp',	flex: 40 / 100,
																		renderer: 	function (value, meta, record, rowIndex) {
																						if (record.data.state == 'error' || record.data.response.indexOf('FAIL') >= 0) meta.style = "background-color: #FFCCCC;";
																						if (record.data.state == 'pending') meta.style = "background-color: #FBFEC0;";
																						return value;
																					}
																	},
																	{	text: 'Hostname',	dataIndex: 'hostname',	flex: 45 / 100,
																		renderer: 	function (value, meta, record, rowIndex) {
																						if (record.data.state == 'error' || record.data.response.indexOf('FAIL') >= 0) meta.style = "background-color: #FFCCCC;";
																						if (record.data.state == 'pending') meta.style = "background-color: #FBFEC0;";
																						return value;
																					}
																	},
																	{	text: 'Status',		dataIndex: 'state',		flex: 15 / 100,
																		renderer: 	function (value, meta, record, rowIndex) {
																						if (record.data.state == 'error' || record.data.response.indexOf('FAIL') >= 0) {
																							meta.style = "background-color: #FFCCCC;";
																							return 'fail';
																						}
																						if (record.data.state == 'pending') meta.style = "background-color: #FBFEC0;";
																						return value;
																					}
																	}
																],
												listeners:		{
																	selectionChange:	function (view, selections, options) {
																							if (selections.length == 1) {
																								Ext.getCmp('firmware_queue_info_button').enable();
																								if (selections[0].data.state == 'pending')
																									Ext.getCmp('firmware_queue_delete_button').enable();
																							}
																							else { 
																								Ext.getCmp('firmware_queue_info_button').disable();
																								Ext.getCmp('firmware_queue_delete_button').disable();
																							}
																						}
																}
											}
										]
					},
					{
						xtype:			'grid',
						title:			'AP List',
						id:				'firmware_grid',
						height:			center_panel_Height - 27,		// size - header
						scrollable:		true,
						border:			false,
						columnWidth:	0.6,
						store:			{
											fields: 		[
																{	name: 'id',			type: 'int'		},
																{	name: 'hostname',	type: 'string'	},
																{	name: 'ip_mac',		type: 'string'	},
																{	name: 'model',		type: 'string'	},
																{	name: 'firmware',	type: 'string'	}
															],
											autoLoad: 		false,
											remoteFilter:	true,
											remoteSort:		false,
											proxy: 			{
																type:			'ajax',
																url: 			'server/firmware.php',
																extraParams:	{
																					cmd: 'getAPlist'
																				},
																actionMethods:	{
																					create:		'POST',
																					read:		'POST',
																					update: 	'POST',
																					destroy:	'POST'
																				},
																reader:			{	type:		'json'	}
															}
						},
						dockedItems:	[
											{
												dock:	'top',
												xtype:	'toolbar',
												autoScroll: true,
												items:	[
															// Filter text field
															{
																width:			100,
																xtype:			'textfield',
																id:				'firmware_filter_field',
																listeners: 		{
																					specialkey:	function(f, e) {
																									if(e.getKey() == e.ENTER){
																									Ext.getCmp('firmware_filter_button').click();
																								}
																				}
																}
															},
															// Filter button
															{
																text:			'',
																id:				'firmware_filter_button',
																glyph:			'f0b0@FontAwesome',
																handler:		function() {
																					Ext.getCmp('firmware_grid').store.filter({
																						property		: 'filter',
																						value			: Ext.getCmp('firmware_filter_field').getValue(),
																						anyMatch		: false,
																						caseSensitive	: false
																					});
																					loadFirmwareAPlist();
																				}
															},
															{
																text:			'',
																id:				'firmware_clear_button',
																glyph:			'f00d@FontAwesome',
																handler:		function() {
																					Ext.getCmp('firmware_filter_field').setValue('');
																					Ext.getCmp('firmware_filter_button').click();
																				}
															},
															{ xtype: 'tbseparator' },
															{
																text:			'Upload Firmware',
																id:				'firmware_upload_button',
																glyph:			'f2db@FontAwesome',
																disabled:		true,
																handler:		function() {
																					if (firmwares_server.length == 0)
																						Ext.toast('The server address is empty<br>You must install it before upload firmware ("Server settings")');
																					else
																						updateFirmware()
																				}
															}
														]
											}
										],
						viewConfig:		{
											enableTextSelection:	true,
											loadMask:				false,
										},
						selModel: 		{
											type:		'checkboxmodel',
											mode:		'MULTI'
										},
						columns: 		[
											{	xtype: 'rownumberer',	width: 30				},
											{	text: 'Hostname',		dataIndex: 'hostname',	flex: 25 / 100	},
											{	text: 'IP (MAC)',		dataIndex: 'ip_mac',	flex: 30 / 100	},
											{	text: 'Model',			dataIndex: 'model',		flex: 25 / 100	},
											{	text: 'Firmware',		dataIndex: 'firmware',	flex: 20 / 100	}
										],
						listeners:		{
											afterrender:		function () {
																	loadFirmwareAPlist();
																},
											selectionChange:	function (view, selections, options) {
																	if (selections.length > 0)
																		Ext.getCmp('firmware_upload_button').enable();
																	else
																		Ext.getCmp('firmware_upload_button').disable();
																},
											beforeselect: 		function(combo, record, index) {
																	var model = Ext.getCmp('firmware_list_grid').getSelectionModel().getSelection();
																	if (model.length == 1 && record.data.model.replace(/<span class="x-item-selected">/g, '').replace(/<\/span>/g, '') == model[0].data.model)
																		return true;
																	else 
																		return false;
																}
										}
					}
				]
});

function loadFirmwareAPlist() {
	Ext.getCmp('firmware_grid').store.load();
	Ext.getCmp('firmware_queue_grid').store.load();
	clearInterval(settings_interval);
	settings_interval = setTimeout('loadFirmwareAPlist();', refresh_timeout / 3);
}

function loadFirmwareList() {
	Ext.getCmp('firmware_list_grid').store.load();
}

function updateFirmware() {
	var firmware_timestamp = 'now';
	var firmware_id		= Ext.getCmp('firmware_list_grid').getSelectionModel().getSelection()[0].data.id;
	var firmware_md5	= Ext.getCmp('firmware_list_grid').getSelectionModel().getSelection()[0].data.md5;
	var firmware_aps	= [];
	var firmware_cmd	= 'echo "Restore FS..."; ' +
						  'fs restore && ' +
						  'echo "Reciving Firmware..."; ' +
						  'wget http://' + ((firmwares_login.length > 0) ? ((firmwares_pass.length > 0) ? (firmwares_login + ':' + firmwares_pass + '@') : firmwares_login + '@') : '') + firmwares_server + '/server/firmware.php?id=' + firmware_id + ' -O /tmp/firmware.bin -T 5; ' +
						  'if [ `echo $?` = 0 ]; then ' +
						  'echo "Checking MD5..."; ' +
						  'if [ `md5sum /tmp/firmware.bin | awk \' { print $1 } \'` = ' + firmware_md5 + ' ]; then ' +
						  'echo "Writing Firmware and rebooting device..."; ' +
						  'mtd_write -r write /tmp/firmware.bin Kernel_RootFS; ' +
						  'else echo FAIL; fi; ' +
						  'else echo FAIL; fi';

	new Ext.window.Window({
			width:			260,
			height:			160,
			title:			'Firmware update',
			id:				'shedule_window',
			shadow:			true,
			resizable:		false,
			draggable:		true,
			closable:		true,
			autoShow:		true,
			modal:			true,
			bodyPadding:	20,
			items:			[
								{
									fieldLabel:	'Date',
									labelWidth:	60,
									width:		160,
									xtype:		'datefield',
									id:			'shedule_date',
									name:		'shedule_date',
									format: 	'd-m-Y',
									editable: 	false,
									minValue:	new Date(),
									value: 		new Date()
								},
								{
									fieldLabel:	'Time',
									labelWidth:	60,
									width:		160,
									xtype:		'timefield',
									id:			'shedule_time',
									name:		'shedule_time',
									format: 	'H:i',
									editable: 	true,
									minValue:	new Date(),
									value: 		new Date()
								}
							],
			buttons:		[
								{ 
									text: 		'Shedule',
									handler:	function() {
													firmware_timestamp = new Date(new Date(Ext.getCmp('shedule_date').getValue()).getFullYear(),
																		 new Date(Ext.getCmp('shedule_date').getValue()).getMonth(),
																		 new Date(Ext.getCmp('shedule_date').getValue()).getDate(),
																		 new Date(Ext.getCmp('shedule_time').getValue()).getHours(),
																		 new Date(Ext.getCmp('shedule_time').getValue()).getMinutes(), 0).getTime() / 1000;
													Ext.getCmp('shedule_window').close();
													update();
												}
								},
								{ 
									text: 		'Update Now',
									handler:	function() {
													Ext.getCmp('shedule_window').close();
													update();
												}
								},
								{ 
									text: 		'Cancel',
									handler:	function() {
													Ext.getCmp('shedule_window').close();
												}
								}
							]
	});

	function update() {
		var sel	= Ext.getCmp('firmware_grid').getSelectionModel().getSelection();

		if (sel.length > 1)
			for (var i = 0; i < sel.length; i++)
				firmware_aps.push(sel[i].data.id);
		else
			firmware_aps = sel[0].data.id;

		request	= {};
		if (firmware_aps.length > 1)
			request.group = true;
		request.id = firmware_aps;

		if (firmware_timestamp != 'now')
			request.timestamp = firmware_timestamp;
		request.command	= firmware_cmd;

		if (firmware_timestamp == 'now')
			var msg_str = 'Please wait for a few minutes to update firmware';
		else 
			var msg_str = 'Firmware update sheduled to: ' + (new Date(firmware_timestamp * 1000).toLocaleString('ru-RU'));

		Ext.MessageBox.show({
			title:		'Firmware update',
			msg:		msg_str,
			buttons:	Ext.MessageBox.OK,
		});

		$.post('server/control_settings.php', request)
		.done(function(data) {
			try { var result = JSON.parse(data); }
			catch (e) { var result = JSON.parse(JSON.stringify(data)); }
			if (result.state != 'done') {
				Ext.MessageBox.show({
					title:		'Firmware updade error!',
					msg:		'Status: ' + result.state + '<br>Response: ' + result.response,
					buttons:	Ext.MessageBox.OK,
				});
			} 
		})
		.fail(function() {
			Ext.MessageBox.show({
				title:		'Firmware update error!',
				msg:		'Status: ajax fail',
				buttons:	Ext.MessageBox.OK,
			});
		});
		loadFirmwareAPlist();
	}
}

function settingsFirmware() {
	new Ext.window.Window({
			width:			500,
			height:			190,
			title:			'Firmware Server Settings',
			id:				'settings_window',
			shadow:			true,
			resizable:		false,
			draggable:		true,
			closable:		true,
			autoShow:		true,
			modal:			true,
			items:			[
								{
									xtype:		'form',
									id:			'firmwares_settings_form',
									border:		false,
									items:		[
													{
														fieldLabel:	'Server',
														width:		'90%',
														xtype:		'textfield',
														id:			'firmwares_server',
														name:		'firmwares_server',
														margin:		'20, 20, 10, 20',
														value:		firmwares_server,
														allowBlank:	false
													},
													{
														fieldLabel:	'Login',
														width:		'90%',
														xtype:		'textfield',
														id:			'firmwares_login',
														name:		'firmwares_login',
														margin:		'10, 20, 10, 20',
														value:		firmwares_login,
														allowBlank:	true
													},
													{
														fieldLabel:	'Password',
														width:		'90%',
														xtype:		'textfield',
														inputType:	'password',
														id:			'firmwares_pass',
														name:		'firmwares_login',
														margin:		'10, 20, 20, 20',
														value:		firmwares_pass,
														allowBlank:	true
													}
												]
								}
							],
			buttons:		[
								{ 
									text: 		'Save',
									formBind:	true,
									handler:	function() {
													if (Ext.getCmp('firmwares_settings_form').isValid()) {
														if (Ext.getCmp('firmwares_login').value.length == 0 && Ext.getCmp('firmwares_pass').value.length > 0) {
															Ext.toast('You must enter Login or delete Password');
															Ext.getCmp('firmwares_login').focus();
															return;
														}
														var request		= {};
														request.server	= Ext.getCmp('firmwares_server').value;
														request.login	= Ext.getCmp('firmwares_login').value;
														request.pass	= Ext.getCmp('firmwares_pass').value;
														request.cmd		= 'setSettings';
														$.post('server/firmware.php', request,
															function(data) {
																try { var result = JSON.parse(data); }
																catch (e) { var result = JSON.parse(JSON.stringify(data)); }
																if (result.status == 'done') {
																	firmwares_server	= request.server;
																	firmwares_login		= request.login;
																	firmwares_pass		= request.pass;
																}
															}
														);
														Ext.getCmp('settings_window').close();
													}
												}
								},
								{ 
									text: 		'Cancel',
									handler:	function() {
													Ext.getCmp('settings_window').close();
												}
								}
							]
	});
}