var grid_AP_panel = Ext.create('Ext.grid.Panel', {
	height:				center_panel_Height,
	scrollable:			true,
	store:				{
							autoLoad: 		false,
							remoteFilter:	true,
							remoteSort:		true,
							fields: 		[
												{	name: 'host_name',		type: 'string'	},
												{	name: 'host_ipmac',		type: 'string'	},
												{	name: 'host_model',		type: 'string'	},
												{	name: 'wifi_channel24',	type: 'string'	},
												{	name: 'wifi_channel5',	type: 'string'	},
												{	name: 'wifi_clients24',	type: 'int'		},
												{	name: 'wifi_clients5',	type: 'int'		},
												{	name: 'host_status',	type: 'string'	},
												{	name: 'wifi_rxtx',		type: 'string'	},
												{	name: 'state',			type: 'string'	},
												{	name: 'down',			type: 'int'		},
												{	name: 'sqlid',			type: 'int'		}
											],
							proxy: 			{
												type:			'ajax',
												url:			'server/get_ap.php',
												actionMethods:	{
																	create:		'POST',
																	read:		'POST',
																	update:		'POST',
																	destroy:	'POST'
																},
												reader:			{	type:		'json'	}
											}
						},
	selectedRecords: 	[],
	dockedItems:		[
							{
								dock:	'top',
								xtype:	'toolbar',
								items:	[
											// Filter text field
											{
												width:			100,
												xtype:			'textfield',
												id:				'filter_field',
												listeners: 		{
																	specialkey:	function(f, e) {
																					if(e.getKey() == e.ENTER){
																					Ext.getCmp('filter_button').click();
																				}
																}
												}
											},
											// Filter button
											{
												text:			'Filter',
												id:				'filter_button',
												glyph:			'f0b0@FontAwesome',
												handler:		function() {
																	grid_AP_panel.store.filter({
																		property		: 'filter',
																		value			: Ext.getCmp('filter_field').getValue(),
																		anyMatch		: false,
																		caseSensitive	: false
																	});
																	clearTimeout(ap_interval);
																	loadAPgridDATA();
																}
											},
											{
												text:			'Clear',
												id:				'clear_button',
												glyph:			'f00d@FontAwesome',
												handler:		function() {
																	Ext.getCmp('filter_field').setValue('');
																	Ext.getCmp('filter_button').click();
																}
											},

											{ xtype: 'tbseparator' },
											// Info button
											{
												text:			'Info',
												id:				'info_button',
												glyph:			'f05a@FontAwesome',
												disabled:		true,
												handler:		function() {
																	var sel = grid_AP_panel.getSelectionModel().getSelection();
																	showAPinfo(sel[0].data.host_name.replace(/<span class="x-item-selected">/g, '').replace(/<\/span>/g, '') + ' / ' + sel[0].data.host_ipmac.replace(/<span class="x-item-selected">/g, '').replace(/<\/span>/g, ''), sel[0].data.sqlid);
																}
											},
											// Plot button
											{
												text:			'Plot',
												id:				'plot_button',
												glyph:			'f1fe@FontAwesome',
												disabled:		true,
												handler:		function() {
																	show_AP_plot();
																}
											},
											{ xtype: 'tbseparator' },
											// Hide down AP button
											{
												text:			'Hide down AP',
												id:				'hide_down_ap_button',
												pressed:		($.cookie("hide_down_ap") == '1') ? true : false,
												enableToggle:	true,
												handler:		function() {
																	$.cookie("hide_down_ap", (Ext.getCmp('hide_down_ap_button').pressed === true) ? '1' : '0');
																	grid_AP_panel.store.filter({
																		property		: 'hide_down_ap',
																		value			: this.pressed,
																		anyMatch		: false,
																		caseSensitive	: false
																	});
																}
											}
										],
							}
						],
			viewConfig: {
							preserveScrollOnReload:	true,
							enableTextSelection:	true,
							loadMask:				false,
						},
			selModel: 	{
							type:		'checkboxmodel',
							checkOnly:	false
						},
			columns: 	[
							{	text: 'Hostname',			dataIndex: 'host_name',		flex: 15 / 100, minWidth: 110,
								renderer: 	function (value, meta, record, rowIndex) {
												if (record.data.state == 'down') meta.style = "background-color: #FFCCCC;";
												if (record.data.state == 'lost') meta.style = "background-color: #FBFEC0;";
												return value;
											},
							},
							{	text: 'IP (MAC)',			dataIndex: 'host_ipmac', 	flex: 15 / 100,	minWidth: 180,
								renderer: 	function (value, meta, record, rowIndex) {
												if (record.data.state == 'down') meta.style = "background-color: #FFCCCC;";
												if (record.data.state == 'lost') meta.style = "background-color: #FBFEC0;";
												return value;
											},
							},
							{	text: 'Model (FW)',			dataIndex: 'host_model',	flex: 20 / 100,	minWidth: 200,
								renderer: 	function (value, meta, record, rowIndex) {
												if (record.data.state == 'down') meta.style = "background-color: #FFCCCC;";
												if (record.data.state == 'lost') meta.style = "background-color: #FBFEC0;";
												return value;
											}
							},
							{	text: 'Wireless 2.4GHz',	minWidth: 110,		flex: 12 / 100,
								columns:	[
												{	text: 'Clients',	dataIndex: 'wifi_clients24',	minWidth: 50,	flex: 6 / 100,	align: 'center',
													renderer: 	function (value, meta, record, rowIndex) {
																	if (record.data.state == 'down') meta.style = "background-color: #FFCCCC;";
																	if (record.data.state == 'lost') meta.style = "background-color: #FBFEC0;";
																	return value;
																},
												},
												{	text: 'Channel',	dataIndex: 'wifi_channel24',	minWidth: 60,	flex: 6 / 100,	align: 'center',
													renderer: 	function (value, meta, record, rowIndex) {
																	if (record.data.state == 'down') meta.style = "background-color: #FFCCCC;";
																	if (record.data.state == 'lost') meta.style = "background-color: #FBFEC0;";
																	return value;
																},
												}
											]
							},
							{	text: 'Wireless 5GHz',		minWidth: 110,		flex: 12 / 100,
								columns:	[
												{	text: 'Clients',	dataIndex: 'wifi_clients5',		minWidth: 50, 	flex: 6 / 100,	align: 'center',
													renderer: 	function (value, meta, record, rowIndex) {
																	if (record.data.state == 'down') meta.style = "background-color: #FFCCCC;";
																	if (record.data.state == 'lost') meta.style = "background-color: #FBFEC0;";
																	return value;
																},
												},
												{	text: 'Channel',	dataIndex: 'wifi_channel5',		minWidth: 60,	flex: 6 / 100,	align: 'center',
													renderer: 	function (value, meta, record, rowIndex) {
																	if (record.data.state == 'down') meta.style = "background-color: #FFCCCC;";
																	if (record.data.state == 'lost') meta.style = "background-color: #FBFEC0;";
																	return value;
																},
												}
											]
							},
							{	text: 'Summary<br>RX/TX',	dataIndex: 'wifi_rxtx',		flex: 15 / 100,	minWidth: 100,	align: 'center',
								renderer: 	function (value, meta, record, rowIndex) {
												if (record.data.state == 'down') meta.style = "background-color: #FFCCCC;";
												if (record.data.state == 'lost') meta.style = "background-color: #FBFEC0;";
												return value;
											},
							},
							{	text: 'Status',				dataIndex: 'host_status',	flex: 15 / 100,	minWidth: 130,	align: 'center',
								renderer: 	function (value, meta, record, rowIndex) {
												if (record.data.state == 'down') meta.style = "background-color: #FFCCCC;";
												if (record.data.state == 'lost') meta.style = "background-color: #FBFEC0;";
												return value;
											}
							}
						],
			bbar:		{
							style: 'background-color: #d7efcd;',
							items: 	[
										{
											width:	'100%',
											xtype:	'label',
											id:		'summary_ap',
										}
									]
						},
			listeners:	{
							afterrender:		function () {
													if ($.cookie("hide_down_ap") == '1')
														grid_AP_panel.store.filter({
															property		: 'hide_down_ap',
															value			: true,
															anyMatch		: false,
															caseSensitive	: false
														});
													loadAPgridDATA();
												},
							itemdblclick:		function(dv, record, item, index, e) {
													if (record.data.state == 'up')
														Ext.getCmp('info_button').click();
												},
							selectionChange:	function (view, selections, options) {
													if (selections.length == 1 && selections[0].data.state == 'up') {
														Ext.getCmp('info_button').enable();
													}
													else 
														Ext.getCmp('info_button').disable();

													if (selections.length > 0)
														if (selections.length == 1 && grid_AP_panel.getSelectionModel().getSelection()[0].data.state != 'up')
															Ext.getCmp('plot_button').disable();
														else
															Ext.getCmp('plot_button').enable();
													else
														Ext.getCmp('plot_button').disable();
												},
			}
});

function loadAPgridDATA() {
	// Save selected items before reload data
	var selection	= grid_AP_panel.getSelectionModel().getSelection();
	
	var i;
	var ap_total		= 0;
	var ap_down			= 0;
	var clients_total	= 0;
	var clients_on_ap	= 0;
	var clients_24		= 0;
	var clients_5		= 0;
	
	grid_AP_panel.store.load({
		callback:	function(records, operation, success) {
						if (success) {
							// Calculate summary 
							if (records.length > 0) {
								ap_total	= records.length;
								ap_down		= records[0].data.down;
								for (i = 0; i < records.length; i++) {
									clients_total 	+= records[i].data.wifi_clients24 + records[i].data.wifi_clients5;
									clients_24		+= records[i].data.wifi_clients24;
									clients_5		+= records[i].data.wifi_clients5;
								}
							}
							else {
								ap_total		= 0;
								ap_down			= 0;
								clients_total	= 0;
								clients_24		= 0;
								clients_5		= 0;
							}
							clients_on_ap = (clients_total > 0) ? (clients_total / records.length).toFixed(0) : 0;
							Ext.getCmp('summary_ap').setHtml('<div>' +
									'	<div style="width: 80px; float: left">Total AP:</div><div style="float: left;">' + ap_total + ' (Down: ' + ap_down + ')</div><br clear="all">' +
									'	<div style="width: 80px; float: left">Total Clients:</div><div style="float: left;">' + clients_total + ' (2.4GHz: ' + clients_24 + ' / 5GHz: ' + clients_5 + '), average on AP: ' + clients_on_ap + '</div>' +
									'</div>');

							// Restore selected items
							for (i = 0; i < selection.length; i++) {
								var item = grid_AP_panel.store.find('host_ipmac', selection[i].data.host_ipmac);
								grid_AP_panel.getSelectionModel().select(item, true); 
							}
						}
					}
	});
	ap_interval = setTimeout('loadAPgridDATA();', refresh_timeout);
}