function showClientsInfo(mac) {
	var interval;
	var width	= (window.innerWidth >= 700) ? 700 : window.innerWidth;
	var height	= (window.innerHeight >= 424) ? 424 : window.innerHeight;
	
	new Ext.window.Window({
		width:			width,
		height:			height,
		title:			'Client ' + mac + ' info',
		id:				'info_client_window',
		shadow:			true,
		resizable:		false,
		draggable:		true,
		closable:		true,
		autoShow:		true,
		modal:			true,
		items:			[
							{
								xtype:		'grid',
								id:			'info_client_grid',
								height:		height - 65,
								scrollable:	true,
								border:		false,
								store:		{
												fields: 		[
																	{	name: 'name',		type: 'string'	},
																	{	name: 'value',		type: 'string'	}
																],
												proxy: 			{
																	type:			'ajax',
																	actionMethods:	{
																						create:		'POST',
																						read:		'POST',
																						update:		'POST',
																						destroy:	'POST'
																					},
																	reader:			{ type:	'json' }
																}
											},
								viewConfig:	{
												preserveScrollOnReload:	true,
												enableTextSelection:	true,
												loadMask:				false
											},
								columns: 	[	
												{	dataIndex: 'name',		align: 'right',	tdCls: 'value-column', flex: 40 / 100	}, 
												{	dataIndex: 'value',		flex: 60 / 100											}
											],
								listeners:	{
												'afterrender':	function() {
																	loadDATA();
																}
											}
							}
						],
		buttons:		[
							{
								text:		'Close',
								handler:	function() { Ext.getCmp('info_client_window').close(); }
							}
						],						
		listeners:		{
							'close':	function() { clearInterval(interval); }
						}
	});
	
	function loadDATA() {
		Ext.getCmp('info_client_grid').store.load({
													url: 		'server/get_clients_info.php',
													params: { 
																'mac': mac
															}
												});
		interval = setTimeout(loadDATA, refresh_timeout);
	}
}