var log_tabpanel = new Ext.Panel({
	height:		center_panel_Height - 27,
	layout:		'column',
	border:		false,
	items:		[
					{
						xtype:			'grid',
						id:				'log_grid',
						height:			center_panel_Height - 27,		// size - header
						scrollable:		true,
						border:			false,
						columnWidth:		0.5,
						x:			-1,
						y:			-1,
						store:			{
											fields: 		[
																{	name: 'id',			type: 'int'		},
																{	name: 'client_id',	type: 'int'		},
																{	name: 'hostname',	type: 'string'	},
																{	name: 'state',		type: 'string'	},
																{	name: 'timestamp',	type: 'string'	},
																{	name: 'request',	type: 'string'	},
																{	name: 'response',	type: 'string'	}
															],
											autoLoad: 		false,
											remoteFilter:	true,
											remoteSort:		false,
											proxy: 			{
																type:			'ajax',
																url: 			'server/get_requests.php',
																actionMethods:	{
																					create:		'POST',
																					read:		'POST',
																					update: 	'POST',
																					destroy:	'POST'
																				},
																reader:			{	type:		'json'	}
															}
						},
						dockedItems:	[
											{
												dock:	'top',
												xtype:	'toolbar',
												autoScroll: true,
												items:	[
															// Filter text field
															{
																width:			100,
																xtype:			'textfield',
																id:				'log_filter_field',
																listeners: 		{
																					specialkey:	function(f, e) {
																									if(e.getKey() == e.ENTER){
																									Ext.getCmp('log_filter_button').click();
																								}
																				}
																}
															},
															// Filter button
															{
																text:			'',
																id:				'log_filter_button',
																glyph:			'f0b0@FontAwesome',
																handler:		function() {
																					Ext.getCmp('log_grid').store.filter({
																						property		: 'filter',
																						value			: Ext.getCmp('log_filter_field').getValue(),
																						anyMatch		: false,
																						caseSensitive	: false
																					});
																					loadLogDATA();
																				}
															},
															{
																text:			'',
																id:				'log_clear_button',
																glyph:			'f00d@FontAwesome',
																handler:		function() {
																					Ext.getCmp('log_filter_field').setValue('');
																					Ext.getCmp('log_filter_button').click();
																				}
															},
															{ 
																xtype:			'tbseparator'
															},
															{	
																xtype:			'datefield',
																id:				'logStartDate',
																name:			'logStartDate',
																format: 		'd-m-Y',
																margin: 		'0 5 0 0',
																width:			90,
																editable:		false,
																maxValue:		new Date(),
																listeners:		{
																					afterrender:	function() {
																										var date = new Date();
																										date.setDate(date.getDate() - 7);
																										this.setValue(date);
																									},
																					change:			function() {
																										Ext.getCmp('logEndDate').setMinValue(new Date(Ext.getCmp('logStartDate').value));
																									}
																}
															},
															{
																xtype:			'displayfield',
																margin:			'0 5 0 0',
																value:			'-'
															},
															{
																xtype:			'datefield',
																id:				'logEndDate',
																name:			'logEndDate',
																format: 		'd-m-Y',
																margin:			'0 5 0 0',
																width:			90,
																editable:		false,
																value:			new Date(),
																listeners:		{
																					change:		function() {
																									Ext.getCmp('logStartDate').setMaxValue(new Date(Ext.getCmp('logEndDate').value));
																								}
																}
															},
															{
																text:			'Show/Refresh',
																id:				'log_show_button',
																glyph:			'f06e@FontAwesome',
																handler:		function() {
																					loadLogDATA();
																				}
															},
														],
											}
										],
						viewConfig:		{
											preserveScrollOnReload:	true,
											enableTextSelection:	true,
											loadMask:				false,
										},
						columns: 		[
											{	xtype: 'rownumberer', width: 30,	},
											{	text: 'Request time',	dataIndex: 'timestamp',	flex: 1/3,
												renderer: 	function (value, meta, record, rowIndex) {
																if (record.data.state == 'error') meta.style = "background-color: #FFCCCC;";
																if (record.data.state == 'pending') meta.style = "background-color: #FBFEC0;";
																return value;
															}
											},
											{	text: 'Hostname',		dataIndex: 'hostname',	flex: 2/5,
												renderer: 	function (value, meta, record, rowIndex) {
																if (record.data.state == 'error') meta.style = "background-color: #FFCCCC;";
																if (record.data.state == 'pending') meta.style = "background-color: #FBFEC0;";
																return value;
															}
											},
											{	text: 'State',			dataIndex: 'state',		flex: 1/5, 
												renderer: 	function (value, meta, record, rowIndex) {
																if (record.data.state == 'error') meta.style = "background-color: #FFCCCC;";
																if (record.data.state == 'pending') meta.style = "background-color: #FBFEC0;";
																return value;
															}
											}, 
										],
						listeners:		{
											afterrender:		function () {
																	loadLogDATA();
																},
											selectionChange:	function (view, selections, options) {
																	if (selections.length > 0) {
																		Ext.getCmp('log_panel_time').setValue(selections[0].data.timestamp.replace(/<span class="x-item-selected">/g, '').replace(/<\/span>/g, ''));
																		Ext.getCmp('log_panel_hostname').setValue(selections[0].data.hostname.replace(/<span class="x-item-selected">/g, '').replace(/<\/span>/g, ''));
																		Ext.getCmp('log_panel_request').setValue(selections[0].data.request.replace(/<span class="x-item-selected">/g, '').replace(/<\/span>/g, ''));
																		Ext.getCmp('log_panel_response').setValue(selections[0].data.response.replace(/<span class="x-item-selected">/g, '').replace(/<\/span>/g, ''));
																		Ext.getCmp('log_panel_state').setValue(selections[0].data.state.replace(/<span class="x-item-selected">/g, '').replace(/<\/span>/g, ''));
																		if (selections[0].data.state == 'pending') 
																			Ext.getCmp('log_panel_delete').enable();
																		else 
																			Ext.getCmp('log_panel_delete').disable();
																	}
																	else 
																		Ext.getCmp('log_panel_delete').disable();
																}
										}
					},
					{
						xtype:			'panel',
						title:			'Request info',
						id:				'log_panel',
						height:			center_panel_Height - 32,		// size - header
						scrollable:		false,
						border:			false,
						columnWidth:	0.5,
						bodyPadding:	20,
						items:			[
											{
												xtype:			'textfield',
												id:				'log_panel_time',
												fieldLabel:		'Request Time',
												value:			'',
												editable:		false,
												width:			'100%'
											},
											{
												xtype:			'textfield',
												id:				'log_panel_hostname',
												fieldLabel:		'Hostname',
												value:			'',
												editable:		false,
												width:			'100%'
											},
											{
												xtype:			'textareafield',
												id:				'log_panel_request',
												fieldLabel:		'Request',
												value:			'',
												editable:		false,
												width:			'100%',
												height:			'30%'
											},
											{
												xtype:			'textareafield',
												id:				'log_panel_response',
												fieldLabel:		'Response',
												value:			'',
												editable:		false,
												width:			'100%',
												height:			'30%'
											},
											{
												xtype:			'textfield',
												id:				'log_panel_state',
												fieldLabel:		'State',
												value:			'',
												editable:		false,
												width:			'100%'
											},
										],
						buttons:		[
											{ 
												text: 		'Delete',
												id:			'log_panel_delete',
												handler:	function() {
																var request = {};
																request.id = Ext.getCmp('log_grid').getSelectionModel().getSelection()[0].data.id
																$.post('server/del_requests.php', request)
																.done(function() {
																	loadLogDATA();
																})
																.fail(function() {
																	Ext.MessageBox.show({
																		title:		'Delete request error!',
																		msg:		request.id + ' status: ajax fail',
																		buttons:	Ext.MessageBox.OK,
																	});
																});	
															}
											},
										]
					}
					
				]
});

function loadLogDATA() {
	var selection	= Ext.getCmp('log_grid').getSelectionModel().getSelection();

	Ext.getCmp('log_grid').store.load({
		params:		{
						startDate:	new Date(	new Date(Ext.getCmp('logStartDate').getValue()).getFullYear(),
												new Date(Ext.getCmp('logStartDate').getValue()).getMonth(),
												new Date(Ext.getCmp('logStartDate').getValue()).getDate(),
												0, 0, 0).getTime() / 1000,
												
						endDate:	new Date(	new Date(Ext.getCmp('logEndDate').getValue()).getFullYear(),
												new Date(Ext.getCmp('logEndDate').getValue()).getMonth(),
												new Date(Ext.getCmp('logEndDate').getValue()).getDate(),
												23, 59, 59).getTime() / 1000,
					},
		callback:	function(records, operation, success) {
						if (success) {
							if (Ext.getCmp('log_grid').getSelectionModel().getSelection().length == 0)
								Ext.getCmp('log_grid').getSelectionModel().select(0, true);
							else 
								for (i = 0; i < Ext.getCmp('log_grid').store.data.items.length; i++)
									if (Ext.getCmp('log_grid').store.data.items[i].data.hostname == selection[0].data.hostname && Ext.getCmp('log_grid').store.data.items[i].data.timestamp == selection[0].data.timestamp)
										Ext.getCmp('log_grid').getSelectionModel().select(Ext.getCmp('log_grid').store.data.items[i], true);

							selections = Ext.getCmp('log_grid').getSelectionModel().getSelection();
							if (selections.length > 0) {
								Ext.getCmp('log_panel_time').setValue(selections[0].data.timestamp.replace(/<span class="x-item-selected">/g, '').replace(/<\/span>/g, ''));
								Ext.getCmp('log_panel_hostname').setValue(selections[0].data.hostname.replace(/<span class="x-item-selected">/g, '').replace(/<\/span>/g, ''));
								Ext.getCmp('log_panel_request').setValue(selections[0].data.request.replace(/<span class="x-item-selected">/g, '').replace(/<\/span>/g, ''));
								Ext.getCmp('log_panel_response').setValue(selections[0].data.response.replace(/<span class="x-item-selected">/g, '').replace(/<\/span>/g, ''));
								Ext.getCmp('log_panel_state').setValue(selections[0].data.state.replace(/<span class="x-item-selected">/g, '').replace(/<\/span>/g, ''));
								if (selections[0].data.state == 'pending') 
									Ext.getCmp('log_panel_delete').enable();
								else
									Ext.getCmp('log_panel_delete').disable();
							}
							else
								Ext.getCmp('log_panel_delete').disable();
						}
					}
	});
	clearInterval(settings_interval);
	settings_interval = setTimeout('loadLogDATA();', refresh_timeout);
}