var reboot_tabpanel = new Ext.Panel({
	height:		center_panel_Height - 27,
	layout:		'column',
	border:		false,
	items:		[
					{
						xtype:			'grid',
						title:			'AP List',
						id:				'reboot_grid',
						height:			center_panel_Height - 27,		// size - header
						scrollable:		true,
						border:			false,
						columnWidth:	0.5,
						store:			{
											fields: 		[
																{	name: 'id',			type: 'int'		},
																{	name: 'hostname',	type: 'string'	},
																{	name: 'ip_mac',		type: 'string'	},
																{	name: 'model',		type: 'string'	},
																{	name: 'firmware',	type: 'string'	}
															],
											autoLoad: 		false,
											remoteFilter:	true,
											remoteSort:		false,
											proxy: 			{
																type:			'ajax',
																url: 			'server/firmware.php',
																extraParams:	{
																					cmd: 'getAPlist'
																				},
																actionMethods:	{
																					create:		'POST',
																					read:		'POST',
																					update: 	'POST',
																					destroy:	'POST'
																				},
																reader:			{	type:		'json'	}
															}
						},
						dockedItems:	[
											{
												dock:	'top',
												xtype:	'toolbar',
												autoScroll: true,
												items:	[
															// Filter text field
															{
																width:			100,
																xtype:			'textfield',
																id:				'reboot_filter_field',
																listeners: 		{
																					specialkey:	function(f, e) {
																									if(e.getKey() == e.ENTER){
																									Ext.getCmp('reboot_filter_button').click();
																								}
																				}
																}
															},
															// Filter button
															{
																text:			'',
																id:				'reboot_filter_button',
																glyph:			'f0b0@FontAwesome',
																handler:		function() {
																					Ext.getCmp('reboot_grid').store.filter({
																						property		: 'filter',
																						value			: Ext.getCmp('reboot_filter_field').getValue(),
																						anyMatch		: false,
																						caseSensitive	: false
																					});
																					loadRebootAPlist();
																				}
															},
															{
																text:			'',
																id:				'reboot_clear_button',
																glyph:			'f00d@FontAwesome',
																handler:		function() {
																					Ext.getCmp('reboot_filter_field').setValue('');
																					Ext.getCmp('reboot_filter_button').click();
																				}
															},
															{ xtype: 'tbseparator' },
															{	
																xtype:			'datefield',
																id:				'rebootStartDate',
																name:			'rebootStartDate',
																format: 		'd-m-Y',
																margin: 		'0 5 0 0',
																width:			90,
																editable:		false,
																maxValue:		new Date(),
																listeners:		{
																					afterrender:	function() {
																										var date = new Date();
																										date.setDate(date.getDate() - 30);
																										this.setValue(date);
																									},
																					change:			function() {
																										Ext.getCmp('rebootEndDate').setMinValue(new Date(Ext.getCmp('rebootStartDate').value));
																									}
																}
															},
															{
																xtype:			'displayfield',
																margin:			'0 5 0 0',
																value:			'-'
															},
															{
																xtype:			'datefield',
																id:				'rebootEndDate',
																name:			'rebootEndDate',
																format: 		'd-m-Y',
																margin:			'0 5 0 0',
																width:			90,
																editable:		false,
																value:			new Date(),
																listeners:		{
																					change:		function() {
																									Ext.getCmp('rebootStartDate').setMaxValue(new Date(Ext.getCmp('rebootEndDate').value));
																								}
																}
															},
															{
																text:			'Show',
																id:				'reboot_show_button',
																glyph:			'f06e@FontAwesome',
																disabled:		true,
																handler:		function() {
																					loadRebootLogList();
																				}
															}
														]
											}
										],
						viewConfig:		{
											enableTextSelection:	true,
											loadMask:				false,
										},
						selModel: 		{
											type:		'checkboxmodel',
											mode:		'MULTI'
										},
						columns: 		[
											{	xtype: 'rownumberer',	width: 30				},
											{	text: 'Hostname',		dataIndex: 'hostname',	flex: 25 / 100	},
											{	text: 'IP (MAC)',		dataIndex: 'ip_mac',	flex: 30 / 100	},
											{	text: 'Firmware',		dataIndex: 'firmware',	flex: 20 / 100	}
										],
						listeners:		{
											afterrender:		function () {
																	loadRebootAPlist();
																},
											selectionChange:	function (view, selections, options) {
																	if (selections.length > 0)
																		Ext.getCmp('reboot_show_button').enable();
																	else
																		Ext.getCmp('reboot_show_button').disable();
																}
										}
					},
					{
						xtype:			'grid',
						title:			'Reboot Log',
						id:				'reboot_log_grid',
						height:			center_panel_Height - 27,		// size - header
						scrollable:		true,
						border:			true,
						columnWidth:	0.5,
						y:				-1,
						store:			{
											fields: 		[
																{	name: 'id',					type: 'int'		},
																{	name: 'hostname',			type: 'string'	},
																{	name: 'ip_mac',				type: 'string'	},
																{	name: 'timestamp',			type: 'string'	},
																{	name: 'reason',				type: 'string'	},
																{	name: 'fw_version',			type: 'string'	},
																{	name: 'fw_prev_version',	type: 'string'	},
																{	name: 'request',			type: 'string'	},
																{	name: 'response',			type: 'string'	}
															],
											autoLoad: 		true,
											remoteFilter:	true,
											remoteSort:		false,
											proxy: 			{
																type:			'ajax',
																url: 			'server/reboot_log.php',
																actionMethods:	{
																					create:		'POST',
																					read:		'POST',
																					update: 	'POST',
																					destroy:	'POST'
																				},
																reader:			{	type:		'json'	}
															}
						},
						viewConfig:		{
											enableTextSelection:	true,
											loadMask:				false,
											getRowClass:			function (record, rowIndex, rowParams, store) {
																		if (record.data.reason == 'Unknown')
																			return 'hide-row-expander';
																	}
										},
						columns: 		[
											{	text: 'Time',		dataIndex: 'timestamp',	flex: 25 / 100	},
											{	text: 'Hostname',	dataIndex: 'hostname',	flex: 25 / 100	},
											{	text: 'IP (MAC)',	dataIndex: 'ip_mac',	flex: 25 / 100	},
											{	text: 'Reason',		dataIndex: 'reason',	flex: 25 / 100	}
										],
						plugins: 		[
											{
												ptype:		'rowexpander',
												rowBodyTpl:	new Ext.XTemplate(
																'<tpl if="reason == \'Firmware change\'">',
																	'<div style="width: 120px; float: left;"><b>Previous Firmware:</b></div><div style="float: left;">{fw_prev_version}</div><br>',
																	'<div style="width: 120px; float: left;"><b>New Firmware:</b></div><div style="float: left;">{fw_version}</div><br>',
																'</tpl>',
																'<tpl if="reason == \'From Request\'">',
																	'<div style="width: 120px; float: left;"><b>Request:</b></div><div style="float: left;">{request}</div><br>',
																	'<div style="width: 120px; float: left;"><b>Response:</b></div><div style="float: left;">{response}</div><br>',
																'</tpl>',
																{
																	formatChange: function(v){ return v; }
																}
															)
											}
										]
					}
				]
});

function loadRebootAPlist() {
	Ext.getCmp('reboot_grid').store.load();
	clearInterval(settings_interval);
	settings_interval = setTimeout('loadRebootAPlist();', refresh_timeout);
}

function loadRebootLogList() {
	var sel		= Ext.getCmp('reboot_grid').getSelectionModel().getSelection();
	var ids		= [];
	var group	= false;

	for (var i = 0; i < sel.length; i++)
		ids.push(sel[i].id);

	if (ids.length > 1)
		group = true;
	
	Ext.getCmp('reboot_log_grid').store.load({
		params:		{
						id:			[ ids ],
						startDate:	new Date(	new Date(Ext.getCmp('rebootStartDate').getValue()).getFullYear(),
												new Date(Ext.getCmp('rebootStartDate').getValue()).getMonth(),
												new Date(Ext.getCmp('rebootStartDate').getValue()).getDate(),
												0, 0, 0).getTime() / 1000,
												
						endDate:	new Date(	new Date(Ext.getCmp('rebootEndDate').getValue()).getFullYear(),
												new Date(Ext.getCmp('rebootEndDate').getValue()).getMonth(),
												new Date(Ext.getCmp('rebootEndDate').getValue()).getDate(),
												23, 59, 59).getTime() / 1000,
					}
	});
}