var room_active_tab 	= null;			// Active tab id
var room_map_lock		= true;			// Lock map draggable
var room_map_redraw;					// Map redraw timer
var room_map_drawing	= false;		// Map draw status;

paper.install(window);

var map_AP_panel = new Ext.tab.Panel({
	height:				center_panel_Height,
	border:				false,
	dockedItems:	[
						{
							dock:	'top',
							xtype:	'toolbar',
							items:	[
										// Add New button
										{
											text:			'Add New',
											id:				'mapAPlist_addNew_button',
											glyph:			'f067@FontAwesome',
											handler:		showMapAddDialog
										},
										// Edit button
										{
											text:			'Edit',
											id:				'mapAPlist_Edit_button',
											glyph:			'f040@FontAwesome',
											disabled:		false,
											handler:		showMapEditDialog
										},
										// Delete button
										{
											text:			'Delete',
											id:				'mapAPlist_Delete_button',
											glyph:			'f00d@FontAwesome',
											disabled:		false,
											handler:		showMapDeleteDialog
										}
									]
						}
					],
	listeners:		{
						afterrender:	function() {
											$.post('server/maproom.php', { action: 'get' },	
												function (SQL) {
														if (SQL.room_rooms.length == 0)
															return;

														for (var i = 0; i < SQL.room_rooms.length; i++) {
															map_AP_panel.add(
																				{ 
																					title:			SQL.room_rooms[i].name,
																					autoScroll:		true,
																					html:			'<canvas id="canvas_' + SQL.room_rooms[i].room_id + '" resize></canvas>',
																					room_id:		SQL.room_rooms[i].room_id,
																					dockedItems:	[
																										{
																											dock:	'top',
																											xtype:	'toolbar',
																											items:	[
																														{
																															text:				'Lock',
																															id:					'map_lock_button',
																															tooltip:			'Lock AP movement on map',
																															glyph:				'f023@FontAwesome',
																															enableToggle:		true,
																															pressed:			true,
																															handler:			function() {
																																					room_map_lock = (Ext.getCmp('map_lock_button').pressed === true) ? true : false;
																																				}
																														},
																														{ 	xtype: 'tbseparator' },
																														{
																															xtype:				'sliderfield',
																															id:					'map_' + SQL.room_rooms[i].room_id + '_scale',
																															tooltip:			'Map scale',
																															width:				300,
																															fieldLabel:			'Scale',
																															labelWidth: 		40,
																															minValue:			0.5,
																															maxValue:			3,
																															value:				SQL.room_rooms[i].scale,
																															decimalPrecision:	1,
																															increment:			0.1,
																															listeners:			{
																																					change: function () {
																																								if (room_map_drawing) 
																																									return;
																																								$.post('server/maproom.php', { action: 'scale', room_id: room_active_tab, scale: Ext.getCmp('map_' + room_active_tab + '_scale').getValue() })
																																								.done(	function (SQL) {
																																											initCanvas(SQL);
																																										}
																																								);
																																							}
																																				}
																														}
																													]
																										}
																									]
																				}
																			);
														}
														room_active_tab = SQL.room_rooms[0].room_id;
														map_AP_panel.setActiveTab(0);
												}
											);
										},
						tabchange:			function(tabPanel, tab) {
															room_active_tab = tab.config.room_id;
															$.post('server/maproom.php', { action: 'get' },
																function (SQL) {
																	initCanvas(SQL);
																}
															);
											}
	}
});

function selectImg(num, type) {
	if (Ext.getCmp(type + '_map_roomid').value)
		document.getElementById('map_div_' + Ext.getCmp(((type == 'edit') ? 'edit_map_mapid' : 'add_map_roomid')).value).style.backgroundColor = '';
	document.getElementById('map_div_' + num).style.backgroundColor = '#A0A0A0';
	Ext.getCmp(((type == 'edit') ? 'edit_map_mapid' : 'add_map_roomid')).setValue(num);
}

function showMapAddDialog() {
	var SQL;
	var map_room_id = null;

	$.post('server/maproom.php', { action: 'get' }, 
		function(data) { 
			var SQL = data;

			for (var i = 0; i < SQL.room_aps.length; i++) {
				for (var j = 0; j < SQL.aps.length; j++) {
					if (SQL.room_aps[i].client_id == SQL.aps[j].id)
						SQL.aps.splice(j, 1);
				}
			}

			var map_window = new Ext.window.Window({
				title:			'Add new map',
				id:				'add_map_window',			
				width:			800,
				height:			400,
				shadow:			true,
				resizable:		false,
				draggable:		false,
				closable:		true,
				modal:			true,
				autoShow:		true,
				items:			[
									{
										xtype:			'tabpanel',
										border:			false,
										bodyPadding:	20,
										items:			[
															{
																title:	'General',
																xtype:	'form',
																height: 270,
																border:	false,
																items:	[
																			{
																				xtype:			'textfield',
																				name:			'add_map_roomname',
																				fieldLabel:		'Room name',
																				value:			'',
																				allowBlank: 	false,
																				width:			730
																			},
																			{
																				xtype:			'textareafield',
																				name:			'add_map_roomcomment',
																				fieldLabel:		'Comment',
																				value:			'',
																				width:			730
																			},
																			{
																				xtype:			'tagfield',
																				name:			'add_map_roomaps',
																				fieldLabel:		'APs',
																				store:			{
																									fields: [
																												{	name: 'id',					type: 'int'		},
																												{	name: 'host',				type: 'string'	},
																												{	name: 'hostname',			type: 'string'	}
																											],
																									data:	SQL.aps
																								},
																				displayField:	'hostname',
																				valueField:		'id',
																				filterPickList:	true,
																				allowBlank: 	false,
																				editable:		false,
																				queryMode:		'local',
																				publishes:		'value',
																				encodeSubmitValue: true,
																				width:			730
																			},
																			{
																				xtype:			'textfield',
																				id:				'add_map_roomid',
																				name:			'add_map_roomid',
																				value:			'',
																				hidden:			true
																			}
																		]
															},
															{
																title:		'Room map',
																id:			'add_map_roommap_tab',
																height: 	270,
																border:		false,
																autoScroll: true,
																html:		'<div id="add_map_roommap"></div>',
																listeners:	{
																				afterrender:	function() {
																									html = '';
																									for (var i = 0; i < SQL.images.length; i++) {
																										html += '			<div id="map_div_' + SQL.images[i].map_id + '" class="map" onclick="selectImg(' + SQL.images[i].map_id + ', \'add\')">' +
																												'				<div>' + SQL.images[i].name + '</div>' +
																												'				<img src="server/maproom.php?id=' + SQL.images[i].map_id + '" />' +
																												'			</div>';
																									}
																									document.getElementById('add_map_roommap').innerHTML = html;
																								}
																			}

															}
														],
										buttons:	[
														{
															text:		'Add map image',
															handler:	function() {
																			new Ext.window.Window({
																				title:			'Upload new map image',
																				id:				'add_map_imageupload',
																				width:			320,
																				height:			160,
																				shadow:			true,
																				resizable:		false,
																				draggable:		false,
																				closable:		true,
																				modal:			true,
																				autoShow:		true,
																				items:			[ 
																									{
																										xtype:			'form',
																										bodyPadding:	20,
																										border:			false,
																										items: 			[
																															{
																																xtype:		'textfield',
																																fieldLabel:	'Name',
																																name:		'file-name',
																																allowBlank: false,
																																labelWidth:	50,
																																width:		270
																															},
																															{
																																xtype:		'filefield',
																																emptyText:	'Select an image',
																																fieldLabel:	'Image',
																																allowBlank: false,
																																labelWidth:	50,
																																width:		270,
																																name:		'file-image',
																																buttonText:	'Browse',
																															}
																														],

																										buttons:		[
																															{
																																text:		'Upload',
																																handler:	function() {
																																				var form = this.up('form').getForm();
																																				if (form.isValid()) {
																																					form.submit({
																																						url:		'server/maproom.php',
																																						params:		{ action: 'putimage' },
																																						waitMsg:	'Uploading image...',
																																						failure:	function () {
																																										Ext.getCmp('add_map_imageupload').close();
																																										$.post('server/maproom.php', { action: 'get' }, 
																																											function(data) { 
																																												SQL = data; 
																																												var html = '<div id="add_map_roommap">';
																																												for (var i = 0; i < SQL.images.length; i++) {
																																													html += '			<div id="map_div_' + SQL.images[i].map_id + '" class="map" onclick="selectImg(' + SQL.images[i].map_id + ', \'add\')">' +
																																															'				<div>' + SQL.images[i].name + '</div>' +
																																															'				<img src="server/maproom.php?id=' + SQL.images[i].map_id + '" />' +
																																															'			</div>';
																																												}
																																												html += '</div>';
																																												Ext.getCmp('add_map_roommap_tab').update(html);
																																											}
																																										);
																																									}
																																					});
																																				}
																																			}
																															},
																															{
																																text:		'Cancel',
																																handler:	function() { Ext.getCmp('add_map_imageupload').close(); }
																															}
																														]
																									}
																								]
																			});
																		}
														},
														{
															text:		'Apply',
															handler:	function() {
																			if (Ext.getCmp('add_map_roomid').value.length == 0) {
																				Ext.MessageBox.alert('Room map image not selected', 'You need select room map image!');
																				return;
																			}
																			var win = this.up('window'), form = win.down('form').getForm();
																			if (form.isValid()) {
																				form.submit({
																					url: 		'server/maproom.php',
																					params:		{ action: 'save' },	
																					waitMsg:	'Saving...',
																					failure:	function () {
																									Ext.getCmp('add_map_window').close();
																									showCanvas();
																								}
																				});
																			}
																		}
														},
														{ 
															text:		'Cancel',
															handler:	function() { Ext.getCmp('add_map_window').close();	}
														}
													]
									}
								]
			});
		}
	);
}

function showMapEditDialog() {
	var SQL;
	var map_room_id = null;
	
	$.post('server/maproom.php', { action: 'get' }, 
		function(data) { 
			var SQL = data;
			var room_id, room_name, room_comment, room_map;
			var room_aps = [];

			for (var i = 0; i < SQL.room_aps.length; i++) {
				for (var j = 0; j < SQL.aps.length; j++) {
					if (SQL.room_aps[i].client_id == SQL.aps[j].id && SQL.room_aps[i].room_id != map_AP_panel.getActiveTab().config.room_id)
						SQL.aps.splice(j, 1);
				}
			}

			for (var i = 0; i < SQL.room_rooms.length; i++) {
				if (SQL.room_rooms[i].room_id == map_AP_panel.getActiveTab().config.room_id) {
					room_id = SQL.room_rooms[i].room_id;
					room_name = SQL.room_rooms[i].name;
					room_comment = SQL.room_rooms[i].comment;
					room_map = SQL.room_rooms[i].map_id;
					for (var j = 0; j < SQL.room_aps.length; j++) {
						if (SQL.room_aps[j].room_id == map_AP_panel.getActiveTab().config.room_id) 
							room_aps.push(SQL.room_aps[j].client_id);
					}
				}
			}
			
			var map_window = new Ext.window.Window({
				title:			'Edit map',
				id:				'edit_map_window',			
				width:			800,
				height:			400,
				shadow:			true,
				resizable:		false,
				draggable:		false,
				closable:		true,
				modal:			true,
				autoShow:		true,
				items:			[
									{
										xtype:			'tabpanel',
										border:			false,
										bodyPadding:	20,
										items:			[
															{
																title:	'General',
																xtype:	'form',
																height: 270,
																border:	false,
																items:	[
																			{
																				xtype:			'textfield',
																				name:			'edit_map_roomname',
																				fieldLabel:		'Room name',
																				value:			room_name,
																				allowBlank: 	false,
																				width:			730
																			},
																			{
																				xtype:			'textareafield',
																				name:			'edit_map_roomcomment',
																				fieldLabel:		'Comment',
																				value:			room_comment,
																				width:			730
																			},
																			{
																				xtype:			'tagfield',
																				name:			'edit_map_roomaps',
																				fieldLabel:		'APs',
																				store:			{
																									fields: [
																												{	name: 'id',					type: 'int'		},
																												{	name: 'host',				type: 'string'	},
																												{	name: 'hostname',			type: 'string'	}
																											],
																									data:	SQL.aps
																								},
																				displayField:	'hostname',
																				valueField:		'id',
																				filterPickList:	true,
																				allowBlank: 	false,
																				editable:		false,
																				queryMode:		'local',
																				publishes:		'value',
																				value:			room_aps,
																				encodeSubmitValue: true,
																				width:			730
																			},
																			{
																				xtype:			'textfield',
																				id:				'edit_map_mapid',
																				name:			'edit_map_mapid',
																				value:			room_map,
																				hidden:			true
																			},
																			{
																				xtype:			'textfield',
																				id:				'edit_map_roomid',
																				name:			'edit_map_roomid',
																				value:			map_AP_panel.getActiveTab().config.room_id,
																				hidden:			true
																			}

																		]
															},
															{
																title:		'Room map',
																id:			'edit_map_roommap_tab',
																height: 	270,
																border:		false,
																autoScroll: true,
																html:		'<div id="edit_map_roommap"></div>',
																listeners:	{
																				afterrender:	function() {
																									html = '';
																									for (var i = 0; i < SQL.images.length; i++) {
																										html += '			<div id="map_div_' + SQL.images[i].map_id + '" class="map" onclick="selectImg(' + SQL.images[i].map_id + ', \'edit\')">' +
																												'				<div>' + SQL.images[i].name + '</div>' +
																												'				<img src="server/maproom.php?id=' + SQL.images[i].map_id + '" />' +
																												'			</div>';
																									}
																									document.getElementById('edit_map_roommap').innerHTML = html;
																									document.getElementById('map_div_' + room_map).style.backgroundColor = '#A0A0A0';
																								}
																			}

															}
														],
										buttons:	[
														{ 
															text:		'Add map image',
															handler:	function() {
																			new Ext.window.Window({
																				title:			'Upload new map image',
																				id:				'add_map_imageupload',
																				width:			320,
																				height:			160,
																				shadow:			true,
																				resizable:		false,
																				draggable:		false,
																				closable:		true,
																				modal:			true,
																				autoShow:		true,
																				items:			[ 
																									{
																										xtype:			'form',
																										bodyPadding:	20,
																										border:			false,
																										items: 			[
																															{
																																xtype:		'textfield',
																																fieldLabel:	'Name',
																																name:		'file-name',
																																allowBlank: false,
																																labelWidth:	50,
																																width:		270
																															},
																															{
																																xtype:		'filefield',
																																emptyText:	'Select an image',
																																fieldLabel:	'Image',
																																allowBlank: false,
																																labelWidth:	50,
																																width:		270,
																																name:		'file-image',
																																buttonText:	'Browse',
																															}
																														],

																										buttons:		[
																															{
																																text:		'Upload',
																																handler:	function() {
																																				var form = this.up('form').getForm();
																																				if (form.isValid()) {
																																					form.submit({
																																						url: 		'server/maproom.php',
																																						params:		{ action: 'putimage' },
																																						waitMsg: 	'Uploading image...',
																																						failure: 	function () {
																																										Ext.getCmp('add_map_imageupload').close();
																																										$.post('server/maproom.php', { action: 'get' }, 
																																											function(data) { 
																																												SQL = data; 
																																												var html = '<div id="add_map_roommap">';
																																												for (var i = 0; i < SQL.images.length; i++) {
																																													html += '			<div id="map_div_' + SQL.images[i].map_id + '" class="map" onclick="selectImg(' + SQL.images[i].map_id + ', \'edit\')">' +
																																															'				<div>' + SQL.images[i].name + '</div>' +
																																															'				<img src="server/maproom.php?id=' + SQL.images[i].map_id + '" />' +
																																															'			</div>';
																																												}
																																												html += '</div>';
																																												Ext.getCmp('edit_map_roommap_tab').update(html);
																																											}
																																										);
																																									}
																																					});
																																				}
																																			}
																															},
																															{
																																text:		'Cancel',
																																handler:	function() { Ext.getCmp('add_map_imageupload').close(); }
																															}
																														]
																									}
																								]
																			});
																		}
														},
														{ 
															text:		'Apply',
															handler:	function() {
																			if (Ext.getCmp('edit_map_roomid').value.length == 0) {
																				Ext.MessageBox.alert('Room map image not selected', 'You need select room map image!');
																				return;
																			}
																			var win = this.up('window'), form = win.down('form').getForm();
																			if (form.isValid()) {
																				form.submit({
																					url:		'server/maproom.php',
																					params:		{ action: 'edit' },
																					waitMsg:	'Saving...',
																					failure:	function () {
																									Ext.getCmp('edit_map_window').close();
																									showCanvas();
																								}
																				});
																			}
																		}
														},
														{ 
															text:		'Cancel',
															handler:	function() { Ext.getCmp('edit_map_window').close();	}
														}
													]
									}
								]
			});
		}
	);
}


function showMapDeleteDialog() {
	Ext.MessageBox.confirm('Delete room map', 'Do you realy wont to delete room: ' + map_AP_panel.getActiveTab().config.title, 
		function(btnText) {
			if(btnText === "yes")
				$.post('server/maproom.php', 
					{ action: 'delete', id: map_AP_panel.getActiveTab().config.room_id }, 
					function(data) {
						showCanvas();
					}
				);
		}
	);
}

function showCanvas() {
			map_AP_panel.removeAll();
			$.post('server/maproom.php', { action: 'get' },	
				function (SQL) {
					if (SQL.room_rooms.length == 0)
						return;

					for (var i = 0; i < SQL.room_rooms.length; i++) {
						map_AP_panel.add(
											{ 
												title:		SQL.room_rooms[i].name,
												autoScroll:	true,
												html:		'<canvas id="canvas_' + SQL.room_rooms[i].room_id + '" resize></canvas>',
												room_id:	SQL.room_rooms[i].room_id,
												dockedItems:	[
																	{
																		dock:	'top',
																		xtype:	'toolbar',
																		items:	[
																					{
																						text:				'Lock',
																						id:					'map_lock_button',
																						tooltip:			'Lock AP movement on map',
																						glyph:				'f023@FontAwesome',
																						enableToggle:		true,
																						pressed:			true,
																						handler:			function() {
																												room_map_lock = (Ext.getCmp('map_lock_button').pressed === true) ? true : false;
																											}
																					},
																					{ 	xtype: 'tbseparator' },
																					{
																						xtype:				'sliderfield',
																						id:					'map_' + SQL.room_rooms[i].room_id + '_scale',
																						tooltip:			'Map scale',
																						width:				300,
																						fieldLabel:			'Scale',
																						labelWidth: 		40,
																						minValue:			0.5,
																						maxValue:			3,
																						value:				SQL.room_rooms[i].scale,
																						decimalPrecision:	1,
																						increment:			0.1,
																						listeners:			{
																												change: function () {
																															if (!room_map_drawing) 
																																$.post('server/maproom.php', { action: 'scale', room_id: room_active_tab, scale: Ext.getCmp('map_' + room_active_tab + '_scale').getValue() })
																																.done(	function (SQL) {
																																			initCanvas(SQL);
																																		}
																																);
																														}
																											}
																					}
																				]
																	}
																]
											}
										);
					}
					room_active_tab = SQL.room_rooms[0].room_id;
					initCanvas(SQL);
					map_AP_panel.setActiveTab(0);
				}
			);
}

var map			= {};							// Map propties
var AP			= [];							// Array of APs position
function initCanvas(SQLdata) {

	if (room_map_drawing)						// Exit if map drawing
		return
	else
		room_map_drawing = true;

	var room		= {};

	var path;
	var tool		= new Tool();				// Mouse & Key event handler
	var hitOptions	= {
						segments:	false,
						stroke:		false,
						fill:		true,
						tolerance:	5
					};
	
	var SQL			= JSON.parse(JSON.stringify(SQLdata));

	AP				= [];						// Array of APs position
	map				= {};						// Map propties
	
	// Find current room
	for (i = 0; i < SQL.room_rooms.length; i++)
		if (SQL.room_rooms[i].room_id == room_active_tab)
			room = SQL.room_rooms[i];
	
	// Find AP of current room
	for (i = 0; i < SQL.room_aps.length; i++)
		if (SQL.room_aps[i].room_id == room_active_tab) {
			for (j = 0; j < SQL.aps.length; j++)
				if (SQL.aps[j].id == SQL.room_aps[i].client_id) {
					SQL.room_aps[i].host = SQL.aps[j].host;
					SQL.room_aps[i].hostname = SQL.aps[j].hostname;
				}
			AP.push(SQL.room_aps[i]);
		}

	// Initialize paper
	paper.setup('canvas_' + room_active_tab);

	// Clear previous items on canvas
	paper.project.activeLayer.removeChildren();
	paper.view.draw();

	// Load background image
	var background = new Raster( { source: 'server/maproom.php?id=' + room.map_id, position: [-10000, -10000] });

	if (room.scale === null)
		room.scale = 1;

	// Wait image loading
	background.onLoad = function() {
		
		room_back_id	= background._id;
		
		// Calculate and set background scale
		paper.view.viewSize = [ Math.round(background.size._width * room.scale), Math.round(background.size._height * room.scale) ];
		background.scale(room.scale);
		background.position = view.center;
		
		// Map propties
		map.start_x		= Math.round(background.position.x - (background.size._width  * room.scale / 2));
		map.end_x		= Math.round(background.position.x + (background.size._width  * room.scale / 2));
		map.start_y		= Math.round(background.position.y - (background.size._height * room.scale / 2));
		map.end_y		= Math.round(background.position.y + (background.size._height * room.scale / 2));
		map.AP_size		= 60;
		map.AP_position	= { x: (map.start_x + map.AP_size), y: (map.start_y + map.AP_size) };
		
		for (i = 0; i < AP.length; i++) {
			// Draw AP image
			var AP_image			= (AP[i].up == 1) ? new paper.Raster('router_up') : new paper.Raster('router_down');
			AP_image.size 			= new Size(map.AP_size, 60);
			AP_image.position		= view.center;
			AP_image.position.x		= Math.round(AP_image.position.x);
			AP_image.position.y 	= Math.round(AP_image.position.y - 20);

			// Draw AP text
			var AP_hostname			= new PointText({
													point:			view.center,
													justification:	'center',
													fontSize:		12,
													fillColor:		'black'
												});
			AP_hostname.content 	= AP[i].hostname;
			AP_hostname.position.x	= Math.round(AP_hostname.position.x);
			AP_hostname.position.y	= Math.round(AP_hostname.position.y + 25);

			var AP_host				= new PointText({
													point:			view.center,
													justification:	'center',
													fontSize:		12,
													fillColor:		'black'
												});
			AP_host.content 		= AP[i].host;
			AP_host.position.x		= Math.round(AP_host.position.x);
			AP_host.position.y		= Math.round(AP_host.position.y + 40);

			// Group AP image and text
			var group				= new Group( [ AP_image, AP_hostname, AP_host ] );
			var AP_group			= group.rasterize();

			// Hide non-group image 
			AP_image.visible		= false;
			AP_hostname.visible		= false;
			AP_host.visible			= false;
			
			if (!AP[i].position_x || !AP[i].position_y) {
				AP[i].position_x = Math.round(map.AP_position.x);
				AP[i].position_y = Math.round(map.AP_position.y);
				
				map.AP_position.x += Math.round(map.AP_size * 2);
				if (map.AP_position.x > map.end_x -  map.AP_size / 2) {
					map.AP_position.x = Math.round(map.start_x + map.AP_size);
					map.AP_position.y += Math.round(map.start_y + map.AP_size * 2);
				}
			}
			else {
				AP[i].position_x = Math.round(map.start_x + (map.end_x - map.start_x) * AP[i].position_x / 100);
				AP[i].position_y = Math.round(map.start_y + (map.end_y - map.start_y) * AP[i].position_y / 100);
			}

			if (AP[i].hostname == AP_hostname.content && AP[i].host == AP_host.content) {
				AP_group.position.x	= Math.round(AP[i].position_x);
				AP_group.position.y	= Math.round(AP[i].position_y);
				AP_group.name		= AP_hostname.content + ' (' + AP_host.content + ')|' + AP[i].client_id;
			}

			AP_group.onClick = function(event) {
//				console.log('Click: ' + event);
			}
				
			AP_group.onDoubleClick = function(event) {
				var host = (event.target + '').replace(/Raster /, '').replace(/'/g, '').split('|');
				showAPinfo(host[0], host[1]);
			}
		}

		tool.onMouseDown = function(event) {
			path = (project.hitTest(event.point, hitOptions) != null) ? project.hitTest(event.point, hitOptions).item : null;
		}

		tool.onMouseUp = function(event) {
			if (path && path._id != room_back_id && !room_map_lock) {
				for (var i = 0; i < AP.length; i++) {
					if (AP[i].hostname + ' (' + AP[i].host + ')|' + AP[i].client_id == path._name) {
						var new_x = (path.position.x - map.start_x) / (map.end_x - map.start_x) * 100;
						var new_y = (path.position.y - map.start_y) / (map.end_y - map.start_y) * 100;
						$.post('server/maproom.php', { action: 'update', position_x: new_x, position_y: new_y, client_id: AP[i].client_id });						
						break;
					}
				}
			}
		}

		tool.onMouseMove = function(event) {
			project.activeLayer.selected 		= false;
			if (event.item)	event.item.selected = false;
		}

		tool.onMouseDrag = function(event) {
			if (path && path._id != room_back_id && !room_map_lock) {
				var position_x = path.position.x + event.delta.x;
				var position_y = path.position.y + event.delta.y;
				
				if      ( position_x > map.end_x - map.AP_size / 2   ) position_x = map.end_x - map.AP_size / 2;
				else if ( position_x < map.start_x + map.AP_size / 2 ) position_x = map.start_x + map.AP_size / 2;
				if      ( position_y > map.end_y - map.AP_size / 2   ) position_y = map.end_y - map.AP_size / 2;
				else if ( position_y < map.start_y + map.AP_size / 2 ) position_y = map.start_y + map.AP_size / 2;
				
				path.position.x = position_x;
				path.position.y = position_y;

				for (var i = 0; i < AP.length; i++) {
					if (AP[i].hostname + ' (' + AP[i].host + ')|' + AP[i].client_id == path._name) {
						AP[i].position_x = position_x;
						AP[i].position_y = position_y;
						break;
					}
				}
			}
		}

		tool.onKeyUp = function(event) {
			if (event.key == '-' || event.key == '+') {
				room.scale = (event.key == '-') ? (room.scale > 0.5) ? +(+room.scale - 0.1).toFixed(1) : 0.5 : (+room.scale < 3) ? +(+room.scale + 0.1).toFixed(1) : 2;
				$.post('server/maproom.php', { action: 'scale', room_id: room.room_id, scale: room.scale })
				.done(	function (SQL) {
							Ext.getCmp('map_' + room_active_tab + '_scale').setValue(room.scale);
							initCanvas(SQL);
						}
				);
			}
		}
		clearInterval(room_map_redraw);
		room_map_redraw = setTimeout(	function () {
														$.post('server/maproom.php', { action: 'get' },	
															function (SQL) {
																initCanvas(SQL);
															}
														);		
										}, 60000);
		room_map_drawing = false;	
	};
}