function showAPinfo(title, AP_id) {

	var plot;
	var plot_interval;
	var plot_height		= ((window.innerHeight - 200) / 3 * 2).toFixed(0);
	var legend_height	= (window.innerHeight - plot_height - 180);	
	var legendSelect	= [];
	var legendRestore	= false;
	var start, end;

	var popup_width		= (window.innerWidth >= 920) ? 920 : window.innerWidth;
	var popup_height	= (window.innerHeight >= 400) ? 400 : window.innerHeight;
	
	new Ext.window.Window({
		width:			popup_width,
		height:			popup_height,
		title:			title,
		id:				'info_window',
		shadow:			true,
		resizable:		false,
		draggable:		false,
		closable:		true,
		autoShow:		true,
		modal:			true,
		items:			[
							{
								xtype:		'tabpanel',
								width:		'auto',
								layout:		'fit',
								border:		false,
								items:	 	[
												{
													title:	'System Info',
													tooltip:'Access point system information',
													glyph:	'f129@FontAwesome',
													border:	false,
													items:	[ 
																{
																	xtype:		'grid',
																	id:			'info_sysinfo_grid',
																	scrollable:	true,
																	//height:		popup_height - 100,
																	border:		false,
																	store:		{
																					fields: 		[
																										{	name: 'name',		type: 'string'	},
																										{	name: 'value',		type: 'string'	}
																									],
																					proxy: 			{
																										type:	'ajax',
																										reader:	{ type:	'json' }
																									}
																				},
																	viewConfig:	{
																					preserveScrollOnReload:	true,
																					enableTextSelection:	true,
																					loadMask:				false,
																				},
																	columns: 	[	
																					{	dataIndex: 'name',		align: 'right',	tdCls: 'value-column', flex: 40 / 100	}, 
																					{	dataIndex: 'value',		flex: 60 / 100											}
																				],
																	listeners:	{
																					'afterrender':	function() {
																						this.store.load( { url: '/server/get_ap_info_extjs.php?cmd=getSysinfo&id=' + AP_id } );
																					}
																				}
																}
															]	
												},
												{
													title:	'Wireless',
													tooltip:'Access point Wireless information',
													glyph:	'f1eb@FontAwesome',
													items:	[
																{
																	id:			'info_wireless_grid',
																	scrollable:	true,
																	xtype:		'grid',
																	height:		popup_height - 63,
																	store:		{
																					fields: [
																								{	name: 'wifi_bssid',				type: 'string'	},
																								{	name: 'wifi_ssid',				type: 'string'	},
																								{	name: 'wifi_channel',			type: 'string'	},
																								{	name: 'wifi_hidden',			type: 'string'	},
																								{	name: 'wifi_isolate_cl',		type: 'string'	},
																								{	name: 'wifi_isolate_bc',		type: 'string'	},
																								{	name: 'wifi_isolate_ssids',		type: 'string'	},
																								{	name: 'wifi_isolate_lan_wlan',	type: 'string'	},
																								{	name: 'wifi_apcli_status',		type: 'string'	},
																								{	name: 'wifi_apcli_addr',		type: 'string'	}
																							],
																					proxy:	{
																								type:	'ajax',
																								reader:	{ type:	'json'	}
																							}
																				},
																	viewConfig:	{
																					preserveScrollOnReload:	true,
																					enableTextSelection:	true,
																					loadMask:				false,
																				},
																	columns: 	[
																					{	text: 'SSID',		dataIndex: 'wifi_ssid',		align: 'center',	flex: 13 / 100	}, 
																					{	text: 'BSSID',		dataIndex: 'wifi_bssid',	align: 'center',	flex: 13 / 100	}, 
																					{	text: 'Channel',	dataIndex: 'wifi_channel',	align: 'center',	flex: 7 / 100	}, 
																					{	text: 'Hidden',		dataIndex: 'wifi_hidden',	align: 'center',	flex: 7 / 100	}, 
																					{	text: 'Isolation',
																						columns: [
																									{	text: 'Client',		dataIndex: 'wifi_isolate_cl', 		align: 'center',	flex: 10 / 100	},
																									{	text: 'Broadcast',	dataIndex: 'wifi_isolate_bc',		align: 'center',	flex: 10 / 100	},
																									{	text: 'SSID',		dataIndex: 'wifi_isolate_ssids',	align: 'center',	flex: 10 / 100	},
																									{	text: 'LAN/WAN',	dataIndex: 'wifi_isolate_lan_wlan',	align: 'center',	flex: 10 / 100	}
																								 ]
																					},
																					{	text: 'APCLI',			dataIndex: 'wifi_apcli_status',		align: 'center',	flex: 7 / 100	}, 
																					{	text: 'APCLI Address',	dataIndex: 'wifi_apcli_addr',		align: 'center',	flex: 13 / 100	}
																				],
																	listeners:	{
																					'afterrender':	function() {
																						this.store.load( { url: '/server/get_ap_info_extjs.php?cmd=getWireless&id=' + AP_id } );
																					}
																				}
																}
															]
													
												},
												{
													title:	'WAN / LAN',
													tooltip:'Access point WAN & LAN interface information',
													glyph:	'f26b@FontAwesome',
													items:	[
																{
																	xtype:		'grid',
																	id:			'info_wanlan_grid',
																	scrollable:	true,
																	height:		popup_height - 63,
																	store:		{
																					fields: [
																								{	name: 'name',		type: 'string'	},
																								{	name: 'value',		type: 'string'	}
																							],
																					proxy: 	{
																								type:	'ajax',
																								reader:	{	type:		'json'	}
																							}
																				},
																	viewConfig:	{
																					preserveScrollOnReload:	true,
																					enableTextSelection:	true,
																					loadMask:				false,
																				},
																	columns:	[
																					{	dataIndex: 'name',	align: 'right',		tdCls: 'value-column',	flex: 40 / 100	}, 
																					{	dataIndex: 'value',	flex: 60 / 100												}
																				],
																	listeners:	{
																					'afterrender':	function() {
																						this.store.load( { url: '/server/get_ap_info_extjs.php?cmd=getWANLAN&id=' + AP_id } );
																					}
																				}
																}
															]
												},
												{
													title:	'VPN',
													tooltip:'Access point VPN information',
													glyph:	'f132@FontAwesome',
													items:	[
																{
																	xtype:		'grid',
																	id:			'info_vpn_grid',
																	scrollable:	true,
																	height:		popup_height - 63,
																	store:		{
																					fields: [
																								{	name: 'name',		type: 'string'	},
																								{	name: 'value',		type: 'string'	}
																							],
																					proxy: 	{
																								type:	'ajax',
																								reader:	{ type: 'json'	}
																							}
																				},
																	viewConfig:	{
																					preserveScrollOnReload:	true,
																					enableTextSelection:	true,
																					loadMask:				false,
																				},
																	columns:	[
																					{	dataIndex: 'name',	align: 'right',		tdCls: 'value-column',	flex: 40 / 100	}, 
																					{	dataIndex: 'value',	flex: 60 / 100												}
																				],
																	listeners:	{
																					'afterrender':	function() {
																						this.store.load( { url: '/server/get_ap_info_extjs.php?cmd=getVPN&id=' + AP_id } );
																					}
																				}
																}
															]
												},
												{
													title:	'IPv6',
													tooltip:'Access point IPv6 information',
													glyph:	'f005@FontAwesome',
													items:	[
																{
																	xtype:		'grid',
																	id:			'info_ipv6_grid',
																	scrollable:	true,
																	height:		popup_height - 63,
																	store:		{
																					fields: [
																								{	name: 'name',	type: 'string'	},
																								{	name: 'value',	type: 'string'	}
																							],
																					proxy: 	{
																								type:	'ajax',
																								reader:	{ type: 'json'	}
																							}
																				},
																	viewConfig:	{
																					preserveScrollOnReload:	true,
																					enableTextSelection:	true,
																					loadMask:				false,
																				},
																	columns:	[
																					{	dataIndex: 'name',	align: 'right',	tdCls: 'value-column',	flex: 40 / 100	}, 
																					{	dataIndex: 'value',	flex: 60 / 100											}
																				],
																	listeners:	{
																					'afterrender':	function() {
																						this.store.load( { url: '/server/get_ap_info_extjs.php?cmd=getIPv6&id=' + AP_id } );
																					}
																				}
																}
															]
												},
												{
													title:	'Interfaces',
													tooltip:'Access point system interfaces information',
													glyph:	'f005@FontAwesome',
													items:	[
																{
																	xtype:		'grid',
																	id:			'info_interfaces_grid',
																	scrollable:	true,
																	height:		popup_height - 63,
																	store:		{
																					fields:	[
																								{	name: 'ifname',		type: 'string'	},
																								{	name: 'rx_bytes',	type: 'int'		},
																								{	name: 'tx_bytes',	type: 'int'		},
																								{	name: 'rx_packets',	type: 'int'		},
																								{	name: 'tx_packets',	type: 'int'		},
																							],
																					proxy:	{
																								type:	'ajax',
																								reader:	{ type: 'json'	}
																							}
																				},
																	viewConfig:	{
																					preserveScrollOnReload:	true,
																					enableTextSelection:	true,
																					loadMask:				false,
																				},
																	columns: 	[
																					{	text: 'Interface',	dataIndex: 'ifname',	flex: 20 / 100																				}, 
																					{	text: 'RX Bytes',	dataIndex: 'rx_bytes',	flex: 20 / 100,	renderer: function(value) {	return Ext.util.Format.number(value, ',000'); }	}, 
																					{	text: 'TX Bytes',	dataIndex: 'tx_bytes',	flex: 20 / 100,	renderer: function(value) {	return Ext.util.Format.number(value, ',000'); }	}, 
																					{	text: 'RX Packets',	dataIndex: 'rx_packets',flex: 20 / 100,	renderer: function(value) {	return Ext.util.Format.number(value, ',000'); }	}, 
																					{	text: 'TX Packets',	dataIndex: 'tx_packets',flex: 20 / 100,	renderer: function(value) { return Ext.util.Format.number(value, ',000'); }	} 
																				],
																	listeners:	{
																					'afterrender':	function() {
																						this.store.load( { url: '/server/get_ap_info_extjs.php?cmd=getInterfaces&id=' + AP_id } );
																					}
																				}
																}
															]
												},
												{
													title:	'Ports',
													tooltip:'Access point ethernet ports information',													
													glyph:	'f005@FontAwesome',
													items:	[
																{
																	xtype:		'grid',
																	id:			'info_ports_grid',
																	scrollable:	true,
																	height:		popup_height - 63,
																	store:		{
																					fields: [
																								{	name: 'port',					type: 'string'	},
																								{	name: 'link',					type: 'string'	},
																								{	name: 'speed',					type: 'string'	},
																								{	name: 'duplex',					type: 'string'	},
																								{	name: 'rx_bytes',				type: 'string'	},
																								{	name: 'tx_bytes',				type: 'string'	}
																							],
																					proxy:	{
																								type:	'ajax',
																								reader:	{ type: 'json' }
																							}
																				},
																	viewConfig:	{
																					preserveScrollOnReload:	true,
																					enableTextSelection:	true,
																					loadMask:				false,
																				},
																	columns:	[
																					{	text: 'Port #',		dataIndex: 'port',		align: 'center',	flex: 12 / 100	}, 
																					{	text: 'Link',		dataIndex: 'link',		align: 'center',	flex: 12 / 100	}, 
																					{	text: 'Speed',		dataIndex: 'speed',		align: 'center',	flex: 12 / 100	}, 
																					{	text: 'Duplex',		dataIndex: 'duplex',	align: 'center',	flex: 12 / 100	}, 
																					{	text: 'RX Bytes',	dataIndex: 'rx_bytes',	flex: 16 / 100,
																						renderer: function(value) { return Ext.util.Format.number(value, ',000'); }
																					}, 
																					{	text: 'TX Bytes',	dataIndex: 'tx_bytes',	flex: 16 / 100,
																						renderer: function(value) { return Ext.util.Format.number(value, ',000'); }
																					}
																				],
																	listeners:	{
																					'afterrender':	function() {
																						this.store.load( { url: '/server/get_ap_info_extjs.php?cmd=getPorts&id=' + AP_id } );
																					}
																				}																	}
															]
												},
												{
													title:	'Clients',
													tooltip:'Access point clients information',
													glyph:	'f0c0@FontAwesome',
													items:	[
																{
																	xtype:		'grid',
																	id:			'info_clients_grid',
																	scrollable:	true,
																	height:		popup_height - 63,
																	store:		{
																					fields:	[
																								{	name: 'sta_timestamp',	type: 'string'	},
																								{	name: 'sta_mac',		type: 'string'	},
																								{	name: 'sta_vendor',		type: 'string'	},
																								{	name: 'ap_host',		type: 'string'	},
																								{	name: 'ap_ssid',		type: 'string'	},
																								{	name: 'sta_conn_time',	type: 'string'	},
																								{	name: 'sta_psm',		type: 'string'	},
																								{	name: 'sta_mimops',		type: 'string'	},
																								{	name: 'sta_mcs',		type: 'string'	},
																								{	name: 'sta_bw',			type: 'string'	},
																								{	name: 'sta_sgi',		type: 'string'	},
																								{	name: 'sta_stbc',		type: 'string'	},
																								{	name: 'sta_ldpc',		type: 'string'	},
																								{	name: 'sta_mode',		type: 'string'	},
																								{	name: 'sta_tx_rate',	type: 'string'	},
																								{	name: 'sta_rssi',		type: 'string'	},
																								{	name: 'sta_quality',	type: 'string'	},
																								{	name: 'sta_rx_bytes',	type: 'string'	},
																								{	name: 'sta_tx_bytes',	type: 'string'	},
																								{	name: 'sta_rxtx_bytes',	type: 'string'	},
																								{	name: 'bssid',			type: 'string'	},
																							],
																					proxy:	{
																								type:	'ajax',
																								reader:	{ type: 'json'	}
																							}
																				},
																	viewConfig:	{
																					preserveScrollOnReload:	true,
																					enableTextSelection:	true,
																					loadMask:				false,
																				},
																	columns:	[
																					{	text: 'MAC',		dataIndex: 'sta_mac',		align: 'center',	flex: 15 / 100	}, 
																					{	text: 'BSSID',		dataIndex: 'bssid',			align: 'center',	flex: 15 / 100	}, 
																					{	text: 'Vendor',		dataIndex: 'sta_vendor',	align: 'center',	flex: 20 / 100	}, 
																					{	text: 'Conn. time',	dataIndex: 'sta_conn_time',	align: 'center',	flex: 10 / 100	}, 
																					{	text: 'Rate',		dataIndex: 'sta_tx_rate',	align: 'center',	flex: 8 / 100	}, 
																					{	text: 'RSSI',		dataIndex: 'sta_rssi',		align: 'center',	flex: 8 / 100	}, 
																					{	text: 'Quality',	dataIndex: 'sta_quality',	align: 'center',	flex: 10 / 100	}, 
																					{	text: 'RX / TX',	dataIndex: 'sta_rxtx_bytes',align: 'center',	flex: 10 / 100	}
																				],
																	plugins: 	[
																					{
																						ptype:		'rowexpander',
																						rowBodyTpl:	new Ext.XTemplate(
																										'<div style="width: 12%; float:left;"><b>PSM:</b>&nbsp;{sta_psm}</div>',
																										'<div style="width: 12%; float:left;"><b>MIMO PS:</b>&nbsp;{sta_mimops}</div>',
																										'<div style="width: 12%; float:left;"><b>MCS:</b>&nbsp;{sta_mcs}</div>',
																										'<div style="width: 12%; float:left;"><b>BW:</b>&nbsp;{sta_bw}</div>',
																										'<div style="width: 12%; float:left;"><b>SGI:</b>&nbsp;{sta_sgi}</div>',
																										'<div style="width: 12%; float:left;"><b>STBC:</b>&nbsp;{sta_stbc}</div>',
																										'<div style="width: 12%; float:left;"><b>LDPC:</b>&nbsp;{sta_ldpc}</div>',
																										'<div style="width: 12%; float:left;"><b>MODE:</b>&nbsp;{sta_mode}</div>',
																										{
																											formatChange: function(v){ return v; }
																										}
																									)
																					}
																				],
																	listeners:	{
																					'afterrender':	function() {
																						this.store.load( { url: '/server/get_ap_info_extjs.php?cmd=getClients&id=' + AP_id } );
																					}
																				}	
																}
															]
												},
												{
													title:	'Plot',
													tooltip:'Access point plots',
													glyph:	'f1fe@FontAwesome',
													id:		'info_plot_plot',
													height: window.innerHeight - 93,
													layout:	{
																type:	'vbox',
																pack:	'start',
																align:	'stretch'
															},
													items:	[
																{
																	flex:			2,
																	id:				'plot_window_div',
																	html:			'<div>'+
																					'	<div style="width: 100%; height: 100%;">'+
																					'		<div style="width: 100%; float: left; margin-right: 0px;">'+
																					'			<div id="plot_div" style="height: ' + plot_height + 'px;">'+
																					'				<div id="plot" style="width: 100%; height: 100%; text-align: center; padding: 10em 0; color: #B0B0B0;"><h1>Select type of graphics below.</h1></div>'+
																					'			</div>'+
																					'		</div>'+
																					'	</div>' +
																					'</div>' +
																					'<div id="plot_tooltip" style="position: absolute; display: none; border: 1px solid #fdd; padding: 2px; background-color: #fee; opacity: 0.80;"></div>',
																},
																{
																	xtype:			'grid',
																	flex:			1,
																	autoScroll:		true,
																	id:				'plot_legend',
																	store:			{
																						fields: [
																							{	name: 'color',		type: 'string'	},
																							{	name: 'mac',		type: 'string'	},
																							{	name: 'ssid',		type: 'string'	},
																							{	name: 'macbssid',	type: 'string'	},
																							{	name: 'name',		type: 'string'	},
																							{	name: 'min',		type: 'float'	},
																							{	name: 'max',		type: 'float'	},
																							{	name: 'avg',		type: 'float'	},
																							{	name: 'last',		type: 'float'	}
																						]
																					},
																	viewConfig:		{
																						preserveScrollOnReload:	true,
																						enableTextSelection:	true,
																						loadMask:				false,
																					},
																	columns: 		[
																						{	text: '#',			align: 'center',		flex: 5 / 100,	
																							renderer: 	function (value, meta, record, rowIndex) {
																											meta.style = "background-color:" + record.data.color + ";";
																											return rowIndex + 1;
																										}
																						},
																						{	text: 'MAC',		dataIndex: 'name',		flex: 25 / 100	},
																						{	text: 'BSSID',		dataIndex: 'ssid',		flex: 30 / 100	},
																						{	text: 'Mbit/sec.',	minWidth: 110,	id: 'plot_legend_unit',	flex: 40 / 100,
																							columns:	[
																											{	text: 'Min',	dataIndex: 'ap_min',	minWidth: 50,	flex: 10 / 100,	align: 'center'	},
																											{	text: 'Max',	dataIndex: 'ap_max',	minWidth: 60,	flex: 10 / 100,	align: 'center'	},
																											{	text: 'Avg',	dataIndex: 'ap_avg',	minWidth: 60,	flex: 10 / 100,	align: 'center'	},
																											{	text: 'Last',	dataIndex: 'ap_last',	minWidth: 60,	flex: 10 / 100,	align: 'center'	}
																										]
																						}
																					],
																	listeners:		{
																						select:		function() {
																										if (!legendRestore) {
																											var sel = Ext.getCmp('plot_legend').getSelectionModel().getSelection();
																											switch(Ext.getCmp('plot_type').value) {
																												case 'CPU & Memory':	legendSelect = [ sel[0].data.name ];					break;
																												case 'Interfaces':		legendSelect = [ sel[0].data.name ];					break;
																												case 'Ethernet ports':	legendSelect = [ sel[0].data.name ];					break;
																												case 'Clients':			legendSelect = [ sel[0].data.name, sel[0].data.ssid ];	break;
																											}
																											clearTimeout(plot_interval);
																											getDATA();
																										}
																									}
																					}
																	},
																{
																	xtype:		'fieldset',
																	height:		80,
																	title:		'Settings',
																	margin:		'10 10 10 10',
																	items: 		[
																					{
																						xtype:			'fieldcontainer',
																						name:			'plot_time',
																						fieldLabel:		'Time',
																						layout: 		'hbox',
																						items:			[ 
																											{
																												xtype:			'combo',
																												id:				'plot_time',
																												store:			{
																																	fields: 	[ 'name', 'value' ],
																																	data: 		[
																																					{ name: '2M',			value: 160		},
																																					{ name: '5M',			value: 340		},
																																					{ name: '10M',			value: 640		},
																																					{ name: '15M',			value: 940		},
																																					{ name: '30M',			value: 1840		},
																																					{ name: '1H',			value: 3600		},
																																					{ name: '2H',			value: 7200		},
																																					{ name: '3H',			value: 10800	},
																																					{ name: '6H',			value: 21600	},
																																					{ name: '12H',			value: 43200	},
																																					{ name: '24H',			value: 86400	},
																																					{ name: 'Manual',		value: 'Manual'	},
																																					{ name: 'Custom range',	value: 'Custom'	},
																																				]
																																},
																												editable:		false,
																												displayField:	'name',
																												valueField:		'value',
																												value:			640,
																												margin:			'0 20 5 0',
																												listeners:		{
																																	'select':	function(el) {
																																					Ext.getCmp('start_date').hide();
																																					Ext.getCmp('start_time').hide();
																																					Ext.getCmp('time_separator').hide();
																																					Ext.getCmp('end_date').hide();
																																					Ext.getCmp('end_time').hide();
																																					Ext.getCmp('manual_time_hour').hide();
																																					Ext.getCmp('manual_time_separator').hide();
																																					Ext.getCmp('manual_time_min').hide();
																																					if (el.value == 'Custom') {
																																						Ext.getCmp('start_date').show();
																																						Ext.getCmp('start_time').show();
																																						Ext.getCmp('time_separator').show();
																																						Ext.getCmp('end_date').show();
																																						Ext.getCmp('end_time').show();
																																					}
																																					else if (el.value == 'Manual') {
																																						Ext.getCmp('manual_time_hour').show();
																																						Ext.getCmp('manual_time_separator').show();
																																						Ext.getCmp('manual_time_min').show();
																																					}
																																				}
																																}
																											},
																											{ xtype: 'datefield',		id: 'start_date',			name: 'start_date',			margin: '0 5 0 0',		editable: false, 	width: 100, 	hidden: true, 	value: new Date() 											},
																											{ xtype: 'timefield',		id:	'start_time',			name: 'start_time',			margin:	'0 5 0 0',		format:	'H:i',		width: 70,		hidden:	true,	value: new Date(new Date() - 600000)					 	},
																											{ xtype: 'displayfield',	id:	'time_separator',									margin:	'0 5 0 0',											hidden: true,	value: '-'													},
																											{ xtype: 'datefield',		id: 'end_date',				name: 'end_date',			margin:	'0 5 0 0',		editable: false,	width: 100,		hidden: true,	value: new Date()											},
																											{ xtype: 'timefield',		id:	'end_time',				name: 'end_time',			format:	'H:i',								width: 70,		hidden: true,	value: new Date()											},
																											{ xtype: 'numberfield',		id:	'manual_time_hour',		name: 'manual_time_hour',	margin:	'0 5 0 0',		fieldLabel: 'H:M',	width: 70,		hidden: true,	value: 1,	minValue: 0,	maxValue: 72,	labelWidth: 25	},
																											{ xtype: 'displayfield',	id: 'manual_time_separator', 							margin: '0 5 0 0',											hidden: true,	value: ':'													},
																											{ xtype: 'numberfield',		id: 'manual_time_min',		name: 'manual_time_min',												width: 40,		hidden: true,	value: 0,	minValue: 0,	maxValue: 59					},
																										]
																					},
																					{
																						xtype:			'fieldcontainer',
																						name:			'plot_type',
																						fieldLabel: 	'Type',
																						layout: 		'hbox',
																						items:			[ 
																											{
																												xtype:			'combo',
																												store:			{
																																	fields: 	[ 'name', 'value' ],
																																	data: 		[
																																					{ name: 'CPU & Memory',		value: 'CPU & Memory'	},
																																					{ name: 'Interfaces',		value: 'Interfaces'		},
																																					{ name: 'Ethernet ports',	value: 'Ethernet ports'	},
																																					{ name: 'Clients',			value: 'Clients'		}
																																				]
																																},
																												editable:		false,
																												displayField:	'name',
																												valueField:		'value',
																												value:			'Clients',
																												id:				'plot_type',
																												margin:			'0 20 0 0',
																												listeners:		{
																																	'select':	function(el) {
																																					Ext.getCmp('plot_iface_unit').hide();
																																					Ext.getCmp('plot_clients_unit').hide();
																																					if (el.value == 'Clients') {
																																						columns = [
																																											{	text: '#',			align: 'center',		flex: 5 / 100,	
																																												renderer: 	function (value, meta, record, rowIndex) {
																																																meta.style = "background-color:" + record.data.color + ";";
																																																return rowIndex + 1;
																																															}
																																											},
																																											{	text: 'MAC',		dataIndex: 'name',		flex: 25 / 100	},
																																											{	text: 'BSSID',		dataIndex: 'ssid',		flex: 30 / 100	},
																																											{	text: 'Mbit/sec.',	minWidth: 110,	id: 'plot_legend_unit',	flex: 40 / 100,
																																												columns:	[
																																																{	text: 'Min',	dataIndex: 'ap_min',	minWidth: 50,	flex: 10 / 100,	align: 'center'	},
																																																{	text: 'Max',	dataIndex: 'ap_max',	minWidth: 60,	flex: 10 / 100,	align: 'center'	},
																																																{	text: 'Avg',	dataIndex: 'ap_avg',	minWidth: 60,	flex: 10 / 100,	align: 'center'	},
																																																{	text: 'Last',	dataIndex: 'ap_last',	minWidth: 60,	flex: 10 / 100,	align: 'center'	}
																																															]
																																											}
																																										];
																																						Ext.getCmp('plot_legend').reconfigure(undefined, columns);
																																						if (Ext.getCmp('plot_clients_unit').value == 'Rate' ||
																																							Ext.getCmp('plot_clients_unit').value == 'TX+RX Bandwidth')
																																							Ext.ComponentManager.get('plot_legend_unit').setText('Mbit/sec.');
																																						else if (Ext.getCmp('plot_clients_unit').value == 'RSSI')
																																							Ext.ComponentManager.get('plot_legend_unit').setText('dBm');
																																						else if (Ext.getCmp('plot_clients_unit').value == 'Quality')
																																							Ext.ComponentManager.get('plot_legend_unit').setText('%');
																																						Ext.getCmp('plot_clients_unit').show();
																																					}
																																					else {
																																						columns = [
																																										{	text: '#',	align: 'center',	flex: 5 / 100,	
																																											renderer: 	function (value, meta, record, rowIndex) {
																																															meta.style = "background-color:" + record.data.color + ";";
																																															return rowIndex + 1;
																																														}
																																										},
																																										{	text: 'Name',	dataIndex: 'name',	flex: 55 / 100	},
																																										{	text: '%',		id: 'plot_legend_unit',	minWidth: 110,		flex: 40 / 100,
																																											columns:	[
																																															{	text: 'Min',	dataIndex: 'ap_min',	minWidth: 50,	flex: 10 / 100,	align: 'center'	},
																																															{	text: 'Max',	dataIndex: 'ap_max',	minWidth: 60,	flex: 10 / 100,	align: 'center'	},
																																															{	text: 'Avg',	dataIndex: 'ap_avg',	minWidth: 60,	flex: 10 / 100,	align: 'center'	},
																																															{	text: 'Last',	dataIndex: 'ap_last',	minWidth: 60,	flex: 10 / 100,	align: 'center'	}
																																														]
																																										}
																																									];
																																						Ext.getCmp('plot_legend').reconfigure(undefined, columns);
																																						if (el.value == 'Interfaces') {
																																							Ext.getCmp('plot_iface_unit').show();
																																							if (Ext.getCmp('plot_iface_unit').value == 'BPS')
																																								Ext.ComponentManager.get('plot_legend_unit').setText('Mbit/sec.');
																																							else
																																								Ext.ComponentManager.get('plot_legend_unit').setText('PPS');
																																						}
																																						else if (el.value == 'Ethernet ports')
																																							Ext.ComponentManager.get('plot_legend_unit').setText('Mbit/sec.');
																																					}
																																				}
																																}
																											},
																											{
																												xtype:			'combo',
																												store:			{
																																	fields: 	[ 'name', 'value' ],
																																	data: 		[
																																					{ name: 'BPS',	value: 'BPS'	},
																																					{ name: 'PPS',	value: 'PPS'	},
																																				]
																																},
																												editable:		false,
																												hidden:			true,
																												displayField:	'name',
																												valueField:		'value',
																												id:				'plot_iface_unit',
																												value:			'BPS',
																												width:			60,
																												listeners:		{
																																	'select':	function(el) {
																																					if (el.value == 'BPS')
																																						Ext.ComponentManager.get('plot_legend_unit').setText('Mbit/sec.');
																																					else
																																						Ext.ComponentManager.get('plot_legend_unit').setText('PPS');
																																				}
																																}
																											},
																											{
																												xtype:			'combo',
																												store:			{
																																	fields: 	[ 'name', 'value' ],
																																	data: 		[
																																					{ name: 'Rate',				value: 'Rate'				},
																																					{ name: 'RSSI',				value: 'RSSI'				},
																																					{ name: 'Quality',			value: 'Quality'			},
																																					{ name: 'TX+RX Bandwidth',	value: 'TX+RX Bandwidth'	},
																																				]
																																},
																												editable:		false,
																												displayField:	'name',
																												valueField:		'value',
																												id:				'plot_clients_unit',
																												value:			'TX+RX Bandwidth',
																												listeners:		{
																																	'select':	function(el) {
																																					if (el.value == 'Rate' || el.value == 'TX+RX Bandwidth')
																																						Ext.ComponentManager.get('plot_legend_unit').setText('Mbit/sec.');
																																					else if (el.value == 'RSSI')
																																						Ext.ComponentManager.get('plot_legend_unit').setText('dBm');
																																					else
																																						Ext.ComponentManager.get('plot_legend_unit').setText('%');
																																				}
																																}
																											}
																										],
																					},
																	]					
																}
															]
												}
											],
								buttons:		[
													{
														text:		'Plot',
														cls:		'plot-btn-style',
														handler:	function() {
																		clearInterval(plot_interval);
																		getDATA();
																	}
													},
													{
														text:		'Close',
														handler:	function() { Ext.getCmp('info_window').close(); }
													}
												],
											
								listeners:	{
												tabchange:	function(tabPanel, tab) {
																if (plot !== undefined) {
																	clearInterval(plot_interval);
																	$("#plot").empty();
																	Ext.getCmp('plot_legend').store.removeAll();
																	$("#plot_tooltip").hide();
																	legendSelect = [];
																}
																if (popup_maximized) {
																	popup_maximized = false;
																	Ext.getCmp('info_window').setSize(popup_width + 1, popup_height + 1); 
																	Ext.getCmp('info_window').setSize(popup_width, popup_height);
																	Ext.getCmp('info_window').center();
																}
																	
																switch (tab.title) {
																	case 'Plot':
																		Ext.getCmp('info_window').setSize(window.innerWidth+1, window.innerHeight+1); 
																		Ext.getCmp('info_window').setSize(window.innerWidth, window.innerHeight);
																		Ext.getCmp('info_window').center();
																		popup_maximized = true;
																	break;
																}
															},
											  }
							}
						],
		listeners:		{
							'close': function() { clearInterval(plot_interval); }
						}
	});

	function getDATA() {
		switch(Ext.getCmp('plot_time').value) {
			case 'Custom':
				start	= new Date (	
										new Date(Ext.getCmp('start_date').value).getFullYear(),
										new Date(Ext.getCmp('start_date').value).getMonth(),
										new Date(Ext.getCmp('start_date').value).getDate(), 
										new Date(Ext.getCmp('start_time').value).getHours(),
										new Date(Ext.getCmp('start_time').value).getMinutes(),
										new Date(Ext.getCmp('start_time').value).getSeconds()
									).getTime();
				end		= new Date (	
										new Date(Ext.getCmp('end_date').value).getFullYear(),
										new Date(Ext.getCmp('end_date').value).getMonth(),
										new Date(Ext.getCmp('end_date').value).getDate(), 
										new Date(Ext.getCmp('end_time').value).getHours(),
										new Date(Ext.getCmp('end_time').value).getMinutes(),
										new Date(Ext.getCmp('end_time').value).getSeconds()
									).getTime();
				break;
			case 'Manual':
				start	= new Date(new Date() - (Ext.getCmp('manual_time_hour').value * 3600 + Ext.getCmp('manual_time_min').value * 60) *  1000).getTime();
				end		= new Date().getTime();
				break;
			default:
				start	= new Date(new Date() - Ext.getCmp('plot_time').value * 1000).getTime();
				end		= new Date().getTime();
		}

		var sel			= grid_AP_panel.getSelectionModel().getSelection();
		var element		= {};
		element.start 	= start;
		element.end 	= end;
		element.ap_num	= sel[0].data.sqlid;
		element.unit	= Ext.getCmp('plot_iface_unit').value;
		element.cl_unit	= Ext.getCmp('plot_clients_unit').value;

		switch(Ext.getCmp('plot_type').value) {
			case 'CPU & Memory':	element.name	= legendSelect[0];
									element.type	= 'CPU';
									break;
			case 'Interfaces':		element.name	= legendSelect[0];
									element.type	= 'Iface';
									break;
			case 'Ethernet ports':	element.name	= legendSelect[0];
									element.type	= 'Port';
									break;
			case 'Clients':			element.sMAC	= legendSelect[0];
									element.sSSID	= legendSelect[1];
									element.type	= 'Clients';
									break;
		}

		// Get SQL data
		clearInterval(plot_interval);
		$.post('/server/get_ap_info_extjs.php?cmd=getAPstatistic', element, 
			function(SQL) {
				if (Ext.getCmp('info_window') !== undefined) {
					prepareDATA(SQL);
					if (Ext.getCmp('plot_time').value != 'Custom')
						plot_interval = setTimeout(getDATA, 10000);
				}
			}
		).error(function () { console.log( ' error loading data ' ) });
		
	}

	function prepareDATA(SQL) {
		if (plot == undefined) {
			plot = $.plot("#plot", JSON.parse(JSON.stringify(SQL)), {
								xaxes:	[ { mode: "time", timezone: "browser", min: start, max: end } ],
								yaxes:	[ { min: (Ext.getCmp('plot_type').value == 'Clients' && Ext.getCmp('plot_clients_unit').value == 'RSSI') ? -100 : 0 } ],
								legend: { show: false },
								grid:	{ hoverable: true, autoHighlight: false },
								colors: c_a,
								series: { lines: { show: true }, points: { show: false } }
			});
			$("#plot").bind("plothover", function (event, pos, item) {
				if (item) 
					switch(Ext.getCmp('plot_type').value) {
						case 'CPU & Memory':	$("#plot_tooltip").html(item.series.label.split('|')[0]).css({top: item.pageY - 80, left: item.pageX - 30}).fadeIn(200);												break;
						case 'Interfaces':		$("#plot_tooltip").html(item.series.label.split('|')[0]).css({top: item.pageY - 80, left: item.pageX - 30}).fadeIn(200);												break;
						case 'Ethernet ports':	$("#plot_tooltip").html(item.series.label.split('|')[0]).css({top: item.pageY - 80, left: item.pageX - 30}).fadeIn(200);												break;
						case 'Clients':			$("#plot_tooltip").html(item.series.label.split('|')[0] + '<br>' + item.series.label.split('|')[5]).css({top: item.pageY - 90, left: item.pageX - 60}).fadeIn(200);		break;
					}
				else 
					$("#plot_tooltip").hide();
			});
		}
		else 
			plot = $.plot("#plot", JSON.parse(JSON.stringify(SQL)), {
				xaxes:	[ { mode: "time", timezone: "browser", min: start, max: end } ],
				yaxes:	[ { min: (Ext.getCmp('plot_type').value == 'Clients' && Ext.getCmp('plot_clients_unit').value == 'RSSI') ? -100 : 0 } ],
				legend: { show: false },
				grid:	{ hoverable: true, autoHighlight: false },
				colors: c_a,
				series: { lines: { show: true }, points: { show: false } }							
			});



		var dataset 	= plot.getData();
		var legendDATA	= [];
		for (var i = 0; i < dataset.length; ++i) {
			var tmp 		= dataset[i].label.split("|");
			element 		= {};
			element.color	= dataset[i].color;
			element.name	= tmp[0];
			element.ap_min	= +tmp[1];
			element.ap_max	= +tmp[2];
			element.ap_avg	= +tmp[3];
			element.ap_last	= +tmp[4];
			element.ssid	= tmp[5];
			element.macbssid= tmp[0]+tmp[5];
			legendDATA.push(element);
		}
		var selection = Ext.getCmp('plot_legend').getSelectionModel().getSelection();
		Ext.getCmp('plot_legend').store.loadData(legendDATA);
		
		legendRestore = true;
		for (var i = 0; i < selection.length; i++) {
			var item = Ext.getCmp('plot_legend').store.find('macbssid', selection[i].data.macbssid);
			Ext.getCmp('plot_legend').getSelectionModel().select(item, true); 
		}
		legendRestore = false;
	}

}