function show_AP_plot() {
	
	var plot;
	var plot_interval;
	var plot_height		= ((window.innerHeight - 170) / 3 * 2).toFixed(0);
	var legend_height	= (window.innerHeight - plot_height - 150);
	var legendSelect	= '';
	var legendRestore	= false;
	var start, end;

	new Ext.window.Window({
		width:			window.innerWidth,
		height:			window.innerHeight,
		title:			'AP Plot',
		id:				'plot_window',
		bodyCls:		'window-plot',
		layout:			{
							type:	'vbox',
							pack:	'start',
							align:	'stretch'
						},
		shadow:			true,
		resizable:		false,
		draggable:		false,
		closable:		true,
		modal:			true,
		autoShow:		true,
		items:			[
							{
								flex:	2,
								id:		'plot_window_div',
								html:	'<div>'+
										'	<div style="width: 100%; height: 100%;">'+
										'		<div style="width: 100%; float: left; margin-right: 0px;">'+
										'			<div id="plot_div" style="height: ' + plot_height + 'px;">'+
										'				<div id="plot" style="width: 100%; height: 100%; text-align: center; padding: 10em 0; color: #B0B0B0;"><h1>Select type of graphics below.</h1></div>'+
										'			</div>'+
										'		</div>'+
										'	</div>' +
										'</div>' +
										'<div id="plot_tooltip" style="position: absolute; display: none; border: 1px solid #fdd; padding: 2px; background-color: #fee; opacity: 0.80;"></div>',
							},
							{
								flex:			1,
								xtype:			'grid',
								autoScroll:		true,
								height:			legend_height,		// top + bottom + header
								id:				'plot_legend',
								store:			{
													fields:	[
																{	name: 'ap_color',	type: 'string'	},
																{	name: 'ap_ip',		type: 'string'	},
																{	name: 'ap_min',		type: 'float'	},
																{	name: 'ap_max',		type: 'float'	},
																{	name: 'ap_avg',		type: 'float'	},
																{	name: 'ap_last',	type: 'float'	},
																{	name: 'ap_num',		type: 'int'		},
															]											
												},
								viewConfig:		{
													enableTextSelection:	true,
													loadMask:				false,
												},
								columns: 		[
													{	text: '#',				align: 'center',			flex: 5 / 100,	
														renderer: 	function (value, meta, record, rowIndex) {
																		meta.style = "background-color:" + record.data.ap_color + ";";
																		return record.data.ap_num;
																	}
													},
													{	text: 'Hostname (IP)',	dataIndex: 'ap_ip',			flex: 55 / 100	},
													{	text: 'MBit/sec.',		minWidth: 110,	id: 'plot_legend_unit',	flex: 40 / 100,
														columns:	[
																		{	text: 'Min',	dataIndex: 'ap_min',	minWidth: 50,	flex: 10 / 100,	align: 'center'	},
																		{	text: 'Max',	dataIndex: 'ap_max',	minWidth: 60,	flex: 10 / 100,	align: 'center'	},
																		{	text: 'Avg',	dataIndex: 'ap_avg',	minWidth: 60,	flex: 10 / 100,	align: 'center'	},
																		{	text: 'Last',	dataIndex: 'ap_last',	minWidth: 60,	flex: 10 / 100,	align: 'center'	}
																	]
													}
												],
								listeners:		{
													select:		function() {
																	if (!legendRestore) {
																		var sel = Ext.getCmp('plot_legend').getSelectionModel().getSelection();
																		legendSelect = sel[0].data.ap_ip;
																		clearTimeout(plot_interval);
																		getDATA();
																	}
																},
												}
							},
							{
								height:		80,
								xtype:		'fieldset',
								cls:		'window-plot',
								title:		'Plot',
								margin:		'10 10 10 10',
								items: 		[
												{
													xtype:			'fieldcontainer',
													name:			'plot_time',
													fieldLabel:		'Time',
													layout: 		'hbox',
													items:			[ 
																		{
																			xtype:			'combo',
																			id:				'plot_time',
																			store:			{
																								fields: 	[ 'name', 'value' ],
																								data: 		[
																												{ name: '2M',			value: 120		},
																												{ name: '5M',			value: 300		},
																												{ name: '10M',			value: 600		},
																												{ name: '15M',			value: 900		},
																												{ name: '30M',			value: 1800		},
																												{ name: '1H',			value: 3600		},
																												{ name: '2H',			value: 7200		},
																												{ name: '3H',			value: 10800	},
																												{ name: '6H',			value: 21600	},
																												{ name: '12H',			value: 43200	},
																												{ name: '24H',			value: 86400	},
																												{ name: 'Manual',		value: 'Manual'	},
																												{ name: 'Custom range',	value: 'Custom'	},
																											]
																							},
																			editable:		false,
																			displayField:	'name',
																			valueField:		'value',
																			value:			600,
																			margin:			'0 20 5 0',
																			listeners:		{
																								'select':	function(el) {
																												Ext.getCmp('start_date').hide();
																												Ext.getCmp('start_time').hide();
																												Ext.getCmp('time_separator').hide();
																												Ext.getCmp('end_date').hide();
																												Ext.getCmp('end_time').hide();
																												Ext.getCmp('manual_time_hour').hide();
																												Ext.getCmp('manual_time_separator').hide();
																												Ext.getCmp('manual_time_min').hide();
																												if (el.value == 'Custom') {
																													Ext.getCmp('start_date').show();
																													Ext.getCmp('start_time').show();
																													Ext.getCmp('time_separator').show();
																													Ext.getCmp('end_date').show();
																													Ext.getCmp('end_time').show();
																												}
																												else if (el.value == 'Manual') {
																													Ext.getCmp('manual_time_hour').show();
																													Ext.getCmp('manual_time_separator').show();
																													Ext.getCmp('manual_time_min').show();
																												}
																											}
																							}
																		},
																		{ xtype: 'datefield',		id: 'start_date',			name: 'start_date',			margin: '0 5 0 0',		editable: false, 	width: 100, 	hidden: true, 	value: new Date() 											},
																		{ xtype: 'timefield',		id:	'start_time',			name: 'start_time',			margin:	'0 5 0 0',		format:	'H:i',		width: 70,		hidden:	true,	value: new Date(new Date() - 600000)					 	},
																		{ xtype: 'displayfield',	id:	'time_separator',									margin:	'0 5 0 0',											hidden: true,	value: '-'													},
																		{ xtype: 'datefield',		id: 'end_date',				name: 'end_date',			margin:	'0 5 0 0',		editable: false,	width: 100,		hidden: true,	value: new Date()											},
																		{ xtype: 'timefield',		id:	'end_time',				name: 'end_time',			format:	'H:i',								width: 70,		hidden: true,	value: new Date()											},
																		{ xtype: 'numberfield',		id:	'manual_time_hour',		name: 'manual_time_hour',	margin:	'0 5 0 0',		fieldLabel: 'H:M',	width: 70,		hidden: true,	value: 1,	minValue: 0,	maxValue: 72,	labelWidth: 25	},
																		{ xtype: 'displayfield',	id: 'manual_time_separator', 							margin: '0 5 0 0',											hidden: true,	value: ':'													},
																		{ xtype: 'numberfield',		id: 'manual_time_min',		name: 'manual_time_min',												width: 40,		hidden: true,	value: 0,	minValue: 0,	maxValue: 59					},
																	]
												},
												{
													xtype:			'fieldcontainer',
													name:			'plot_type',
													fieldLabel: 	'Type',
													layout: 		'hbox',
													items:			[ 
																		{
																			xtype:			'combo',
																			store:			{
																								fields: 	[ 'name', 'value' ],
																								data: 		[
																												{ name: 'WiFi Bandwidth',	value: 'WiFi Bandwidth'	},
																												{ name: 'Clients',			value: 'Clients'		}
																											]
																							},
																			editable:		false,
																			displayField:	'name',
																			valueField:		'value',
																			value:			'WiFi Bandwidth',
																			id:				'plot_type',
																			margin:			'0 20 0 0',
																			listeners:		{
																								'select':	function(el) {
																												if (el.value == 'Clients')
																													Ext.ComponentManager.get('plot_legend_unit').setText('Clients');
																												else
																													Ext.ComponentManager.get('plot_legend_unit').setText('Mbit/sec.');
																											}
																							}
																		},
																		{
																			xtype:			'combo',
																			store:			{
																								fields: 	[ 'name', 'value' ],
																								data: 		[
																												{ name: '2.4GHz',				value: '2.4GHz'					},
																												{ name: '5GHz',					value: '5GHz'					},
																												{ name: 'Both (2.4GHz + 5GHz)',	value: 'Both (2.4GHz + 5GHz)'	}
																											]
																							},
																			editable:		false,
																			displayField:	'name',
																			valueField:		'value',
																			id:				'plot_band',
																			value:			'Both (2.4GHz + 5GHz)',
																		}
																	],
												},
								]
							}
						],
		buttons:		[
							{	text: 'Plot',	handler: function() { clearInterval(plot_interval); getDATA(); }	},
							{ 	text: 'Close',	handler: function() { Ext.getCmp('plot_window').close(); }			}
						],
		listeners:		{
							'close':	function() { clearInterval(plot_interval); if (plot !== undefined) plot.destroy(); }
						}
	});

	function getDATA() {
		switch(Ext.getCmp('plot_time').value) {
			case 'Custom':
				start	= new Date (	
										new Date(Ext.getCmp('start_date').value).getFullYear(),
										new Date(Ext.getCmp('start_date').value).getMonth(),
										new Date(Ext.getCmp('start_date').value).getDate(), 
										new Date(Ext.getCmp('start_time').value).getHours(),
										new Date(Ext.getCmp('start_time').value).getMinutes(),
										new Date(Ext.getCmp('start_time').value).getSeconds()
									).getTime();
				end		= new Date (	
										new Date(Ext.getCmp('end_date').value).getFullYear(),
										new Date(Ext.getCmp('end_date').value).getMonth(),
										new Date(Ext.getCmp('end_date').value).getDate(), 
										new Date(Ext.getCmp('end_time').value).getHours(),
										new Date(Ext.getCmp('end_time').value).getMinutes(),
										new Date(Ext.getCmp('end_time').value).getSeconds()
									).getTime();
				break;
			case 'Manual':
				start	= new Date(new Date() - (Ext.getCmp('manual_time_hour').value * 3600 + Ext.getCmp('manual_time_min').value * 60) *  1000).getTime();
				end		= new Date().getTime();
				break;
			default:
				start	= new Date(new Date() - Ext.getCmp('plot_time').value * 1000).getTime();
				end		= new Date().getTime();
		}

		var server_url	= (Ext.getCmp('plot_type').value == 'WiFi Bandwidth') ? '/server/get_ap_plot_bw.php' : '/server/get_ap_plot_clients.php';
		var sel			= grid_AP_panel.getSelectionModel().getSelection();
		var element		= {};
		element.start 	= start;
		element.end 	= end;
		element.band	= Ext.getCmp('plot_band').value;
		element.AP		= [];
		element.sAP		= legendSelect;
		for (var i = 0; i < sel.length; i++)
			if (sel[i].data.state == 'up')
				element.AP.push(sel[i].data.sqlid);
		
		clearInterval(plot_interval);
		$.post(server_url, element, 
			function(SQL) {
				if (Ext.getCmp('plot_window') !== undefined) {
					prepareDATA(SQL);
					if (Ext.getCmp('plot_time').value != 'Custom')
						plot_interval = setTimeout(getDATA, 10000);
				}
		});	
	}

	function prepareDATA(SQL) {
		if (plot == undefined) {
			plot = $.plot("#plot", JSON.parse(JSON.stringify(SQL)), {
								xaxes:	[ { mode: "time", timezone: "browser", min: start, max: end } ],
								yaxes:	[ { min: 0 } ],
								legend: { show: false },
								grid:	{ hoverable: true, autoHighlight: false },
								colors: c_a,
								series: { lines: { show: true }, points: { show: false } }
			});
			$("#plot").bind("plothover", function (event, pos, item) {
				if (item) {
					$("#plot_tooltip").html(item.series.label.split('|')[0])
						.css({top: item.pageY - 50, left: item.pageX - 60})
						.fadeIn(200);
				} else {
					$("#plot_tooltip").hide();
				}
			});
		}
		else {
			plot = $.plot("#plot", JSON.parse(JSON.stringify(SQL)), {
								xaxes:	[ { mode: "time", timezone: "browser", min: start, max: end } ],
								yaxes:	[ { min: 0 } ],
								legend: { show: false },
								grid:	{ hoverable: true, autoHighlight: false },
								colors: c_a,
								series: { lines: { show: true }, points: { show: false } }
			});
		}

		var dataset 	= plot.getData();
		var legendDATA	= [];
		for (var i = 0; i < dataset.length; ++i) {
			var tmp 		= dataset[i].label.split("|");
			element 		= {};
			element.ap_color= dataset[i].color;
			element.ap_ip	= tmp[0];
			element.ap_min	= +tmp[1];
			element.ap_max	= +tmp[2];
			element.ap_avg	= +tmp[3];
			element.ap_last	= +tmp[4];
			element.ap_num	= +tmp[5];
			legendDATA.push(element);
		}
		var selection = Ext.getCmp('plot_legend').getSelectionModel().getSelection();
		Ext.getCmp('plot_legend').store.loadData(legendDATA);
		
		legendRestore = true;
		for (var i = 0; i < selection.length; i++) {
			var item = Ext.getCmp('plot_legend').store.find('ap_ip', selection[i].data.ap_ip);
			Ext.getCmp('plot_legend').getSelectionModel().select(item, true); 
		}
		legendRestore = false;
	}
}
