var grid_Clients_panel = Ext.create('Ext.grid.Panel', {
//		type:				'big-data-grid',
        height:				center_panel_Height,
        store:				{
								autoLoad: 		false,
								remoteFilter:	true,
								remoteSort:		true,
								pageSize:		1000,
								fields: 		[
													{	name: 'sta_mac',				type: 'string'	},
													{	name: 'sta_vendor',				type: 'string'	},
													{	name: 'ap_host',				type: 'string'	},
													{	name: 'ap_ssid',				type: 'string'	},
													{	name: 'sta_band',				type: 'string'	},
													{	name: 'sta_conn_time',			type: 'string'	},
													{	name: 'sta_psm',				type: 'string'	},
													{	name: 'sta_mimops',				type: 'string'	},
													{	name: 'sta_mcs',				type: 'string'	},
													{	name: 'sta_bw',					type: 'string'	},
													{	name: 'sta_sgi',				type: 'string'	},
													{	name: 'sta_stbc',				type: 'string'	},
													{	name: 'sta_ldpc',				type: 'string'	},
													{	name: 'sta_mode',				type: 'string'	},
													{	name: 'sta_tx_rate',			type: 'string'	},
													{	name: 'sta_rssi',				type: 'string'	},
													{	name: 'sta_quality',			type: 'string'	},
													{	name: 'sta_rxtx_bytes',			type: 'string'	}
												],
								proxy: 			{
													type:			'ajax',
													url:			'/server/get_clients_extjs.php',
													actionMethods:	{
																		create:		'POST',
																		read:		'POST',
																		update:		'POST',
																		destroy:	'POST'
																	},
													reader:			{
																		type:		'json',
																		root:		'records'
																	}
												}			
							},
		dockedItems:		[
								{
									dock:	'top',
									xtype:	'toolbar',
									items:	[
												// Filter text field
												{
													width:			200,
													xtype:			'textfield',
													id:				'clients_filter_field',
													listeners: 		{
																		specialkey:	function(f, e) {
																						if(e.getKey() == e.ENTER){
																						Ext.getCmp('clients_filter_button').click();
																					}
																	}
													}
												},
												// Filter button
												{
													text:			'Filter',
													tooltip:		'Filter clients',
													id:				'clients_filter_button',
													glyph:			'f0b0@FontAwesome',
													handler:		function() {
																		grid_Clients_panel.store.filter({
																			property		: 'filter',
																			value			: Ext.getCmp('clients_filter_field').getValue(),
																			anyMatch		: false,
																			caseSensitive	: false
																		});
																		clearInterval(clients_interval);
																		loadClientsgridDATA();
																	}
												},
												{
													text:			'Clear',
													tooltip:		'Clear filter',
													id:				'clients_clear_button',
													glyph:			'f00d@FontAwesome',
													handler:		function() {
																		Ext.getCmp('clients_filter_field').setValue('');
																		Ext.getCmp('clients_filter_button').click();
																	}
												},

												{ xtype: 'tbseparator' },
												// Info button
												{
													text:			'Info',
													tooltip:		'Show client info',
													id:				'clients_info_button',
													glyph:			'f05a@FontAwesome',
													disabled:		true,
													handler:		function() {
																		var sel = grid_Clients_panel.getSelectionModel().getSelection();
																		showClientsInfo(sel[0].data.sta_mac.replace(/<span class="x-item-selected">/g, '').replace(/<\/span>/g, ''));
																	}
												},
												// Plot button
												{
													text:			'Plot',
													tooltip:		'Plot clients',
													id:				'clients_plot_button',
													glyph:			'f1fe@FontAwesome',
													disabled:		true,
													handler:		function() {
																		var selectAll = grid_Clients_panel.store.data.length > 0 && grid_Clients_panel.getSelectionModel().getSelection().length >= grid_Clients_panel.store.data.length;
																		if (selectAll) {
																			arr = 'ALL';
																		}
																		else {
																			var sel = grid_Clients_panel.getSelectionModel().getSelection();
																			var arr = [];
																			for (var i = 0; i < sel.length; i++)
																				arr.push(sel[i].data.sta_mac.replace(/<span class="x-item-selected">/g, '').replace(/<\/span>/g, ''));
																		}
																		show_Clients_plot(arr);
																	}
												},
												// Plot button
												{
													text:			'Drop',
													tooltip:		'Drop clients',
													id:				'clients_drop_button',
													glyph:			'f00d@FontAwesome',
													disabled:		true,
													handler:		function() {
																		var sel = grid_Clients_panel.getSelectionModel().getSelection();
																		Ext.MessageBox.show({
																			title:		'Drop clients',
																			msg:		'The selected clients will be droped',
																			buttons:	Ext.MessageBox.OK,
																		});
																		for (var i = 0; i < sel.length; i++)
																			dropClient(sel[i].data.client_id, sel[i].data.sta_mac, sel[i].data.sta_band);
																	}
												}
											],
								}
							],
				viewConfig: {
								preserveScrollOnReload:		true,
								enableTextSelection:		true,
								loadMask:					false,
								getRowClass: 				function(record, rowIndex, rowParams, store) {
																return (record.get('sta_band') === '5GHz') ? 'band_5ghz' : '';
															}
							},
				selModel: 	{
								type:			'checkboxmodel',
								checkOnly:		false
							},
				actions:	{
								drop: {
									iconCls:	'cell-editing-delete-row',
									tooltip:	'Drop client',
									handler:	function(view, recIndex, cellIndex, item, e, record) {
													Ext.MessageBox.show({
														title:		'Drop client',
														msg:		'The client ' + record.data.sta_mac.replace(/<span class="x-item-selected">/g, '').replace(/<\/span>/g, '') + ' will be droped',
														buttons:	Ext.MessageBox.OK,
													});
													dropClient(record.data.client_id, record.data.sta_mac, record.data.sta_band);
												}
								},
							},
				columns: 	[	
								{	text: 'MAC',			dataIndex: 'sta_mac',			flex: 15 / 100,		minWidth: 120,	locked: true,		tooltip: 'Client MAC address'					},
								{	sortable:	false,
									draggable:	false,
									resizable:	false,
									locked:		true,
									width:		20,
									xtype:		'actioncolumn',
									items:		[ '@drop' ]
								},
								{	text: 'Vendor',			dataIndex: 'sta_vendor',		flex: 12 / 100,		minWidth: 200,						tooltip: 'Client Vendor'						},
								{	text: 'AP',				dataIndex: 'ap_host',			flex: 15 / 100,		minWidth: 150,						tooltip: 'Access Point where client connected'	},
								{	text: 'SSID (BSSID)',	dataIndex: 'ap_ssid',			flex: 11 / 100,		minWidth: 150,	align: 'center',	tooltip: 'SSID where client connected'			},
								{	text: 'BAND',			dataIndex: 'sta_band',			flex: 3 / 100,		minWidth: 50,	align: 'center',	tooltip: 'Client wireless band'					},
								{	text: 'Conn. Time',		dataIndex: 'sta_conn_time',		flex: 5 / 100,		minWidth: 75,	align: 'center',	tooltip: 'Client connection time'				},
								{	text: 'PSM',			dataIndex: 'sta_psm',			flex: 3 / 100,		minWidth: 50,	align: 'center',	tooltip: 'Power Saving Mode'					},
								{	text: 'MIMO PS',		dataIndex: 'sta_mimops',		flex: 3 / 100,		minWidth: 70,	align: 'center',	tooltip: 'MIMO Power Saving'					},
								{	text: 'MCS',			dataIndex: 'sta_mcs',			flex: 3 / 100,		minWidth: 50,	align: 'center',	tooltip: 'Modulation and Coding Scheme'			},
								{	text: 'BW',				dataIndex: 'sta_bw',			flex: 3 / 100,		minWidth: 50,	align: 'center',	tooltip: 'Bandwidth'							},
								{	text: 'SGI',			dataIndex: 'sta_sgi',			flex: 3 / 100,		minWidth: 50,	align: 'center',	tooltip: 'Short Guard Interval'					},
								{	text: 'STBC',			dataIndex: 'sta_stbc',			flex: 3 / 100,		minWidth: 50,	align: 'center',	tooltip: 'Space–time block code', hidden: true	},
								{	text: 'LDPC',			dataIndex: 'sta_ldpc',			flex: 3 / 100,		minWidth: 50,	align: 'center',	tooltip: 'Low-density parity-check code'		},
								{	text: 'MODE',			dataIndex: 'sta_mode',			flex: 3 / 100,		minWidth: 50,	align: 'center',	tooltip: 'Client Mode'							},
								{	text: 'RATE',			dataIndex: 'sta_tx_rate',		flex: 3 / 100,		minWidth: 50,	align: 'center',	tooltip: 'Client rate'							},
								{	text: 'RSSI',			dataIndex: 'sta_rssi',			flex: 5 / 100,		minWidth: 50,	align: 'center',	tooltip: 'Received Signal Strength Indicator'	},
								{	text: 'QUALITY',		dataIndex: 'sta_quality',		flex: 5 / 100,		minWidth: 80,	align: 'center',	tooltip: 'Signal quality'						},
								{	text: 'RX/TX',			dataIndex: 'sta_rxtx_bytes',	flex: 5 / 100,		minWidth: 80,	align: 'center',	tooltip: 'Session RX / TX bytes'				},
							],
				bbar:		{
								style: 'background-color: #d7efcd;',
								items: 	[
											{
												width:	'100%',
												xtype:	'label',
												id:		'summary_clients',
											}
										]
							},
				listeners:	{
								afterrender:		function () {
														loadClientsgridDATA();
													},
								itemdblclick:		function(dv, record, item, index, e) {
														showClientsInfo(record.data.sta_mac.replace(/<span class="x-item-selected">/g, '').replace(/<\/span>/g, ''));
													},
								selectionChange:	function (view, selections, options) {
														if (selections.length == 1)
															Ext.getCmp('clients_info_button').enable();
														else 
															Ext.getCmp('clients_info_button').disable();

														if (selections.length > 0) {
															Ext.getCmp('clients_plot_button').enable();
															Ext.getCmp('clients_drop_button').enable();
														}
														else {
															Ext.getCmp('clients_plot_button').disable();
															Ext.getCmp('clients_drop_button').disable();
														}
													},
				}
});

// Drop client from AP
function dropClient(id, mac, band) {
	element			= {}
	element.id		= id;
	element.band	= (band.replace(/<span class="x-item-selected">/g, '').replace(/<\/span>/g, '') == '5GHz') ? '5' : '2.4';
	element.mac		= mac.replace(/<span class="x-item-selected">/g, '').replace(/<\/span>/g, '');

	$.post('/server/set_disconnect_client.php', element)
		.done(function(data) {
			var result = JSON.parse(JSON.stringify(data));
			if (result.state != 'done') {
					Ext.MessageBox.show({
						title:		'Dropping client error!',
						msg:		element.mac + ' status: ' + result.state,
						buttons:	Ext.MessageBox.OK,
					});
			}
			else {
				clearInterval(clients_interval);
				loadClientsgridDATA();
			}
		})
		.fail(function() {
			Ext.MessageBox.show({
				title:		'Dropping client error!',
				msg:		element.mac + ' status: ajax fail',
				buttons:	Ext.MessageBox.OK,
			});
		});	
}

function loadClientsgridDATA() {
	// Save selected items before reload data
	var selectAll = grid_Clients_panel.store.data.length > 0 && grid_Clients_panel.getSelectionModel().getSelection().length >= grid_Clients_panel.store.data.length;
	var selection = grid_Clients_panel.getSelectionModel().getSelection();
	grid_Clients_panel.store.load({
		callback:	function(records, operation, success) {
						if (success) {
							if (records.length > 0)
								Ext.getCmp('summary_clients').setHtml(	'<div>' +
																		'	<div style="width: 80px; float: left">Total Clients:</div>' + 
																		'<div style="float: left;">' + records[0].data.sta_total + ' (2.4GHz: ' + records[0].data.sta_24 + ', 5GHz: ' + records[0].data.sta_5 + ')</div><br clear="all">' +
																		'</div>'
																	);
							else
								Ext.getCmp('summary_clients').setHtml(	'<div>' +
																		'	<div style="width: 80px; float: left">Total Clients:</div><div style="float: left;">0 (2.4GHz: 0, 5GHz: 0)</div><br clear="all">' +
																		'</div>'
																	);

							// Restore selected items
							if (selectAll)
								grid_Clients_panel.getSelectionModel().selectAll();
							else 
								for (i = 0; i < selection.length; i++) {
									var item = grid_Clients_panel.store.find('sta_mac', selection[i].data.sta_mac);
									grid_Clients_panel.getSelectionModel().select(item, true); 
								}
						}
					}
	});
	clients_interval = setTimeout('loadClientsgridDATA();', 5000);
}