function showClientsInfo(mac) {
	var interval;

	new Ext.window.Window({
		width:			(window.innerWidth >= 700) ? 700 : window.innerWidth,
		height:			(window.innerHeight >= 394) ? 394 : window.innerHeight,
		title:			'Client ' + mac + ' info',
		id:				'info_client_window',
		shadow:			true,
		resizable:		false,
		draggable:		false,
		closable:		true,
		autoShow:		true,
		modal:			true,
		items:			[
							{
								xtype:		'grid',
								id:			'info_client_grid',
								height:		360,
								store:		{
												fields: 		[
																	{	name: 'name',		type: 'string'	},
																	{	name: 'value',		type: 'string'	}
																],
												proxy: 			{
																	type:			'ajax',
																	actionMethods:	{
																						create:		'POST',
																						read:		'POST',
																						update:		'POST',
																						destroy:	'POST'
																					},
																	reader:			{ type:	'json' }
																}
											},
								viewConfig:	{
												enableTextSelection:	true,
												loadMask:				false,
											},
								columns: 	[	
												{	dataIndex: 'name',		align: 'right',	tdCls: 'value-column', flex: 40 / 100	}, 
												{	dataIndex: 'value',		flex: 60 / 100											}
											],
								listeners:	{
												'afterrender':	function() {
													loadDATA();
												}
											}
							}
						],
		listeners:		{
							'close':	function() { clearInterval(interval); }
						}
	});
	
	function loadDATA() {
		Ext.getCmp('info_client_grid').store.load( { params: { 'mac': mac }, url: '/server/get_clients_info.php' } );
		interval = setTimeout(loadDATA, 3000);
	}
}