var need_reboot = false;

var settings_tabpanel = new Ext.Panel({
	height:		center_panel_Height,
	layout:		'column',
	items:		[ 
					{
						xtype:			'grid',
						id:				'edit_AP_list_grid',
						height:			center_panel_Height,		// size - header
						scrollable:		true,
						border:			true,
						columnWidth:	0.6,
						x:				-1,
						y:				-1,
						store:			{
											fields: 		[
																{	name: 'id',			type: 'string'	},
																{	name: 'host',		type: 'string'	},
																{	name: 'port',		type: 'int'		},
																{	name: 'login',		type: 'string'	},
																{	name: 'last',		type: 'string'	},
																{	name: 'password',	type: 'string'	},
																{	name: 'hostname',	type: 'string'	}
															],
											autoLoad: 		false,
											remoteFilter:	true,
											remoteSort:		false,
											proxy: 			{
																type:			'ajax',
																url: 			'/server/get_settings.php?cmd=getAPlist',
																actionMethods:	{
																					create:		'POST',
																					read:		'POST',
																					update: 	'POST',
																					destroy:	'POST'
																				},
																reader:			{	type:		'json'	}
															}
						},
						dockedItems:		[
												{
													dock:	'top',
													xtype:	'toolbar',
													items:	[
																// Filter text field
																{
																	width:			200,
																	xtype:			'textfield',
																	id:				'editAPlist_filter_field',
																	listeners: 		{
																						specialkey:	function(f, e) {
																										if(e.getKey() == e.ENTER){
																										Ext.getCmp('editAPlist_filter_button').click();
																									}
																					}
																	}
																},
																// Filter button
																{
																	text:			'Filter',
																	id:				'editAPlist_filter_button',
																	glyph:			'f0b0@FontAwesome',
																	handler:		function() {
																									Ext.getCmp('edit_AP_list_grid').store.filter({
																										property		: 'filter',
																										value			: Ext.getCmp('editAPlist_filter_field').getValue(),
																										anyMatch		: true,
																										caseSensitive	: false
																									});
																									//loadSettingsDATA();
																					}
																},
																{
																	text:			'Clear',
																	id:				'editAPlist_clear_button',
																	glyph:			'f00d@FontAwesome',
																	handler:		function() {
																									Ext.getCmp('editAPlist_filter_field').setValue('');
																									Ext.getCmp('editAPlist_filter_button').click();
																					}
																},
																{ xtype: 'tbseparator' },
																// Add New button
																{
																	text:			'Add New',
																	id:				'editAPlist_addNew_button',
																	glyph:			'f067@FontAwesome',
																	handler:		function() {
																						edit_AP_list_addNew();
																					}
																},
																// Edit button
																{
																	text:			'Edit',
																	id:				'editAPlist_Edit_button',
																	glyph:			'f040@FontAwesome',
																	disabled:		true,
																	handler:		function() {
																						edit_AP_list_Edit(Ext.getCmp('edit_AP_list_grid').getSelectionModel().getSelection()[0].data);
																					}
																},
																// Delete button
																{
																	text:			'Delete',
																	id:				'editAPlist_Delete_button',
																	glyph:			'f00d@FontAwesome',
																	disabled:		true,
																	handler:		function() {
																						var sel 	= Ext.getCmp('edit_AP_list_grid').getSelectionModel().getSelection();
																						Ext.MessageBox.confirm('Delete', 'Are you sure to delete<br>' + sel[0].data.host + ':' + sel[0].data.port + '?', function(btn){
																							if(btn === 'yes') {
																								var element	= {};
																								element.id	= sel[0].data.id;
																								$.post('/server/get_settings.php?cmd=deleteAP', element, 
																									function(data) {
																										// refresh grid
																										loadSettingsDATA();
																									}
																								);
																							}
																						});
																					}
																}
															],
												}
											],
						viewConfig:		{
											enableTextSelection:	true,
											loadMask:				false,
										},
						columns: 		[
											{	xtype: 'rownumberer'										},
											{	text: 'Hostname',	dataIndex: 'hostname',	flex: 20 / 100	},
											{	text: 'Host / IP',	dataIndex: 'host',		flex: 20 / 100	}, 
											{	text: 'Port',		dataIndex: 'port', 		flex: 20 / 100	},
											{	text: 'Login',		dataIndex: 'login', 	flex: 20 / 100	},
											{	text: 'Last Data',	dataIndex: 'last',	 	flex: 20 / 100	},
										],
						listeners:		{
											afterrender:		function () {
																	loadSettingsDATA();
																	Ext.getCmp('edit_AP_list_grid').columnWidth = 1;
																	Ext.getCmp('edit_AP_settings_panel').hide();
																	settings_tabpanel.updateLayout();
																},
											selectionChange:	function (view, selections, options) {
																	if (selections.length == 1) {
																		Ext.getCmp('editAPlist_Edit_button').enable();
																		Ext.getCmp('editAPlist_Delete_button').enable();
																		Ext.getCmp('edit_AP_settings_panel').show();

																		Ext.getCmp('edit_AP_list_grid').columnWidth = 0.7;
																		Ext.getCmp('edit_AP_settings_panel').columnWidth = 0.3;
																		settings_tabpanel.updateLayout();
																		
																		showAPsettings(selections[0].data);
																	}
																	else {
																		Ext.getCmp('editAPlist_Edit_button').disable();
																		Ext.getCmp('editAPlist_Delete_button').disable();
																		Ext.getCmp('edit_AP_settings_panel').hide();

																		Ext.getCmp('edit_AP_list_grid').columnWidth = 1;
																		Ext.getCmp('edit_AP_settings_panel').hide();
																		settings_tabpanel.updateLayout();
																	}
																},
										}
					},
					{
						xtype:			'panel',
						title:			'Settings',
						id:				'edit_AP_settings_panel',
						columnWidth:	0.4,
						autoScroll:		true,
						border:			false,
						height:			center_panel_Height - 5,
						items: 			[
											{
												xtype:			'panel',
												margin: 		'5 5 5 5',
												border:			false,
												defaults:		{
																	allowBlank:		false,
																	labelWidth:		100,
																	bodyPadding:	10
																},
												layout:			{
																	type:			'accordion',
																	titleCollapse:	true,
																	animate:		true,
																	activeOnTop:	false
																},
												id:				'edit_AP_settings_panel_accrodion',
												height:			center_panel_Height - 90,
												items:			[
																	{
																		title:		'General',
																		items:		[	
																						{
																							xtype:			'fieldcontainer',
																							fieldLabel:		'Mode',
																							items:			[ 
																												{
																													xtype:			'combo',
																													id:				'ap_mode',
																													store:			{
																																		fields: 	[ 'name', 'value' ],
																																		data: 		[
																																						{ name: 'AP-Bridge',			value: 'AP-Bridge'			},
																																						{ name: 'AP-Gateway',			value: 'AP-Gateway'			},
																																						{ name: 'Client-Gateway',		value: 'Client-Gateway'		},
																																						{ name: 'Client-AP-Gateway',	value: 'Client-AP-Gateway'	}
																																					]
																																	},
																													editable:		false,
																													displayField:	'name',
																													valueField:		'value',
																													value:			'AP-Bridge',
																													width:			'100%',
																													listeners:		{
																																		'change':	function() { need_reboot = true; },
																																		'select':	function(el) {
																																						if (el.value == 'AP-Bridge') {
																																							Ext.getCmp('edit_AP_settings_panel_accrodion_wan').disable();
																																							Ext.getCmp('edit_AP_settings_panel_accrodion_ipv6').disable();
																																						}
																																						else {
																																							Ext.getCmp('edit_AP_settings_panel_accrodion_wan').enable();
																																							Ext.getCmp('edit_AP_settings_panel_accrodion_ipv6').enable();
																																						}
																																					}
																																	}
																												}
																											]
																						}
																					]
																	},
																	{
																		title:		'LAN',
																		id:			'edit_AP_settings_panel_accrodion_lan',
																		items:		[	
																						{	xtype: 'textfield',		fieldLabel: 'Hostname',		id: 'lan_hostname',		width: '100%',		allowBlank: false	},
																						{	xtype: 'textfield',		fieldLabel: 'IP',			id: 'lan_ip',			width: '100%',		allowBlank: false	},
																						{	xtype: 'textfield',		fieldLabel: 'Netmask',		id: 'lan_netmask',		width: '100%',		allowBlank: false	},
																						{	xtype: 'textfield',		fieldLabel: 'Gateway',		id: 'lan_gateway',		width: '100%',		allowBlank: false	},
																						{	xtype: 'textfield',		fieldLabel: 'Primary DNS',	id: 'lan_dns_primary',	width: '100%',		allowBlank: false	},
																						{	xtype: 'textfield',		fieldLabel: 'Secondary DNS',id: 'lan_dns_secondary',width: '100%',		allowBlank: true	}
																					]
																	},
																	{
																		title:		'WAN',
																		id:			'edit_AP_settings_panel_accrodion_wan',
																		items:		[
																						{
																							xtype:			'combo',
																							store:			{
																												fields: 	[ 'name', 'value' ],
																												data: 		[
																																{ name: 'DHCP (Auto Config)',	value: 'DHCP'		},
																																{ name: 'STATIC (Fixed IP)',	value: 'STATIC'		},
																																{ name: 'Zeroconf',				value: 'ZEROCONF'	}
																															]
																											},
																							editable:		false,
																							displayField:	'name',
																							valueField:		'value',
																							value:			'static',
																							id:				'wan_mode',
																							fieldLabel:		'Mode',
																							width:			'100%',
																							listeners:		{
																												'select':	function(el) {
																																if (el.value == 'STATIC') {
																																	Ext.getCmp('wan_ip').show();
																																	Ext.getCmp('wan_netmask').show();
																																	Ext.getCmp('wan_gateway').show();
																																	Ext.getCmp('wan_dns_static').disable();
																																}
																																else {
																																	Ext.getCmp('wan_ip').hide();
																																	Ext.getCmp('wan_netmask').hide();
																																	Ext.getCmp('wan_gateway').hide();
																																	Ext.getCmp('wan_dns_static').enable();
																																	Ext.getCmp('wan_dns_static').setValue(0);
																																}
																															}
																											}
																						},
																						{	xtype: 'textfield',		fieldLabel: 'MAC',			id: 'wan_mac',			width: '100%',		allowBlank: false,	editable: false,	},
																						{	xtype: 'textfield',		fieldLabel: 'IP',			id: 'wan_ip',			width: '100%',		allowBlank: false	},
																						{	xtype: 'textfield',		fieldLabel: 'Netmask',		id: 'wan_netmask',		width: '100%',		allowBlank: false	},
																						{	xtype: 'textfield',		fieldLabel: 'Gateway',		id: 'wan_gateway',		width: '100%',		allowBlank: false	},
																						{	xtype: 'checkboxfield',	fieldLabel: 'Static DNS',	id: 'wan_dns_static',
																							listeners:	{
																											'change':	function(el) {
																															need_reboot = true;
																															if (el.value == 1) {
																																Ext.getCmp('wan_dns_primary').show();
																																Ext.getCmp('wan_dns_secondary').show();
																															}
																															else {
																																Ext.getCmp('wan_dns_primary').hide();
																																Ext.getCmp('wan_dns_secondary').hide();
																															}
																														}
																										}
																						},
																						{	xtype: 'textfield',		fieldLabel: 'Primary DNS',		id: 'wan_dns_primary',		width: '100%',		allowBlank: false,
																							listeners: { 'change':	function() { need_reboot = true; } }
																						},
																						{	xtype: 'textfield',		fieldLabel: 'Secondary DNS',	id: 'wan_dns_secondary',	width: '100%',		allowBlank: false,
																							listeners: { 'change':	function() { need_reboot = true; } }
																						},
																						{	xtype: 'checkboxfield',	fieldLabel: 'Enable NAT',		id: 'wan_nat',														}
																					]
																	},
																	{
																		title:		'IPv6',
																		id:			'edit_AP_settings_panel_accrodion_ipv6',
																		items:		[
																						{
																							xtype:			'combo',
																							store:			{
																												fields: 	[ 'name', 'value' ],
																												data: 		[
																																{ name: 'Disabled',								value: 'disabled'	},
																																{ name: 'Native dynamic/static IP connection',	value: 'native'	},
																																{ name: 'Tunneling connection (6TO4)',			value: 'unknown'		}
																															]
																											},
																							editable:		false,
																							displayField:	'name',
																							valueField:		'value',
																							value:			'disabled',
																							fieldLabel:		'Mode',
																							width:			'100%',
																							id:				'ipv6_mode',
																							listeners:		{
																												'select':	function(el) {
																																if (el.value == 'disabled') {
																																	Ext.getCmp('ipv6_dhcpra').hide();
																																	Ext.getCmp('ipv6_lan_access').hide();
																																	Ext.getCmp('ipv6_int_ip').hide();
																																	Ext.getCmp('ipv6_int_netmask').hide();
																																	Ext.getCmp('ipv6_ext_ip').hide();
																																	Ext.getCmp('ipv6_ext_netmask').hide();
																																	Ext.getCmp('ipv6_gateway').hide();
																																	Ext.getCmp('ipv6_dns_primary').hide();
																																	Ext.getCmp('ipv6_dns_secondary').hide();
																																	Ext.getCmp('ipv6_radvd').hide();
																																	Ext.getCmp('ipv6_dhcp6s').hide();
																																	Ext.getCmp('ipv6_server').hide();
																																}
																																else if (el.value == 'native'){
																																	Ext.getCmp('ipv6_dhcpra').show();
																																	Ext.getCmp('ipv6_lan_access').show();
																																	if (Ext.getCmp('ipv6_dhcpra').value == 1) {
																																		Ext.getCmp('ipv6_int_ip').hide();
																																		Ext.getCmp('ipv6_int_netmask').hide();
																																		Ext.getCmp('ipv6_ext_ip').hide();
																																		Ext.getCmp('ipv6_ext_netmask').hide();
																																		Ext.getCmp('ipv6_gateway').hide();
																																		Ext.getCmp('ipv6_dns_primary').hide();
																																		Ext.getCmp('ipv6_dns_secondary').hide();
																																	}
																																	else {
																																		Ext.getCmp('ipv6_int_ip').show();
																																		Ext.getCmp('ipv6_int_netmask').show();
																																		Ext.getCmp('ipv6_ext_ip').show();
																																		Ext.getCmp('ipv6_ext_netmask').show();
																																		Ext.getCmp('ipv6_gateway').show();
																																		Ext.getCmp('ipv6_dns_primary').show();
																																		Ext.getCmp('ipv6_dns_secondary').show();
																																	}
																																	Ext.getCmp('ipv6_radvd').show();
																																	Ext.getCmp('ipv6_dhcp6s').show();
																																	Ext.getCmp('ipv6_server').hide();
																																}
																																else {
																																	Ext.getCmp('ipv6_dhcpra').hide();
																																	Ext.getCmp('ipv6_lan_access').hide();
																																	Ext.getCmp('ipv6_int_ip').hide();
																																	Ext.getCmp('ipv6_int_netmask').hide();
																																	Ext.getCmp('ipv6_ext_ip').hide();
																																	Ext.getCmp('ipv6_ext_netmask').hide();
																																	Ext.getCmp('ipv6_gateway').hide();
																																	Ext.getCmp('ipv6_dns_primary').hide();
																																	Ext.getCmp('ipv6_dns_secondary').hide();
																																	Ext.getCmp('ipv6_radvd').show();
																																	Ext.getCmp('ipv6_dhcp6s').show();
																																	Ext.getCmp('ipv6_server').show();
																																}
																															}
																											}

																						},
																						{	xtype: 'checkboxfield',		fieldLabel: 'IPv6 autoconfigure by DHCP/RA',	id: 'ipv6_dhcpra',	labelWidth: 230,	
																							listeners:	{
																											'change':	function(el) {
																															if (el.value == 1) {
																																Ext.getCmp('ipv6_int_ip').hide();
																																Ext.getCmp('ipv6_int_netmask').hide();
																																Ext.getCmp('ipv6_ext_ip').hide();
																																Ext.getCmp('ipv6_ext_netmask').hide();
																																Ext.getCmp('ipv6_gateway').hide();
																																Ext.getCmp('ipv6_dns_primary').hide();
																																Ext.getCmp('ipv6_dns_secondary').hide();
																															}
																															else {
																																Ext.getCmp('ipv6_int_ip').show();
																																Ext.getCmp('ipv6_int_netmask').show();
																																Ext.getCmp('ipv6_ext_ip').show();
																																Ext.getCmp('ipv6_ext_netmask').show();
																																Ext.getCmp('ipv6_gateway').show();
																																Ext.getCmp('ipv6_dns_primary').show();
																																Ext.getCmp('ipv6_dns_secondary').show();
																															}
																														}
																										}
																						},
																						{	xtype: 'textfield',			fieldLabel: 'LAN Address',							id: 'ipv6_int_ip',			width: '100%',		allowBlank: false	},
																						{	xtype: 'numberfield',		fieldLabel: 'LAN Prefix',							id: 'ipv6_int_netmask',		width: '100%',		allowBlank: false, 	minValue: 0,	maxValue: 128	},
																						{	xtype: 'textfield',			fieldLabel: 'WAN Address',							id: 'ipv6_ext_ip',			width: '100%',		allowBlank: false	},
																						{	xtype: 'numberfield',		fieldLabel: 'WAN Prefix',							id: 'ipv6_ext_netmask',		width: '100%',		allowBlank: false,	minValue: 0,	maxValue: 128	},
																						{	xtype: 'textfield',			fieldLabel: 'Gateway',								id: 'ipv6_gateway',			width: '100%',		allowBlank: false	},
																						{	xtype: 'textfield',			fieldLabel: 'Primary DNS',							id: 'ipv6_dns_primary',		width: '100%',		allowBlank: false	},
																						{	xtype: 'textfield',			fieldLabel: 'Secondary DNS',						id: 'ipv6_dns_secondary',	width: '100%',							},
																						{	xtype: 'textfield',			fieldLabel: 'Server',								id: 'ipv6_server',			width: '100%',		allowBlank: false	},
																						{	xtype: 'checkboxfield',		fieldLabel: 'Allow access to LAN from internet',	id: 'ipv6_lan_access',		labelWidth: 230							},
																						{	xtype: 'checkboxfield',		fieldLabel: 'Router Advertisement (radvd)',			id: 'ipv6_radvd',			labelWidth: 230							},
																						{	xtype: 'checkboxfield',		fieldLabel: 'Dynamic IPv6 configuration (dhcp6s)',	id: 'ipv6_dhcp6s',			labelWidth: 230							}
																					]
																	},
																	{
																		title:		'Wireless 2.4GHz',
																		id:			'edit_AP_settings_panel_accrodion_wireless',
																		items:		[
																						{	xtype: 'checkboxfield',		fieldLabel: 'Enable',	id: 'wireless_enable',
																							listeners:	{
																											'change':	function(el) {
																															if (el.value == 1) {
																																Ext.getCmp('wireless_channel').show();
																																Ext.getCmp('wireless_ssid').show();
																																Ext.getCmp('wireless_hidden').show();
																																Ext.getCmp('wireless_isolate_clients').show();
																																Ext.getCmp('wireless_isolate_broadcast').show();
																															}
																															else {
																																Ext.getCmp('wireless_channel').hide();
																																Ext.getCmp('wireless_ssid').hide();
																																Ext.getCmp('wireless_hidden').hide();
																																Ext.getCmp('wireless_isolate_clients').hide();
																																Ext.getCmp('wireless_isolate_broadcast').hide();																															}
																														}
																										}																							
																						},
																						{
																							xtype:			'combo',
																							id:				'wireless_channel',
																							store:			{
																												fields: 	[ 'name', 'value' ],
																												data: 		[
																																{ name: 'Auto',	value: 0	},
																																{ name: '1',	value: 1	},
																																{ name: '2',	value: 2	},
																																{ name: '3',	value: 3	},
																																{ name: '4',	value: 4	},
																																{ name: '5',	value: 5	},
																																{ name: '6',	value: 6	},
																																{ name: '7',	value: 7	},
																																{ name: '8',	value: 8	},
																																{ name: '9',	value: 9	},
																																{ name: '10',	value: 10	},
																																{ name: '11',	value: 11	},
																																{ name: '12',	value: 12	},
																																{ name: '13',	value: 13	},
																																{ name: '14',	value: 14	}
																															]
																											},
																							editable:		false,
																							displayField:	'name',
																							valueField:		'value',
																							value:			0,
																							fieldLabel:		'Channel',
																							width:			'100%'
																						},
																						{	xtype: 'textfield',		fieldLabel: 'SSID',					id: 'wireless_ssid',				width: '100%',		allowBlank: false	},
																						{	xtype: 'checkboxfield',	fieldLabel: 'Hidden',				id: 'wireless_hidden'														},
																						{	xtype: 'checkboxfield',	fieldLabel: 'Isolate Clients',		id: 'wireless_isolate_clients'												},
																						{	xtype: 'checkboxfield',	fieldLabel: 'Isolate Broadcast',	id: 'wireless_isolate_broadcast'											}
																					]
																	},
																	{
																		title:		'Wireless 5GHz',
																		id:			'edit_AP_settings_panel_accrodion_wireless_inic',
																		items:		[
																						{	xtype: 'checkboxfield',	fieldLabel: 'Enable',				id: 'wireless_inic_enable',
																							listeners:	{
																											'change':	function(el) {
																															if (el.value == 1) {
																																Ext.getCmp('wireless_inic_channel').show();
																																Ext.getCmp('wireless_inic_ssid').show();
																																Ext.getCmp('wireless_inic_hidden').show();
																																Ext.getCmp('wireless_inic_isolate_clients').show();
																																Ext.getCmp('wireless_inic_isolate_broadcast').show();
																															}
																															else {
																																Ext.getCmp('wireless_inic_channel').hide();
																																Ext.getCmp('wireless_inic_ssid').hide();
																																Ext.getCmp('wireless_inic_hidden').hide();
																																Ext.getCmp('wireless_inic_isolate_clients').hide();
																																Ext.getCmp('wireless_inic_isolate_broadcast').hide();																															}
																														}
																										}																								
																						},
																						{
																							xtype:			'combo',
																							id:				'wireless_inic_channel',
																							store:			{
																												fields: 	[ 'name', 'value' ],
																												data: 		[
																																{ name: 'Auto',	value: 0	},
																																{ name: '36',	value: 36	},
																																{ name: '40',	value: 40	},
																																{ name: '44',	value: 44	},
																																{ name: '48',	value: 48	},
																																{ name: '52',	value: 52	},
																																{ name: '56',	value: 56	},
																																{ name: '60',	value: 60	},
																																{ name: '64',	value: 64	},
																																{ name: '100',	value: 100	},
																																{ name: '104',	value: 104	},
																																{ name: '108',	value: 108	},
																																{ name: '112',	value: 112	},
																																{ name: '116',	value: 116	},
																																{ name: '120',	value: 120	},
																																{ name: '124',	value: 124	},
																																{ name: '128',	value: 128	},
																																{ name: '132',	value: 132	},
																																{ name: '136',	value: 136	},
																																{ name: '140',	value: 140	},
																																{ name: '149',	value: 149	},
																																{ name: '153',	value: 153	},
																																{ name: '157',	value: 157	},
																																{ name: '161',	value: 161	}
																															]
																											},
																							editable:		false,
																							displayField:	'name',
																							valueField:		'value',
																							value:			'auto',
																							fieldLabel:		'Channel',
																							width:			'100%'
																						},
																						{	xtype: 'textfield',		fieldLabel: 'SSID',					id: 'wireless_inic_ssid',				width: '100%',		allowBlank: false	},
																						{	xtype: 'checkboxfield',	fieldLabel: 'Hidden',				id: 'wireless_inic_hidden'														},
																						{	xtype: 'checkboxfield',	fieldLabel: 'Isolate Clients',		id: 'wireless_inic_isolate_clients'												},
																						{	xtype: 'checkboxfield',	fieldLabel: 'Isolate Broadcast',	id: 'wireless_inic_isolate_broadcast'											}
																					]
																	},
																	{
																		title:		'Save/Load Config',
																		id:			'edit_AP_settings_panel_accrodion_config',
																		items:		[
																						{	xtype:	'form', 
																							fileUpload: true,
																							id:		'config_file_form',
																							border:	false,
																							items:	[
																										{
																											xtype:		'filefield',
																											fieldLabel:	'Config',
																											id:			'config_file',
																											name:		'config_file',
																											width:		'100%',
																											emptyText:	'Select config file',
																											listeners:	{
																															'change':	function(el) {
																																			if (el.value.length > 0)
																																				Ext.getCmp('config_upload').enable();
																																			else
																																				Ext.getCmp('config_upload').disable();
																																		}
																														}
																										}
																									]
																						},
																						{	xtype:		'button',
																							text:		'Download',
																							id:			'config_download',
																							width:		'48%',
																							margin:		'0 10 0 0',
																							handler:	function() {
																											var element	= {};
																											element.id	= Ext.getCmp('edit_AP_list_grid').getSelectionModel().getSelection()[0].data.id;
																											var win = Ext.MessageBox.show({
																												title:		'Please wait!',
																												msg:		'Loading configuration form ' + Ext.getCmp('edit_AP_list_grid').getSelectionModel().getSelection()[0].data.host,
																												buttons:	Ext.MessageBox.OK,
																											});
																											Ext.getCmp('config_download').disable();
																											$.post('/server/control_config_get.php', element, 
																												function(data) {
																													if (data.state == 'done') {
																														var date		= new Date();
																														var filename	= 'config_' + Ext.getCmp('edit_AP_list_grid').getSelectionModel().getSelection()[0].data.hostname +
																																		  '_' + date.getDate() + '-' + (date.getMonth() + 1) + '-' + date.getFullYear() + 
																																		  '_' + date.getHours() + '-' + date.getMinutes() + '-' + date.getSeconds() + '.dat';
																														data.response	= '#The following line must not be removed.\n' + 'Default\n' + data.response;
																														var element		= document.createElement('a');
																														element.setAttribute('href', 'data:text/plain;charset=utf-8,' + encodeURIComponent(data.response));
																														element.setAttribute('download', filename);
																														element.style.display = 'none';
																														document.body.appendChild(element);
																														element.click();
																														document.body.removeChild(element);

																														if (win)
																															win.close();
																														
																														Ext.getCmp('config_download').enable();
																													}
																													else {
																														Ext.MessageBox.show({
																															title:		'Save config error!',
																															msg:		'Host: ' + Ext.getCmp('edit_AP_list_grid').getSelectionModel().getSelection()[0].data.host + 
																																		'<br>Status: ' + data.state + '<br>Response: ' + data.response,
																															buttons:	Ext.MessageBox.OK,
																														});
																													}
																												}
																											);
																										}
																						},
																						{	xtype:		'button',
																							text:		'Upload',
																							id:			'config_upload',
																							width:		'48%',
																							disabled:	true,
																							handler:	function() {
																											var win = Ext.MessageBox.show({
																												title:		'Please wait!',
																												msg:		'Loading configuration to ' + Ext.getCmp('edit_AP_list_grid').getSelectionModel().getSelection()[0].data.host,
																												buttons:	Ext.MessageBox.OK,
																											});
																											Ext.getCmp('config_file_form').getForm().submit({ 
																												url:		'/server/control_config_set.php?id=' + Ext.getCmp('edit_AP_list_grid').getSelectionModel().getSelection()[0].data.id,
																												success:	function (form, action) {
																																if (win)
																																	win.close();
																															},
																												failure:	function (form, action) {
																																if (win)
																																	win.close();
																															}
																											});
																											Ext.getCmp('config_upload').disable();
																										}
																						}
																					]
																	}
																],
											}
										],
						buttons:		[
											{ 
												text: 		'Apply',
												handler:	function() {
																if (checkAPsettings()) {
																	var command = '';

																	// Operation Mode
																	command +=	'cli st set' +
																				' operation-mode ' + 		Ext.getCmp('ap_mode').getValue() +
																				' && ';

																	// LAN
																	command +=	'cli sw lan set' +
																				' hostname ' + 				Ext.getCmp('lan_hostname').getValue() +
																				' ip ' + 					Ext.getCmp('lan_ip').getValue() +
																				' netmask ' +				Ext.getCmp('lan_netmask').getValue() +
																				' && ';
																	if (Ext.getCmp('ap_mode').getValue() == 'AP-Bridge') {
																		command +=	'cli sw wan set' +
																					' gateway ' +				Ext.getCmp('lan_gateway').getValue() +
																					' static-dns-primary ' +	Ext.getCmp('lan_dns_primary').getValue() +
																					' static-dns-secondary ' +	Ext.getCmp('lan_dns_secondary').getValue() +
																					' && ';
																	}

																	// WAN
																	if (Ext.getCmp('ap_mode').getValue() != 'AP-Bridge') {
																		command +=	'cli sw wan set' +
																					' mode ' + 					Ext.getCmp('wan_mode').getValue() +
																					' ip ' +					Ext.getCmp('wan_ip').getValue() +
																					' netmask ' +				Ext.getCmp('wan_netmask').getValue() +
																					' gateway ' +				Ext.getCmp('wan_gateway').getValue() +
																					' nat ' +					((Ext.getCmp('wan_nat').getValue() == 1) ? 'on' : 'off') +
																					' static-dns ' +			((Ext.getCmp('wan_dns_static').getValue() == 1) ? 'on' : 'off') +
																					' static-dns-primary ' +	Ext.getCmp('wan_dns_primary').getValue() +
																					' static-dns-secondary ' +	Ext.getCmp('wan_dns_secondary').getValue() +
																					' && ';
																	}

																	// IPv6
																	command +=	'cli sw ipv6 set' +
																				' mode ' +					Ext.getCmp('ipv6_mode').getValue();
																	if (Ext.getCmp('ipv6_mode').getValue() == 'native') {
																		
																	}
																	command +=	' && ';

																	// Wireless 2.4
//																	command +=	'cli wl set 2.4' +
//																				' enabled ' +				((Ext.getCmp('wireless_enable').getValue() == 1) ? 'on' : 'off') +
//																				' channel ' +				Ext.getCmp('wireless_channel').getValue() +
//																				' ssid 1 ' + 				Ext.getCmp('wireless_ssid').getValue() +
//																				' hidden 1 ' + 				((Ext.getCmp('wireless_hidden').getValue() == 1) ? 'on' : 'off') +
//																				' isolate-clients 1 ' +		((Ext.getCmp('wireless_isolate_clients').getValue() == 1) ? 'on' : 'off') +
//																				' isolate-broadcast 1 ' +	((Ext.getCmp('wireless_isolate_broadcast').getValue() == 1) ? 'on' : 'off') +
//																				' && ';

																	// Wireless 5
//																	command +=	'cli wl set 5' +
//																				' enabled ' +				((Ext.getCmp('wireless_inic_enable').getValue() == 1) ? 'on' : 'off') +
//																				' channel ' +				Ext.getCmp('wireless_inic_channel').getValue() +
//																				' ssid 1 ' +				Ext.getCmp('wireless_inic_ssid').getValue() +
//																				' && ';

																	// Apply 
																	command += 	'cli st apply' +
																				' && ' +
																				'echo OK ';
																	if (need_reboot)
																		command +=	' && sleep 10 && reboot';
																				
																	changeAPsettings('Change settings ' + Ext.getCmp('edit_AP_list_grid').getSelectionModel().getSelection()[0].data.hostname,
																					 'Apply new settings?',
																					 command);
																}
															}
											},
											{ 
												text: 		'Cancel',
												handler:	function() {
																// Reload AP settings
																showAPsettings(Ext.getCmp('edit_AP_list_grid').getSelectionModel().getSelection()[0].data)
															}
											},
											{ 
												text: 		'Reboot',
												handler:	function() {
																changeAPsettings('Reboot ' + Ext.getCmp('edit_AP_list_grid').getSelectionModel().getSelection()[0].data.hostname, 'Are you sure you want to reboot the device?', 'echo OK && sleep 10 && reboot');
															}
											}
										]
					}											
				]
});

function edit_AP_list_addNew() {
	new Ext.window.Window({
		title:			'Add New AP',
		id:				'edit_window',
		width:			400,
		height:			270,
		shadow:			true,
		resizable:		false,
		draggable:		false,
		closable:		true,
		modal:			true,
		autoShow:		true,
		items:			[{
							xtype: 		'form',
							id:			'addNew_form',
							items:		{   xtype:		'fieldset',
											margin:		'5 10 10 10',
											title:		'Add New AP',
											items: 		[
															{ xtype: 'textfield',		name: 'host',		id: 'addNew_host',		fieldLabel:	'Host',		width: 340,		allowBlank:	false 										},
															{ xtype: 'numberfield',		name: 'port',		id: 'addNew_port',		fieldLabel: 'Port',		width: 340,		value: 22,			minValue: 1,	maxValue:	65535	},
															{ xtype: 'textfield',		name: 'login',		id:	'addNew_login',		fieldLabel:	'Login',	width: 340,		allowBlank:	false										}, 
															{ xtype: 'textfield',		name: 'password',	id: 'addNew_password',	fieldLabel:	'Password',	width: 340,		allowBlank:	false,	inputType:	'password'				},
															{ xtype: 'textareafield',	name: 'comment',	id:	'addNew_comment',	fieldLabel:	'Comment',	width: 340																}	
														]											
										},
							buttons:	[
											{ 
												text: 		'Add',
												disabled:	true,
												formBind:	true,
												handler:	function() {
																var element		= {};
																element.host	= Ext.getCmp('addNew_host').getValue();
																element.port	= Ext.getCmp('addNew_port').getValue();
																element.login	= Ext.getCmp('addNew_login').getValue();
																element.pass	= Ext.getCmp('addNew_password').getValue();
																element.comment	= Ext.getCmp('addNew_comment').getValue();
																$.post('/server/get_settings.php?cmd=setNewAP', element, 
																	function(data) {
																		// refresh grid
																		loadSettingsDATA();
																		Ext.getCmp('edit_window').close();
																	}
																);
															}
											},
											{ 
												text: 		'Cancel',
												handler:	function() {
																Ext.getCmp('edit_window').close();
															}
											}
										]
						}]
	});
}

function edit_AP_list_Edit(data) {
	new Ext.window.Window({
		title:			'Edit AP',
		id:				'edit_window',			
		width:			400,
		height:			270,
		shadow:			true,
		resizable:		false,
		draggable:		false,
		closable:		true,
		modal:			true,
		autoShow:		true,
		items:			[{
							xtype: 		'form',
							id:			'addNew_form',
							items:		{   xtype:		'fieldset',
											title:		'Add New AP',
											margin:		'5 10 10 10',
											items: 		[
															{ xtype: 'textfield',		name: 'host',		id: 'addNew_host',		fieldLabel:	'Host',		value: data.host,		width: 340,		allowBlank:	false							},
															{ xtype: 'numberfield',		name: 'port',		id:	'addNew_port',		fieldLabel: 'Port',		value: data.port,		width: 340,		minValue: 1,		maxValue: 65535			},
															{ xtype: 'textfield',		name: 'login',		id: 'addNew_login',		fieldLabel:	'Login',	value: data.login,		width: 340,		allowBlank:	false							}, 
															{ xtype: 'textfield',		name: 'password',	id:	'addNew_password',	fieldLabel:	'Password',	value: data.password,	width: 340,		allowBlank:	false,	inputType: 'password'	},
															{ xtype: 'textareafield',	name: 'comment',	id:	'addNew_comment',	fieldLabel:	'Comment',	value: data.comment,	width: 340													}	
														]
										},
							buttons:	[
											{ 
												text:		'Edit',
												disabled:	true,
												formBind:	true,
												handler:	function() {
																for (var i = 0; i < Ext.getCmp('edit_AP_list_grid').store.data.items.length; i++) {
																	if (data.id != Ext.getCmp('edit_AP_list_grid').store.data.items[i].id) {
																		if (Ext.getCmp('addNew_host').getValue() == Ext.getCmp('edit_AP_list_grid').store.data.items[i].data.host &&
																			Ext.getCmp('addNew_port').getValue() == Ext.getCmp('edit_AP_list_grid').store.data.items[i].data.port) {
																				Ext.MessageBox.alert('Warning', Ext.getCmp('addNew_host').getValue() + ':' + Ext.getCmp('addNew_port').getValue() + ' already exist!');
																				return;
																			}
																	}
																}
																var element		= {};
																element.id		= data.id;
																element.host	= Ext.getCmp('addNew_host').getValue();
																element.port	= Ext.getCmp('addNew_port').getValue();
																element.login	= Ext.getCmp('addNew_login').getValue();
																element.pass	= Ext.getCmp('addNew_password').getValue();
																element.comment	= Ext.getCmp('addNew_comment').getValue();
																$.post('/server/get_settings.php?cmd=setEditAP', element, 
																	function(data) {
																		// refresh grid
																		loadSettingsDATA();
																		Ext.getCmp('edit_window').close();
																	}
																);
															}
											},
											{ 
												text:		'Cancel',
												handler:	function() { Ext.getCmp('edit_window').close();	}
											}
										]
						}]
	});
}

function changeAPsettings(title, message, command) {
	Ext.MessageBox.show({
		title:		title,
		msg:		message,
		buttons:	Ext.MessageBox.OKCANCEL,
		fn:			function(btn) {
						if (btn == 'ok') {
							element			= {};
							element.id		= Ext.getCmp('edit_AP_list_grid').getSelectionModel().getSelection()[0].data.id;
							element.command	= command;

							$.post('/server/set_settings.php', element)
								.done(function(data) {
									var result = JSON.parse(JSON.stringify(data));
									if (result.state != 'done') {
											Ext.MessageBox.show({
												title:		'Change settings error!',
												msg:		'Host: ' + Ext.getCmp('edit_AP_list_grid').getSelectionModel().getSelection()[0].data.host + '<br>Status: ' + result.state + '<br>Response: ' + result.response,
												buttons:	Ext.MessageBox.OK,
											});
									}
//									else {
//										setTimeout(showAPsettings(Ext.getCmp('edit_AP_list_grid').getSelectionModel().getSelection()[0].data), 60000);
//									}
								})
								.fail(function() {
									Ext.MessageBox.show({
										title:		'Send command error!',
										msg:		'Status: ajax fail',
										buttons:	Ext.MessageBox.OK,
									});
								});	
						}
					}
	});
}

function checkAPsettings() {
	function showWarning(message, id_expand, id_focus) {
		Ext.MessageBox.show({
			title:		'Error!',
			msg:		message,
			buttons:	Ext.MessageBox.OK,
		});
		if (id_expand !== undefined)	id_expand.expand();
		if (id_focus !== undefined)		id_focus.focus();
	}

	var exp_ipv4 = /^(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)$/;
	var exp_ipv6 = /^(([0-9]|[1-9][0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])\.){3}([0-9]|[1-9][0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])$|^(([a-zA-Z]|[a-zA-Z][a-zA-Z0-9\-]*[a-zA-Z0-9])\.)*([A-Za-z]|[A-Za-z][A-Za-z0-9\-]*[A-Za-z0-9])$|^\s*((([0-9A-Fa-f]{1,4}:){7}([0-9A-Fa-f]{1,4}|:))|(([0-9A-Fa-f]{1,4}:){6}(:[0-9A-Fa-f]{1,4}|((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3})|:))|(([0-9A-Fa-f]{1,4}:){5}(((:[0-9A-Fa-f]{1,4}){1,2})|:((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3})|:))|(([0-9A-Fa-f]{1,4}:){4}(((:[0-9A-Fa-f]{1,4}){1,3})|((:[0-9A-Fa-f]{1,4})?:((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3}))|:))|(([0-9A-Fa-f]{1,4}:){3}(((:[0-9A-Fa-f]{1,4}){1,4})|((:[0-9A-Fa-f]{1,4}){0,2}:((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3}))|:))|(([0-9A-Fa-f]{1,4}:){2}(((:[0-9A-Fa-f]{1,4}){1,5})|((:[0-9A-Fa-f]{1,4}){0,3}:((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3}))|:))|(([0-9A-Fa-f]{1,4}:){1}(((:[0-9A-Fa-f]{1,4}){1,6})|((:[0-9A-Fa-f]{1,4}){0,4}:((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3}))|:))|(:(((:[0-9A-Fa-f]{1,4}){1,7})|((:[0-9A-Fa-f]{1,4}){0,5}:((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3}))|:)))(%.+)?\s*$/;
	var exp_mac  = /^(?:[A-Fa-f0-9]{2}\:){5}[A-Fa-f0-9]{2}$/;

	// Check LAN
	if (Ext.getCmp('lan_hostname').getValue().length == 0 || Ext.getCmp('lan_hostname').getValue().match(/[^A-Z0-9_-]/gi)) {
		showWarning('Wrong LAN hostname', Ext.getCmp('edit_AP_settings_panel_accrodion_lan'), Ext.getCmp('lan_hostname'));
		return false;
	}
	if (!exp_ipv4.test(Ext.getCmp('lan_ip').getValue())) {
		showWarning('Wrong LAN IP', Ext.getCmp('edit_AP_settings_panel_accrodion_lan'), Ext.getCmp('lan_ip'));
		return false;
	}
	if (!exp_ipv4.test(Ext.getCmp('lan_netmask').getValue())) {
		showWarning('Wrong LAN Netmask', Ext.getCmp('edit_AP_settings_panel_accrodion_lan'), Ext.getCmp('lan_netmask'));
		return false;
	}
	if (Ext.getCmp('ap_mode').getValue() == 'AP-Bridge') {
		if (!exp_ipv4.test(Ext.getCmp('lan_gateway').getValue())) {
			showWarning('Wrong LAN Gateway', Ext.getCmp('edit_AP_settings_panel_accrodion_lan'), Ext.getCmp('lan_gateway'));
			return false;
		}
		if (!exp_ipv4.test(Ext.getCmp('lan_dns_primary').getValue())) {
			showWarning('Wrong LAN DNS Primary', Ext.getCmp('edit_AP_settings_panel_accrodion_lan'), Ext.getCmp('lan_dns_primary'));
			return false;
		}
		if (!exp_ipv4.test(Ext.getCmp('lan_dns_secondary').getValue())) {
			showWarning('Wrong LAN DNS Secondary', Ext.getCmp('edit_AP_settings_panel_accrodion_lan'), Ext.getCmp('lan_dns_secondary'));
			return false;
		}
	}

	// Check WAN
	if (!exp_mac.test(Ext.getCmp('wan_mac').getValue())) {
		showWarning('Wrong WAN MAC Address', Ext.getCmp('edit_AP_settings_panel_accrodion_wan'), Ext.getCmp('wan_mac'));
		return false;
	}

	if (Ext.getCmp('wan_mode').getValue() == 'STATIC') {
		if (!exp_ipv4.test(Ext.getCmp('wan_ip').getValue())) {
			showWarning('Wrong WAN IP', Ext.getCmp('edit_AP_settings_panel_accrodion_wan'), Ext.getCmp('wan_ip'));
			return false;
		}
		if (!exp_ipv4.test(Ext.getCmp('wan_netmask').getValue())) {
			showWarning('Wrong WAN Netmask', Ext.getCmp('edit_AP_settings_panel_accrodion_wan'), Ext.getCmp('wan_netmask'));
			return false;
		}
		if (!exp_ipv4.test(Ext.getCmp('wan_gateway').getValue())) {
			showWarning('Wrong WAN Gateway', Ext.getCmp('edit_AP_settings_panel_accrodion_wan'), Ext.getCmp('wan_gateway'));
			return false;
		}
	}
	if (Ext.getCmp('wan_dns_static').getValue() == 1) {
		if (!exp_ipv4.test(Ext.getCmp('wan_dns_primary').getValue())) {
			showWarning('Wrong WAN Primary DNS', Ext.getCmp('edit_AP_settings_panel_accrodion_wan'), Ext.getCmp('wan_dns_primary'));
			return false;
		}
		if (!exp_ipv4.test(Ext.getCmp('wan_dns_secondary').getValue()) && Ext.getCmp('wan_dns_secondary').getValue().length > 0) {
			showWarning('Wrong WAN Secondary DNS', Ext.getCmp('edit_AP_settings_panel_accrodion_wan'), Ext.getCmp('wan_dns_secondary'));
			return false;
		}
	}
	
	// Check IPv6
	if (Ext.getCmp('ipv6_mode').getValue() == 'native') {
		if (Ext.getCmp('ipv6_dhcpra').getValue() == 0) {
			// checking
			if (!exp_ipv6.test(Ext.getCmp('ipv6_int_ip').getValue())) {
				showWarning('Wrong IPv6 LAN Address', Ext.getCmp('edit_AP_settings_panel_accrodion_ipv6'), Ext.getCmp('ipv6_int_ip'));
				return false;
			}
			if (Ext.getCmp('ipv6_int_netmask').getValue().length == 0) {
				showWarning('Wrong IPv6 LAN Prefix', Ext.getCmp('edit_AP_settings_panel_accrodion_ipv6'), Ext.getCmp('ipv6_int_netmask'));
				return false;
			}
			if (!exp_ipv6.test(Ext.getCmp('ipv6_ext_ip').getValue())) {
				showWarning('Wrong IPv6 WAN Address', Ext.getCmp('edit_AP_settings_panel_accrodion_ipv6'), Ext.getCmp('ipv6_ext_ip'));
				return false;
			}
			if (Ext.getCmp('ipv6_ext_netmask').getValue().length == 0) {
				showWarning('Wrong IPv6 WAN Prefix', Ext.getCmp('edit_AP_settings_panel_accrodion_ipv6'), Ext.getCmp('ipv6_ext_netmask'));
				return false;
			}
			if (!exp_ipv6.test(Ext.getCmp('ipv6_gateway').getValue())) {
				showWarning('Wrong IPv6 Gateway', Ext.getCmp('edit_AP_settings_panel_accrodion_ipv6'), Ext.getCmp('ipv6_gateway'));
				return false;
			}
			if (!exp_ipv6.test(Ext.getCmp('ipv6_dns_primary').getValue())) {
				showWarning('Wrong IPv6 Primary DNS', Ext.getCmp('edit_AP_settings_panel_accrodion_ipv6'), Ext.getCmp('ipv6_dns_primary'));
				return false;
			}
			if (!exp_ipv6.test(Ext.getCmp('ipv6_dns_secondary').getValue())) {
				showWarning('Wrong IPv6 Secondary DNS', Ext.getCmp('edit_AP_settings_panel_accrodion_ipv6'), Ext.getCmp('ipv6_dns_secondary'));
				return false;
			}
		}
	}
	if (Ext.getCmp('ipv6_mode').getValue() == 'unknown') {
		if (!exp_ipv4.test(Ext.getCmp('ipv6_server').getValue())) {
			showWarning('Wrong IPv6 Server Address', Ext.getCmp('edit_AP_settings_panel_accrodion_ipv6'), Ext.getCmp('ipv6_server'));
			return false;
		}
	}

	// Check Wireless 2.4
	if (Ext.getCmp('wireless_enable').getValue() == 1) {
		if (Ext.getCmp('wireless_ssid').getValue().length == 0) {
			showWarning('Wrong Wireless SSID', Ext.getCmp('edit_AP_settings_panel_accrodion_wireless'), Ext.getCmp('wireless_ssid'));
			return false;
		}
	}	

	// Check Wireless 5
	if (Ext.getCmp('wireless_inic_enable').getValue() == 1) {
		if (Ext.getCmp('wireless_inic_ssid').getValue().length == 0) {
			showWarning('Wrong Wireless SSID', Ext.getCmp('edit_AP_settings_panel_accrodion_wireless_inic'), Ext.getCmp('wireless_inic_ssid'));
			return false;
		}
	}
	return true;
}

function showAPsettings(sel) {
	Ext.getCmp('edit_AP_settings_panel').setTitle(sel.hostname + '(' + sel.host + ') settings');
		$.post('/server/get_settings.php?cmd=getAPsettings&id=' + sel.id, 
			function(SQL) {
				if (SQL.length == 0)
					return;

				if (SQL[0].ap_model == 'SNR-CPE-W2N-MT' ||
					SQL[0].ap_model == 'SNR-CPE-W4N-MT' ||
					SQL[0].ap_model == 'SNR-CPE-WI2-MT' ||
					SQL[0].ap_model == 'SNR-CPE-AP1-MT' ||
					SQL[0].ap_model == 'SNR-CPE-SFP-MT')
					Ext.getCmp('edit_AP_settings_panel_accrodion_wireless_inic').disable();
				else 
					Ext.getCmp('edit_AP_settings_panel_accrodion_wireless_inic').enable();
				
				// set LAN
				Ext.getCmp('ap_mode').setValue(				SQL[0].ap_mode);
				if (Ext.getCmp('ap_mode').getValue() == 'AP-Bridge') {
					Ext.getCmp('edit_AP_settings_panel_accrodion_wan').disable();
					Ext.getCmp('edit_AP_settings_panel_accrodion_ipv6').disable();
					Ext.getCmp('lan_gateway').show();
					Ext.getCmp('lan_dns_primary').show();
					Ext.getCmp('lan_dns_secondary').show();
				}
				else {
					Ext.getCmp('edit_AP_settings_panel_accrodion_wan').enable();
					Ext.getCmp('edit_AP_settings_panel_accrodion_ipv6').enable();
					Ext.getCmp('lan_gateway').hide();
					Ext.getCmp('lan_dns_primary').hide();
					Ext.getCmp('lan_dns_secondary').hide();					
				}

				// set LAN
				Ext.getCmp('lan_hostname').setValue(		SQL[0].lan_hostname);
				Ext.getCmp('lan_ip').setValue(				SQL[0].lan_ip);
				Ext.getCmp('lan_netmask').setValue(			SQL[0].lan_netmask);
				Ext.getCmp('lan_gateway').setValue(			SQL[0].wan_gateway);
				Ext.getCmp('lan_dns_primary').setValue(		SQL[0].wan_dns_primary);
				Ext.getCmp('lan_dns_secondary').setValue(	SQL[0].wan_dns_secondary);
				
				
				// set WAN
				Ext.getCmp('wan_mode').setValue(			SQL[0].wan_mode);
				Ext.getCmp('wan_mac').setValue(				SQL[0].wan_mac);
				Ext.getCmp('wan_ip').setValue(				SQL[0].wan_ip);
				Ext.getCmp('wan_netmask').setValue(			SQL[0].wan_netmask);
				Ext.getCmp('wan_gateway').setValue(			SQL[0].wan_gateway);
				if (SQL[0].wan_mode == 'STATIC') {
					Ext.getCmp('wan_ip').show();
					Ext.getCmp('wan_netmask').show();
					Ext.getCmp('wan_gateway').show();
				}
				else {
					Ext.getCmp('wan_ip').hide();
					Ext.getCmp('wan_netmask').hide();
					Ext.getCmp('wan_gateway').hide();
				}

				Ext.getCmp('wan_dns_static').setValue(		SQL[0].wan_dns_static);
				if (Ext.getCmp('wan_mode').getValue() == 'STATIC') {
					Ext.getCmp('wan_dns_static').setValue(1);
					Ext.getCmp('wan_dns_static').disable();
				}
				else {
					Ext.getCmp('wan_dns_static').enable();
				}

				if (Ext.getCmp('wan_dns_static').getValue() == 1) {
					Ext.getCmp('wan_dns_primary').show();
					Ext.getCmp('wan_dns_secondary').show();
				}
				else {
					Ext.getCmp('wan_dns_primary').hide();
					Ext.getCmp('wan_dns_secondary').hide();
				}
				Ext.getCmp('wan_dns_primary').setValue(		SQL[0].wan_dns_primary);
				Ext.getCmp('wan_dns_secondary').setValue(	SQL[0].wan_dns_secondary);
				
				Ext.getCmp('wan_nat').setValue(				SQL[0].wan_nat);
				
				// set IPv6
				Ext.getCmp('ipv6_mode').setValue(			SQL[0].ipv6_mode);
				Ext.getCmp('ipv6_dhcpra').setValue(			SQL[0].ipv6_dhcpra);
				Ext.getCmp('ipv6_lan_access').setValue(		SQL[0].ipv6_lan_access);
				Ext.getCmp('ipv6_int_ip').setValue(			SQL[0].ipv6_int_ip);
				Ext.getCmp('ipv6_int_netmask').setValue(	SQL[0].ipv6_int_netmask);
				Ext.getCmp('ipv6_ext_ip').setValue(			SQL[0].ipv6_ext_ip);
				Ext.getCmp('ipv6_ext_netmask').setValue(	SQL[0].ipv6_ext_netmask);
				Ext.getCmp('ipv6_gateway').setValue(		SQL[0].ipv6_gateway);
				Ext.getCmp('ipv6_dns_primary').setValue(	SQL[0].ipv6_dns_primary);
				Ext.getCmp('ipv6_dns_secondary').setValue(	SQL[0].ipv6_dns_secondary);
				Ext.getCmp('ipv6_radvd').setValue(			SQL[0].ipv6_radvd);
				Ext.getCmp('ipv6_dhcp6s').setValue(			SQL[0].ipv6_dhcp6s);
				Ext.getCmp('ipv6_server').setValue(			'');

				Ext.getCmp('ipv6_dhcpra').hide();
				Ext.getCmp('ipv6_lan_access').hide();
				Ext.getCmp('ipv6_int_ip').hide();
				Ext.getCmp('ipv6_int_netmask').hide();
				Ext.getCmp('ipv6_ext_ip').hide();
				Ext.getCmp('ipv6_ext_netmask').hide();
				Ext.getCmp('ipv6_gateway').hide();
				Ext.getCmp('ipv6_dns_primary').hide();
				Ext.getCmp('ipv6_dns_secondary').hide();
				Ext.getCmp('ipv6_radvd').hide();
				Ext.getCmp('ipv6_dhcp6s').hide();
				Ext.getCmp('ipv6_server').hide();

				if (SQL[0].ipv6_mode == 'native') {
					Ext.getCmp('ipv6_dhcpra').show();
					Ext.getCmp('ipv6_lan_access').show();
					if (Ext.getCmp('ipv6_dhcpra').value == 0) {
						Ext.getCmp('ipv6_int_ip').show();
						Ext.getCmp('ipv6_int_netmask').show();
						Ext.getCmp('ipv6_ext_ip').show();
						Ext.getCmp('ipv6_ext_netmask').show();
						Ext.getCmp('ipv6_gateway').show();
						Ext.getCmp('ipv6_dns_primary').show();
						Ext.getCmp('ipv6_dns_secondary').show();
					}
					Ext.getCmp('ipv6_radvd').show();
					Ext.getCmp('ipv6_dhcp6s').show();
				}
				if (SQL[0].ipv6_mode == 'unknown'){
					Ext.getCmp('ipv6_radvd').show();
					Ext.getCmp('ipv6_dhcp6s').show();
					Ext.getCmp('ipv6_server').show();
				}
				
				// set Wireless 2.4
				Ext.getCmp('wireless_enable').setValue(				SQL[0].wlan_24_enabled);
				Ext.getCmp('wireless_channel').setValue(			SQL[0].wlan_24_channel);
				Ext.getCmp('wireless_ssid').setValue(				SQL[0].wlan_24_ssid);
				Ext.getCmp('wireless_hidden').setValue(				SQL[0].wlan_24_hidden);
				Ext.getCmp('wireless_isolate_clients').setValue(	SQL[0].wlan_24_isolate_cl);
				Ext.getCmp('wireless_isolate_broadcast').setValue(	SQL[0].wlan_24_isolate_bc);

				// set Wireless 5
				Ext.getCmp('wireless_inic_enable').setValue(			SQL[0].wlan_5_enabled);
				Ext.getCmp('wireless_inic_channel').setValue(			SQL[0].wlan_5_channel);
				Ext.getCmp('wireless_inic_ssid').setValue(				SQL[0].wlan_5_ssid);
				Ext.getCmp('wireless_inic_hidden').setValue(			SQL[0].wlan_5_hidden);
				Ext.getCmp('wireless_inic_isolate_clients').setValue(	SQL[0].wlan_5_isolate_cl);
				Ext.getCmp('wireless_inic_isolate_broadcast').setValue(	SQL[0].wlan_5_isolate_bc);

				need_reboot = false;
			}
		);	
}

function loadSettingsDATA() {
	Ext.getCmp('edit_AP_list_grid').store.load();
	settings_interval = setTimeout('loadSettingsDATA();', 5000);
}