Ext.onReady(function(){
	// Hide Scrollbar on window size change
	Ext.getBody().setStyle('overflow','hidden');

	// Override default grid settings, disable header menu
	Ext.define("DefaultOverrides", {
		override:		"Ext.grid.column.Column",
		menuDisabled:	true
	});

	// Apply layout
    new Ext.Panel({
		layout:		{
						type:	'vbox',
						pack:	'start',
						align:	'stretch'
					},
		border:		false,
        items:		[
						panel_Top, 
						panel_Center,
						panel_Bottom 
					],
        renderTo:	Ext.getBody()
    });

	if (window.innerWidth < 1024) {
		panel_Center.getTabBar().hide();
		menu_visible = false;
	}
	Ext.QuickTips.init();

	// Change panel height on browser resize
	Ext.GlobalEvents.on('resize', function(w, h) { 
		var width	= (menu_visible) ? w - 165 : w;
		center_panel_Height	= window.innerHeight - 100;
		panel_Center.setSize(width, center_panel_Height);
		grid_AP_panel.setHeight(center_panel_Height);
		grid_Clients_panel.setHeight(center_panel_Height);
		
		statistic_tabpanel.setHeight(center_panel_Height);
		Ext.getCmp('ap_client_distribution_pie').setHeight(center_panel_Height - 50);
		Ext.getCmp('ap_client_distribution_grid').setHeight(center_panel_Height - 50);
		Ext.getCmp('top_clients_session_pie').setHeight(center_panel_Height - 50);
		Ext.getCmp('top_clients_session_grid').setHeight(center_panel_Height - 75);
		Ext.getCmp('top_clients_bandwidth_pie').setHeight(center_panel_Height - 50);
		Ext.getCmp('top_clients_bandwidth_grid').setHeight(center_panel_Height - 75);
		Ext.getCmp('top_ap_bandwidth_pie').setHeight(center_panel_Height - 50);
		Ext.getCmp('top_ap_bandwidth_grid').setHeight(center_panel_Height - 75);
		
		if (clientAndBW_plot !== undefined) {
			document.getElementById('summ_client_bw_chart').style.height = (center_panel_Height - 100) + 'px';
			$.post('/server/get_statistic.php?cmd=getClientsAndBandwidth', 
				function(SQL) {
					$.plot("#summ_client_bw_chart", JSON.parse(JSON.stringify(SQL)), {
						xaxes:	[ { axisLabel: "Last 24 hours", mode: "time", timezone: "browser", min: new Date(new Date() - 1435 * 60 * 1000).getTime() } ],
						yaxes:	[ { axisLabel: "Clients / Mbit/s", min: 0 } ],
						legend: { show: true, position: "nw" },
						grid:	{ hoverable: false, autoHighlight: false },
						colors: [ '#b12f2e', '#0d1380' ],
						series: { lines: { show: true }, points: { show: false } }
					});
				}
			);
		}

		settings_tabpanel.setHeight(center_panel_Height);
		Ext.getCmp('edit_AP_list_grid').setHeight(center_panel_Height);
		Ext.getCmp('edit_AP_settings_panel').setHeight(center_panel_Height - 5);
		Ext.getCmp('edit_AP_settings_panel_accrodion').setHeight(center_panel_Height - 90);
		

		if (Ext.getCmp('plot_window') !== undefined) {
			Ext.getCmp('plot_window').setSize(w+1, h+1);
			Ext.getCmp('plot_window').setSize(w, h);
			document.getElementById('plot_div').style.height = Ext.getCmp('plot_window_div').getHeight() + 'px';
		}
		
		if (Ext.getCmp('info_window') !== undefined) {
			var popup_width		= (window.innerWidth >= 920 && !popup_maximized) ? 920 : window.innerWidth;
			var popup_height	= (window.innerHeight >= 400 && !popup_maximized) ? 400 : window.innerHeight;
			Ext.getCmp('info_window').setSize(popup_width, popup_height);
			Ext.getCmp('info_window').center();
			
			Ext.getCmp('info_sysinfo_grid').setSize(popup_width, popup_height - 63);
			Ext.getCmp('info_wireless_grid').setSize(popup_width, popup_height - 63);
			Ext.getCmp('info_wanlan_grid').setSize(popup_width, popup_height - 63);
			Ext.getCmp('info_vpn_grid').setSize(popup_width, popup_height - 63);
			Ext.getCmp('info_ipv6_grid').setSize(popup_width, popup_height - 63);
			Ext.getCmp('info_interfaces_grid').setSize(popup_width, popup_height - 63);
			Ext.getCmp('info_ports_grid').setSize(popup_width, popup_height - 63);
			Ext.getCmp('info_clients_grid').setSize(popup_width, popup_height - 63);
			Ext.getCmp('info_plot_plot').setHeight(popup_height - 63);
			document.getElementById('plot_div').style.height = Ext.getCmp('plot_window_div').getHeight() + 'px';
		}
		
		if (Ext.getCmp('info_client_window') !== undefined) {
			var popup_width		= (window.innerWidth >= 700) ? 700 : window.innerWidth;
			var popup_height	= (window.innerHeight >= 394) ? 394 : window.innerHeight;
			Ext.getCmp('info_client_window').setSize(popup_width, popup_height);
			Ext.getCmp('info_client_window').center();
			Ext.getCmp('info_client_grid').setHeight(popup_height - 30);
		}
	});
});

function toggleMenu() {
	if (menu_visible) {
		panel_Center.getTabBar().hide();
		menu_visible = false;
	}
	else {
		panel_Center.getTabBar().show();
		menu_visible = true;
	}
}