var clientAndBW_plot;
var top_clients_session	= ($.cookie("top_clients_session") !== null) ? $.cookie("top_clients_session") : 10;
var top_clients_bw		= ($.cookie("top_clients_bw") !== null) ? $.cookie("top_clients_bw") : 10;
var top_ap_bw			= ($.cookie("top_ap_bw") !== null) ? +$.cookie("top_ap_bw") : 10;
var top_clients_and_bw	= ($.cookie("top_clients_and_bw") !== null) ? $.cookie("top_clients_and_bw") : 24;

// Store for AP Distribution
var chartPie_APdistribution =		new Ext.data.Store({
										fields: 		[
															{	name: 'host_name',				type: 'string'	},
															{	name: 'host_number',			type: 'int'		},
															{	name: 'host_ip',				type: 'string'	},
															{	name: 'wifi_clients24',			type: 'int'		},
															{	name: 'wifi_clients5',			type: 'int'		},
															{	name: 'wifi_clients',			type: 'int'		},
															{	name: 'wifi_percent',			type: 'float'	},
															{	name: 'wifi_percent24',			type: 'float'	},
															{	name: 'wifi_percent5',			type: 'float'	}
														],
										autoLoad: 		false,
										remoteFilter:	false,
										remoteSort:		false,
										limitParam: 	undefined,
										proxy: 			{
															type:			'ajax',
															url: 			'/server/get_statistic.php?cmd=getAP',
															actionMethods:	{
																				create:		'POST',
																				read:		'POST',
																				update: 	'POST',
																				destroy:	'POST'
																			},
															reader:			{	type:		'json'	}
														}
									});

// Store for TOP clients session
var chartPie_TOPclientsSession =	new Ext.data.Store({
										fields: 		[
															{	name: 'sta_mac',				type: 'string'	},
															{	name: 'ap_host',				type: 'string'	},
															{	name: 'rxtx_bytes',				type: 'string'	},
															{	name: 'conn_time',				type: 'string'	},
															{	name: 'rxtx_top',				type: 'string'	},
															{	name: 'rxtx_total',				type: 'string'	}
														],
										autoLoad: 		false,
										remoteFilter:	false,
										remoteSort:		false,
										proxy: 			{
															type:			'ajax',
															url: 			'/server/get_statistic.php?cmd=getTOPclients',
															actionMethods:	{
																				create:		'POST',
																				read:		'POST',
																				update: 	'POST',
																				destroy:	'POST'
																			},
															reader:			{	type:		'json'	}
														}
									});

// Store for TOP clients bandwidth
var chartPie_TOPclientsBW =				new Ext.data.Store({
											fields: 		[
																{	name: 'sta_mac',			type: 'string'	},
																{	name: 'ap_host',			type: 'string'	},
																{	name: 'sta_bw',				type: 'float'	}
															],
											autoLoad: 		false,
											remoteFilter:	false,
											remoteSort:		false,
											proxy: 			{
																type:			'ajax',
																url: 			'/server/get_statistic.php?cmd=getTOPclientsBW',
																actionMethods:	{
																					create:		'POST',
																					read:		'POST',
																					update: 	'POST',
																					destroy:	'POST'
																				},
																reader:			{	type:		'json'	}
															}
										});

// Store
var chartPie_TOPapBW =					new Ext.data.Store({
											fields: 		[
																{	name: 'ap_host',			type: 'string'	},
																{	name: 'ap_bw',				type: 'float'	}
															],
											autoLoad: 		false,
											remoteFilter:	false,
											remoteSort:		false,
											proxy: 			{
																type:			'ajax',
																url: 			'/server/get_statistic.php?cmd=getTOPap',
																actionMethods:	{
																					create:		'POST',
																					read:		'POST',
																					update: 	'POST',
																					destroy:	'POST'
																				},
																reader:			{	type:		'json'	}
															}
										});

var statistic_tabpanel = new Ext.TabPanel({
	style: 		'border-color: #ffffff',
	items:	 	[
					{
						title:			'AP Client distribution',
						layout:			'column',
						bodyPadding:	10,
						items:			[ 
											{
												xtype:			'polar',
												columnWidth:	0.5,
												height:			center_panel_Height - 50,	// top + bottom + header
												insetPadding:	10,
												innerPadding:	10,	
												border:			false,
												store:			chartPie_APdistribution,
												reference:		'chart',
												id:				'ap_client_distribution_pie',
												colors:			c_a,
												series: 		[{
																	type:		'pie',
																	xField: 	'wifi_percent',
																	donut:		20,
																	highlight:	true,
																	label: 		{
																					field:			'host_name',
																					display:		'inside',
																					contrast:		true,
																					font:			(window.innerHeight > 1024) ? '14px Verdana' : '12px Verdana',
																					calloutLine:	{
																										length:		40,
																										width:		2,
																									},
																					renderer:		function (text, sprite, config, rendererData, index) {
																										var record = rendererData.store.getAt(index);
																										
																										var r		= parseInt(config.calloutColor.substring(1,3),16);
																										var g		= parseInt(config.calloutColor.substring(3,5),16);
																										var b		= parseInt(config.calloutColor.substring(5,7),16);
																										var light	= (r * 0.8 + g + b * 0.2) / 510 * 100;
																										
																										var color	= (light < 40) ? 'white' : 'black';
																										
																										if (record.data.wifi_percent < 1.5)
																											text = ''
																										else
																											if (window.innerWidth > 1024)
																												text = text + ': ' + record.data.wifi_percent + '% (' + record.data.wifi_clients + ')'
																										return	{	fillStyle: color, text: text  };
																									}
																				},
																	tooltip:	{
																					trackMouse:		true,
																					renderer:		function (tooltip, record, item) {
																										tooltip.setHtml(record.get('host_name') + '<br>' +
																														record.get('host_ip') + '<br>' +
																														record.get('wifi_percent') + '% (2.4GHz: ' + record.get('wifi_percent24') + '% / 5GHz: ' + record.get('wifi_percent5') + '%)' + '<br>' +
																														'Clients: ' + record.get('wifi_clients') + ' (2.4GHz: ' + record.get('wifi_clients24') + ' / 5GHz: ' + record.get('wifi_clients5') + ')');
																									}
																				}
																}]											
											},
											{
												xtype:			'grid',
												autoScroll:		true,
												columnWidth:	0.5,
												height:			center_panel_Height - 50,		// top + bottom + header
												id:				'ap_client_distribution_grid',
												store:			chartPie_APdistribution,
												viewConfig:		{
																	enableTextSelection:	true,
																	loadMask:				false,
																},
												columns: 		[
																	{	text: '#',	align: 'center',	flex: 3 / 100,
																		renderer: 	function (value, meta, record, rowIndex) {
																						var style	= "background-color:" + c_a[rowIndex] + ";";
																						var r		= parseInt(c_a[rowIndex].substring(1,3),16);
																						var g		= parseInt(c_a[rowIndex].substring(3,5),16);
																						var b		= parseInt(c_a[rowIndex].substring(5,7),16);
																						var light	= (r * 0.8 + g + b * 0.2) / 510 * 100;

																						if (light < 40) style += "color:white;";
																						meta.style = style;
																						return rowIndex + 1;																					
																					}
																	},
																	{	text: 'Hostname',	dataIndex: 'host_name',	flex: 10 / 100	}, 
																	{	text: 'IP',			dataIndex: 'host_ip', 	flex: 10 / 100	},
																	{	text: 'Clients',	flex: 9 / 100,
																		columns:	[
																						{	text: 'All',	dataIndex: 'wifi_clients',		align: 'center',	flex: 4 / 100,	minWidth: 20	},
																						{	text: '2.4',	dataIndex: 'wifi_clients24',	align: 'center',	flex: 4 / 100,	minWidth: 20	},
																						{	text: '5',		dataIndex: 'wifi_clients5',		align: 'center',	flex: 4 / 100,	minWidth: 20	}
																					]
																	},
																	{	text: '%',	flex: 9 / 100,
																		columns:	[
																						{ 	text: 'All',	dataIndex: 'wifi_percent', 		align: 'center',	flex: 4 / 100,	minWidth: 20	},
																						{	text: '2.4',	dataIndex: 'wifi_percent24',	align: 'center',	flex: 4 / 100,	minWidth: 20	},
																						{	text: '5',		dataIndex: 'wifi_percent5',		align: 'center',	flex: 4 / 100,	minWidth: 20	}
																					]
																	}
																],
												bbar:			{
																	style:	'background-color: #d7efcd;',
																	items: 	[
																				{
																					width:	'100%',
																					xtype:	'label',
																					id:		'pieChart_APdistribution_summary',
																				}
																			]
																},																
												listeners:		{
																	select:		function(model, record, row, coln, eopts) {
																					var chart = Ext.getCmp('ap_client_distribution_pie');
																					chart.setHighlightItem(chart.getSeries()[0].getItemByIndex(row));
																					
																				}																	
																}
											}
										]
					},
					{
						title:			'TOP-' + top_clients_session + ' Client session',
						layout:			'column',
						id:				'top_clients_session_tab',
						bodyPadding:	10,
						items:			[ 
											{
												xtype:			'polar',
												columnWidth:	0.5,
												height:			center_panel_Height - 50,		// top + bottom + header
												insetPadding:	10,
												innerPadding:	10,	
												border:			false,
												id:				'top_clients_session_pie',
												store:			chartPie_TOPclientsSession,
												reference:		'chart',
												colors:			c_a,
												series: 		[{
																	type:		'pie',
																	xField: 	'percent',
																	donut:		20,
																	highlight:	true,
																	label: 		{
																					field:			'sta_mac',
																					display:		'inside',
																					contrast:		true,
																					font:			(window.innerHeight > 1024) ? '14px Verdana' : '11px Verdana',
																					calloutLine:	{
																										length:		40,
																										width:		2,
																									},
																					renderer:		function (text, sprite, config, rendererData, index) {
																										var record = rendererData.store.getAt(index);
																										
																										var r		= parseInt(config.calloutColor.substring(1,3),16);
																										var g		= parseInt(config.calloutColor.substring(3,5),16);
																										var b		= parseInt(config.calloutColor.substring(5,7),16);
																										var light	= (r * 0.8 + g + b * 0.2) / 510 * 100;
																										
																										var color	= (light < 40) ? 'white' : 'black';
																										
																										if (record.data.percent < 2)
																											text = ''
																										else
																											if (window.innerHeight > 1024)
																												text = text + ' (' + record.data.percent + '%)';
																										return	{	fillStyle: color, text: text  };
																									}
																				},
																	tooltip:	{
																					trackMouse:		true,
																					renderer:		function (tooltip, record, item) {
																										tooltip.setHtml(record.get('sta_mac') + '<br>' +
																														record.get('ap_host') + '<br>' +
																														record.get('rxtx_bytes') + ', ' + record.get('percent') + '%');
																									}
																				}
																}]											
											},
											{
												border:			false,
												columnWidth:	0.5,
												items:			[
																	{
																		xtype:			'combo',
																		id:				'top_clients_session',
																		fieldLabel:		'TOP',
																		labelWidth: 	35,
																		width:			90,
																		store:			{
																							fields: 	[ 'name', 'value' ],
																							data: 		[
																											{ name: '3',	value: 3	},
																											{ name: '5',	value: 5	},
																											{ name: '10',	value: 10	},
																											{ name: '20',	value: 20	},
																											{ name: '30',	value: 30	},
																											{ name: '50',	value: 50	},
																											{ name: '100',	value: 100	}
																										]
																						},
																		editable:		false,
																		displayField:	'name',
																		valueField:		'value',
																		value:			top_clients_session,
																		listeners:		{
																							'select':	function(el) {
																											top_clients_session = this.value;
																											$.cookie("top_clients_session", this.value);
																											Ext.getCmp('top_clients_session_tab').setTitle('TOP-' + top_ap_bw + ' Clients Session');
																											clearInterval(statistic_interval);
																											loadStatisticDATA();
																										}
																						}
																	},
																	{
																		xtype:			'grid',
																		autoScroll:		true,
																		columnWidth:	0.5,
																		height:			center_panel_Height - 75,
																		id:				'top_clients_session_grid',
																		store:			chartPie_TOPclientsSession,
																		viewConfig:		{
																							preserveScrollOnReload:	true,
																							enableTextSelection:	true,
																							loadMask:				false,
																						},
																		columns: 		[
																							{	text: '#',	align: 'center',	flex: 3 / 100,
																								renderer: 	function (value, meta, record, rowIndex) {
																												var style	= "background-color:" + c_a[rowIndex] + ";";
																												var r		= parseInt(c_a[rowIndex].substring(1,3),16);
																												var g		= parseInt(c_a[rowIndex].substring(3,5),16);
																												var b		= parseInt(c_a[rowIndex].substring(5,7),16);
																												var light	= (r * 0.8 + g + b * 0.2) / 510 * 100;

																												if (light < 40) style += "color:white;";
																												meta.style = style;
																												return rowIndex + 1;																					
																											}
																							},
																							{	text: 'MAC',		dataIndex: 'sta_mac',		flex: 20 / 100					}, 
																							{	text: 'AP (IP)',	dataIndex: 'ap_host',		flex: 20 / 100					}, 
																							{	text: 'RX + TX',	dataIndex: 'rxtx_bytes',	flex: 10 / 100,	align: 'center'	} 
																						],
																		bbar:			{
																							style:	'background-color: #d7efcd;',
																							items: 	[
																										{
																											width:	'100%',
																											xtype:	'label',
																											id:		'pieChart_TOPclientsSession_summary',
																										}
																									]
																						},																
																		listeners:		{
																							select:		function(model, record, row, coln, eopts) {
																											var chart = Ext.getCmp('top_clients_session_pie');
																											chart.setHighlightItem(chart.getSeries()[0].getItemByIndex(row));
																											
																										}	
																						}
																	}
																]
											}
										]
					},
					{
						title:			'TOP-' + top_clients_bw + ' Client Bandwidth',
						layout:			'column',
						id:				'top_clients_bw_tab',
						bodyPadding:	10,
						items:			[ 
											{
												xtype:			'polar',
												columnWidth:	0.5,
												height:			center_panel_Height - 50,		// top + bottom + header
												insetPadding:	10,
												innerPadding:	10,	
												border:			false,
												id:				'top_clients_bandwidth_pie',
												store:			chartPie_TOPclientsBW,
												reference:		'chart',
												colors:			c_a,
												series: 		[{
																	type:		'pie',
																	xField: 	'percent',
																	donut:		20,
																	highlight:	true,
																	label: 		{
																					field:			'sta_mac',
																					display:		'inside',
																					contrast:		true,
																					font:			(window.innerHeight > 1024) ? '14px Verdana' : '11px Verdana',
																					calloutLine:	{
																										length:		40,
																										width:		2,
																									},
																					renderer:		function (text, sprite, config, rendererData, index) {
																										var record = rendererData.store.getAt(index);
																										
																										var r		= parseInt(config.calloutColor.substring(1,3),16);
																										var g		= parseInt(config.calloutColor.substring(3,5),16);
																										var b		= parseInt(config.calloutColor.substring(5,7),16);
																										var light	= (r * 0.8 + g + b * 0.2) / 510 * 100;
																										
																										var color	= (light < 40) ? 'white' : 'black';
																										
																										if (record.data.percent < 2)
																											text = ''
																										else
																											if (window.innerHeight > 1024)
																												text = text + ' (' + record.data.percent + '%)';
																										
																										return	{	fillStyle: color, text: text  };
																									}
																				},
																	tooltip:	{
																					trackMouse:		true,
																					renderer:		function (tooltip, record, item) {
																										tooltip.setHtml(record.get('sta_mac') + '<br>' +
																														record.get('ap_host') + '<br>' +
																														record.get('sta_bw') + ' Mbit/s, ' + record.get('percent') + '%');
																									}
																				}
																}]											
											},
											{
												border:			false,
												columnWidth:	0.5,
												items:			[
																	{
																		xtype:			'combo',
																		id:				'top_clients_bw',
																		fieldLabel:		'TOP',
																		labelWidth: 	35,
																		width:			90,
																		store:			{
																							fields: 	[ 'name', 'value' ],
																							data: 		[
																											{ name: '3',	value: 3	},
																											{ name: '5',	value: 5	},
																											{ name: '10',	value: 10	},
																											{ name: '20',	value: 20	},
																											{ name: '30',	value: 30	},
																											{ name: '50',	value: 50	},
																											{ name: '100',	value: 100	}
																										]
																						},
																		editable:		false,
																		displayField:	'name',
																		valueField:		'value',
																		value:			top_clients_bw,
																		listeners:		{
																							'select':	function(el) {
																											top_clients_bw = this.value;
																											$.cookie("top_clients_bw", this.value);
																											Ext.getCmp('top_clients_bw_tab').setTitle('TOP-' + top_ap_bw + ' Clients Bandwidth');
																											clearInterval(statistic_interval);
																											loadStatisticDATA();
																										}
																						}
																	},
																	{
																		xtype:			'grid',
																		autoScroll:		true,
																		height:			center_panel_Height - 75,
																		id:				'top_clients_bandwidth_grid',
																		store:			chartPie_TOPclientsBW,
																		viewConfig:		{
																							preserveScrollOnReload:	true,
																							enableTextSelection:	true,
																							loadMask:				false,
																						},
																		columns: 		[
																							{	text: '#',		align: 'center',	flex: 3 / 100,
																								renderer: 	function (value, meta, record, rowIndex) {
																												var style	= "background-color:" + c_a[rowIndex] + ";";
																												var r		= parseInt(c_a[rowIndex].substring(1,3),16);
																												var g		= parseInt(c_a[rowIndex].substring(3,5),16);
																												var b		= parseInt(c_a[rowIndex].substring(5,7),16);
																												var light	= (r * 0.8 + g + b * 0.2) / 510 * 100;

																												if (light < 40) style += "color:white;";
																												meta.style = style;
																												return rowIndex + 1;																					
																											}
																							},
																							{	text: 'MAC',				dataIndex: 'sta_mac',	flex: 20 / 100									}, 
																							{	text: 'AP (IP)',			dataIndex: 'ap_host',	flex: 20 / 100									}, 
																							{	text: 'Bandwidth (Mbit/s)',	dataIndex: 'sta_bw',	flex: 10 / 100,	minWidth: 120,	align: 'center'	} 
																						],
																		bbar:			{
																							style:	'background-color: #d7efcd;',
																							items: 	[
																										{
																											width:	'100%',
																											xtype:	'label',
																											id:		'pieChart_TOPclientsBW_summary',
																										}
																									]
																						},																
																		listeners:		{
																							select:		function(model, record, row, coln, eopts) {
																											var chart = Ext.getCmp('top_clients_bandwidth_pie');
																											chart.setHighlightItem(chart.getSeries()[0].getItemByIndex(row));
																										}	
																						}
																	}
																]
											}
										]
					},
					{
						title:			'TOP-' + top_ap_bw + ' AP Bandwidth',
						id:				'top_ap_bw_tab',
						layout:			'column',
						bodyPadding:	10,
						items:			[ 
											{
												xtype:			'polar',
												columnWidth:	0.5,
												height:			center_panel_Height - 50,		// top + bottom + header
												insetPadding:	10,
												innerPadding:	10,	
												border:			false,
												id:				'top_ap_bandwidth_pie',
												store:			chartPie_TOPapBW,
												reference:		'chart',
												colors:			c_a,
												series: 		[{
																	type:		'pie',
																	xField: 	'percent',
																	donut:		20,
																	highlight:	true,
																	label: 		{
																					field:			'ap_host',
																					display:		'inside',
																					contrast:		true,
																					font:			(window.innerHeight > 1024) ? '14px Verdana' : '12px Verdana',
																					calloutLine:	{
																										length:		40,
																										width:		2,
																									},
																					renderer:		function (text, sprite, config, rendererData, index) {
																										var record = rendererData.store.getAt(index);
																										
																										var r		= parseInt(config.calloutColor.substring(1,3),16);
																										var g		= parseInt(config.calloutColor.substring(3,5),16);
																										var b		= parseInt(config.calloutColor.substring(5,7),16);
																										var light	= (r * 0.8 + g + b * 0.2) / 510 * 100;
																										
																										var color	= (light < 40) ? 'white' : 'black';
																										
																										if (record.data.percent < 2)
																											text = ''
																										else
																											if (window.innerHeight > 1024)
																												text = text + ': ' + record.data.percent + '%';
																											else
																												text = text.split('(')[0];
																										return	{	fillStyle: color, text: text  };
																									}
																				},
																	tooltip:	{
																					trackMouse:		true,
																					renderer:		function (tooltip, record, item) {
																										tooltip.setHtml(record.get('ap_host') + '<br>' +
																														record.get('ap_bw') + ' Mbit/s, ' + record.get('percent') + '%');
																									}
																				}
																}]											
											}, 
											{ 
												border:			false,
												columnWidth:	0.5,
												items:			[
																	{
																		xtype:			'combo',
																		id:				'top_ap_bw',
																		fieldLabel:		'TOP',
																		labelWidth: 	35,
																		width:			90,
																		store:			{
																							fields: 	[ 'name', 'value' ],
																							data: 		[
																											{ name: '3',	value: 3	},
																											{ name: '5',	value: 5	},
																											{ name: '10',	value: 10	},
																											{ name: '20',	value: 20	},
																											{ name: '30',	value: 30	},
																											{ name: '50',	value: 50	},
																											{ name: '100',	value: 100	},
																										]
																						},
																		editable:		false,
																		displayField:	'name',
																		valueField:		'value',
																		value:			top_ap_bw,
																		listeners:		{
																							'select':	function(el) {
																											top_ap_bw = this.value;
																											$.cookie("top_ap_bw", this.value);
																											Ext.getCmp('top_ap_bw_tab').setTitle('TOP-' + top_ap_bw + ' AP Bandwidth');
																											clearInterval(statistic_interval);
																											loadStatisticDATA();
																										}
																						}
																	},
																	{
																		xtype:			'grid',
																		autoScroll:		true,
																		height:			center_panel_Height - 75,		// top + bottom + header
																		id:				'top_ap_bandwidth_grid',
																		store:			chartPie_TOPapBW,
																		viewConfig:		{
																							preserveScrollOnReload:	true,
																							enableTextSelection:	true,
																							loadMask:				false,
																						},
																		columns: 		[
																							{	text: '#',	align: 'center',	flex: 3 / 100,
																								renderer: 	function (value, meta, record, rowIndex) {
																												var style	= "background-color:" + c_a[rowIndex] + ";";
																												var r		= parseInt(c_a[rowIndex].substring(1,3),16);
																												var g		= parseInt(c_a[rowIndex].substring(3,5),16);
																												var b		= parseInt(c_a[rowIndex].substring(5,7),16);
																												var light	= (r * 0.8 + g + b * 0.2) / 510 * 100;

																												if (light < 40) style += "color:white;";
																												meta.style = style;
																												return rowIndex + 1;																					
																											}
																							},
																							{	text: 'Hostname (IP)',		dataIndex: 'ap_host',	flex: 20 / 100						}, 
																							{	text: 'Bandwidth (Mbit/s)',	dataIndex: 'ap_bw',		flex: 10 / 100,		align: 'center'	} 
																						],
																		bbar:			{
																							style:	'background-color: #d7efcd;',
																							items: 	[
																										{
																											width:	'100%',
																											xtype:	'label',
																											id:		'pieChart_TOPapBW_summary',
																										}
																									]
																						},																
																		listeners:		{
																							select:		function(model, record, row, coln, eopts) {
																											var chart = Ext.getCmp('top_ap_bandwidth_pie');
																											chart.setHighlightItem(chart.getSeries()[0].getItemByIndex(row));
																											
																										}
																						}
																	}
																]
											}
										]
					},
					{
						title:			'Total Clients & Bandwidth',
						bodyPadding:	10,
						items:			[ 	
											{
												xtype:			'combo',
												id:				'summary_clients_bw',
												fieldLabel:		'Last',
												labelWidth: 	40,
												width:			120,
												store:			{
																	fields: 	[ 'name', 'value' ],
																	data: 		[
																					{ name: '3 Hour',	value: 3	},
																					{ name: '6 Hour',	value: 6	},
																					{ name: '12 Hours',	value: 12	},
																					{ name: '24 Hours',	value: 24	},
																					{ name: '2 Days',	value: 48	},
																					{ name: '3 Days',	value: 72	},
																					{ name: '1 Week',	value: 168	},
																				]
																},
												margin:			'0 10 0 40',				
												editable:		false,
												displayField:	'name',
												valueField:		'value',
												value:			top_clients_and_bw,
												listeners:		{
																	'select':	function(el) {
																					top_clients_and_bw = this.value;
																					$.cookie("top_clients_and_bw", this.value)

																					element = {};
																					element.last = Ext.getCmp('summary_clients_bw').value;
																					$.post('/server/get_statistic.php?cmd=getClientsAndBandwidth', 
																						element,
																						function(SQL) {
																							$.plot("#summ_client_bw_chart", JSON.parse(JSON.stringify(SQL)), {
																								xaxes:	[ { axisLabel: "Last " + Ext.getCmp('summary_clients_bw').rawValue, mode: "time", timezone: "browser", min: new Date(new Date() - (element.last * 60 * 60) * 1000).getTime() } ],
																								yaxes:	[ { axisLabel: "Clients / Mbit/s", min: 0 } ],
																								legend: { show: true, position: "nw" },
																								grid:	{ hoverable: false, autoHighlight: false },
																								colors: [ '#b12f2e', '#0d1380' ],
																								series: { lines: { show: true }, points: { show: false } }
																							});
																						}
																					);
																				}
																}
											},
											{ 	border: false,
												html:	'<div id="summ_client_bw_chart" style="height: ' + (center_panel_Height - 65) + 'px;"></div>' }	],
						listeners:		{
											afterrender:	function() {
																element = {};
																element.last = Ext.getCmp('summary_clients_bw').value;
																$.post('/server/get_statistic.php?cmd=getClientsAndBandwidth', 
																element,
																function(SQL) {
																	clientAndBW_plot = $.plot("#summ_client_bw_chart", JSON.parse(JSON.stringify(SQL)), {
																		xaxes:	[ { axisLabel: "Last " + Ext.getCmp('summary_clients_bw').rawValue, mode: "time", timezone: "browser", min: new Date(new Date() - (element.last * 60 * 60) * 1000).getTime() } ],
																		yaxes:	[ { axisLabel: "Clients / Mbit/s", min: 0 } ],
																		legend: { show: true, position: "nw" },
																		grid:	{ hoverable: false, autoHighlight: false },
																		colors: [ '#b12f2e', '#0d1380' ],
																		series: { lines: { show: true }, points: { show: false } }
																	});
																});
														
															}
										}
					}
				]
});

function loadStatisticDATA() {
	var clients_total	= 0;
	var clients_24		= 0;
	var clients_5		= 0;
	
	chartPie_APdistribution.load({
		callback:	function(records, operation, success) {
						if (success) {
							// Calculate summary 
							for (var i = 0; i < records.length; i++) {
								clients_total 	+= records[i].data.wifi_clients24 + records[i].data.wifi_clients5;
								clients_24		+= records[i].data.wifi_clients24;
								clients_5		+= records[i].data.wifi_clients5;
							}
							
							Ext.getCmp('pieChart_APdistribution_summary').setHtml(
								'<div>' +
								'	<div style="width: 80px; float: left">Total AP:</div><div style="float: left;">' + records.length + '</div><br clear="all">' +
								'	<div style="width: 80px; float: left">Total Clients:</div><div style="float: left;">' + clients_total + 
								' [2.4GHz: ' + clients_24 + ' / ' +  (clients_24 / clients_total * 100).toFixed(1) +'%] [5GHz: ' + clients_5 + ' / ' + (clients_5 / clients_total * 100).toFixed(1) +'%]' + '</div>' +
								'</div>'
							);
						}
					}
	});
	
	chartPie_TOPclientsSession.load({
		params: 	{ 
						top:	top_clients_session,
						limit:	+top_clients_session + 1
					},
		callback:	function(records, operation, success) {
						if (success)
							Ext.getCmp('pieChart_TOPclientsSession_summary').setHtml(
									'<div>' +
									'	<div style="width: 80px; float: left">TOP-10:</div><div style="float: left;">' + records[0].data.rxtx_top + '</div><br clear="all">' +
									'	<div style="width: 80px; float: left">Total:</div><div style="float: left;">' + records[0].data.rxtx_total + '</div>' +
									'</div>'
							);
					}
	});
	
	chartPie_TOPclientsBW.load({
		params: 	{ 
						top:	top_clients_bw,
						limit:	+top_clients_bw + 1
					},
		callback:	function(records, operation, success) {
						if (success)
							Ext.getCmp('pieChart_TOPclientsBW_summary').setHtml(
								'<div>' +
								'	<div style="width: 80px; float: left">TOP-10:</div><div style="float: left;">' + records[0].data.top_bw + 'Mbit/s, ' + (records[0].data.top_bw / records[0].data.total_bw * 100).toFixed(2) +'%</div><br clear="all">' +
								'	<div style="width: 80px; float: left">Total:</div><div style="float: left;">' + records[0].data.total_bw + 'Mbit/s' + '</div>' +
								'</div>'			
							);
					}
	});
	
	chartPie_TOPapBW.load({
		params: 	{ 
						top:	top_ap_bw,
						limit:	top_ap_bw + 1
					},
		callback:	function(records, operation, success) {
						if (success)
							Ext.getCmp('pieChart_TOPapBW_summary').setHtml(
								'<div>' +
								'	<div style="width: 80px; float: left">TOP-' + top_ap_bw + ':</div><div style="float: left;">' + records[0].data.top_bw + 'Mbit/s, ' + (records[0].data.top_bw / records[0].data.total_bw * 100).toFixed(2) +'%</div><br clear="all">' +
								'	<div style="width: 80px; float: left">Total:</div><div style="float: left;">' + records[0].data.total_bw + 'Mbit/s' + '</div>' +
								'</div>'
							);
					}
	});
	
	if (clientAndBW_plot !== undefined) {
		element = {};
		element.last = Ext.getCmp('summary_clients_bw').value;
		$.post('/server/get_statistic.php?cmd=getClientsAndBandwidth', 
			element,
			function(SQL) {
				$.plot("#summ_client_bw_chart", JSON.parse(JSON.stringify(SQL)), {
					xaxes:	[ { axisLabel: "Last " + Ext.getCmp('summary_clients_bw').rawValue, mode: "time", timezone: "browser", min: new Date(new Date() - (element.last * 60 * 60) * 1000).getTime() } ],
					yaxes:	[ { axisLabel: "Clients / Mbit/s", min: 0 } ],
					legend: { show: true, position: "nw" },
					grid:	{ hoverable: false, autoHighlight: false },
					colors: [ '#b12f2e', '#0d1380' ],
					series: { lines: { show: true }, points: { show: false } }
				});
			}
		);
	}
	
	
	statistic_interval = setTimeout('loadStatisticDATA();', 15000);
}