<?php
	include "mysql.php";
	include "const.php";
	include "utils.php";

	$filter = '';

	if (!empty($_REQUEST['filter'])) {
		$arr	= array();
		$arr	= json_decode($_REQUEST['filter'], true);

		if ($arr[0]['property'] == 'hide_down_ap')
			$hide_down = ($arr[0]['value'] == 'true') ? true : false;
		if ($arr[0]['property'] == 'filter')
			$filter = $arr[0]['value'];

		if (!empty($arr[1])) {
			if ($arr[1]['property'] == 'hide_down_ap')
				$hide_down = ($arr[1]['value'] == 'true') ? true : false;
			if ($arr[1]['property'] == 'filter')
				$filter = $arr[1]['value'];
		}
	}

	if (!empty($_REQUEST['sort'])) {
		$arr	= array();
		$arr	= json_decode($_REQUEST['sort'], true);
		if ($arr[0]['property'] == 'host_ipmac')
			$arr[0]['property'] = 'INET_ATON(host_ip)';
		else if ($arr[0]['property'] == 'wifi_rxtx')
			$arr[0]['property'] = 'rxtx_bytes';
		else if ($arr[0]['property'] == 'host_status')
			$arr[0]['property'] = 'uptime';

		$order		= 'ORDER BY '.$arr[0]['property'].' '.$arr[0]['direction'];
	}
	else
		$order		= '';

	$sql = "SELECT 
				st_lan_current.hostname 																								AS host_name, 
				CONCAT(st_wan_current.ip, ' (', UCASE(IF(st_general_current.operation_mode = 'AP-Bridge' OR st_general_current.apcli_bridge_only = 1, st_lan_current.mac, st_wan_current.mac)),') ') 														AS host_ipmac, 
				st_wan_current.ip 																										AS host_ip, 
				CONCAT(st_general_current.device_model, ' (',st_general_current.fw_version ,') ') 										AS host_model, 
				st_general_current.uptime 																								AS uptime, 
				interfaces.rx_bytes 															 										AS rx_bytes, 
				interfaces.tx_bytes  																									AS tx_bytes, 
				(interfaces.rx_bytes + interfaces.tx_bytes) 																			AS rxtx_bytes, 
				IF(st_wlan_current.bssid24 IS NULL, '-', IF(st_wlan_current.channel24 = 0, 'AUTO', st_wlan_current.channel24)) 			AS wifi_channel24, 
				IF(st_wlan_current.bssid5 IS NULL, '-', IF(st_wlan_current.channel5 = 0, 'AUTO', st_wlan_current.channel5)) 			AS wifi_channel5, 
				IF(st_wlan_current.bssid24 IS NULL, '0', SUM(IF(st_wlan_current.bssid24 = st_wlan_station_list.bssid, 1, 0))) 			AS wifi_clients24, 
				IF(st_wlan_current.bssid5 IS NULL, '0', SUM(IF(st_wlan_current.bssid5 = st_wlan_station_list.bssid, 1, 0))) 			AS wifi_clients5, 
				clients.id 																												AS sqlid, 
				UNIX_TIMESTAMP(clients.connect_attempt) AS connect_attempt, 
				UNIX_TIMESTAMP(clients.connect_success) AS connect_success 
			FROM clients 
			INNER JOIN st_general_current ON clients.id = st_general_current.client_id 
			LEFT JOIN st_wlan_current ON clients.id = st_wlan_current.client_id 
			LEFT JOIN st_lan_current ON clients.id = st_lan_current.client_id 
			LEFT JOIN st_wan_current ON clients.id = st_wan_current.client_id 
			LEFT JOIN (SELECT 
							sta_mac, bssid, rx_bytes, tx_bytes, client_id 
						FROM 
							st_wlan_station_list_current 
						WHERE (UNIX_TIMESTAMP(NOW()) - UNIX_TIMESTAMP(st_wlan_station_list_current.timestamp) < ".$down_timeout.") 
						GROUP BY sta_mac 
						ORDER BY conn_time) AS st_wlan_station_list ON clients.id = st_wlan_station_list.client_id 
			LEFT JOIN (SELECT 
							client_id, SUM(rx_bytes) as rx_bytes, SUM(tx_bytes) as tx_bytes 
						FROM 
							st_interfaces_current 
						WHERE ifname LIKE 'ra%' 
						GROUP BY client_id) AS interfaces ON clients.id = interfaces.client_id 
			GROUP BY clients.id ".$order;

	$res		= mysql_query($sql) or die($sql);
	$data		= Array();
	$ap_down	= 0;

	while ($row = mysql_fetch_assoc($res)) {
		if ($row["connect_success"] != '') {
			$last_conn	= $time - $row["connect_success"];
			if ($last_conn > $down_timeout) {
				$row["state"]		= 'down';
				$row["host_status"]	= 'Down: ('.date("Y/m/d H:i:s", $row["connect_success"]).')';
				$ap_down++;
			}
			else if ($last_conn > $lost_timeout) {
				$row["state"]		= 'lost';
				$row["host_status"]	= 'Lost: ('.date("Y/m/d H:i:s", $row["connect_success"]).')';
			}
			else {
				$row["state"]		= 'up';
				$row["host_status"]	= "Uptime: ".getUptime($row["uptime"], true, false);
			}

			$find = false;
			if ($filter == '')
				$find = true;
			else
				foreach ($row as &$value) {
					if (substr_count(strtoupper($value), strtoupper($filter)) > 0) {
						$srch = ($filter == '.' || $filter == ')' || $filter == '(') ? '\\'.$filter : $filter;
						$value = preg_replace_callback(	'/'.$srch.'/i',
										function ($matches) {
											return '<span class="x-item-selected">'.$matches[0].'</span>';
										},
										$value
										);
						$find = true;
					}
				}

			if ($find && ($last_conn <= $down_timeout || !$hide_down)) {
				if ($last_conn > $down_timeout) {
					$row["wifi_clients24"]	= '';
					$row["wifi_clients5"]	= '';
					$row["wifi_channel24"]	= '';
					$row["wifi_channel5"]	= '';
					$row["wifi_rxtx"]	= '-/-';
				}
				else {
					$row["wifi_rxtx"]	= getRXTX($row["rx_bytes"], $row["tx_bytes"]);
				}
				$data[] = $row;
			}
		}
	}

	for ($i = 0; $i < count($data); $i++) 
		$data[$i]["down"] = $ap_down;
	
	header("Content-Type: application/json;charset=utf-8");
	echo json_encode($data);
?>