<?php
	include "mysql.php";
	include "control.php";

	header("Pragma: no-cache");
	header("Cache-control: no-cache");
	header("Content-Type: application/json;charset=utf-8");

    if (!isset($_REQUEST['id'])) {
		$result = array('state' => 'error', 'response' => 'NO_ID');
		echo json_encode($result);		
       exit();
    }

    $id		= $_REQUEST['id'];
    $band	= $_REQUEST['band'];

	$colors = [
				'ff0000', '00ff00', '0000ff', 'ffff00', '00ffff', 'ff00ff',
				'c00000', '00c000', '0000c0', 'c0ff00', 'ffc000', 'c000ff',
				'ff00c0', '00c0ff', '00ffc0', 'c0c000', 'c000c0', '00c0c0',
				'800000', '008000', '000080', '808000', '800080', '008080',
				'80ff00', 'ff8000', '8000ff', 'ff8000', '0080ff', '00ff80',
				'80c000', 'c08000', '8000c0', 'c00080', '0080c0', '00c080'
			];

    if (!isset($band))
        $band = "2.4";

    sendDeviceCommand($id, 'cli wl scan '.$band.' report', 'now');

    $row = lastDeviceCommand_waitResult();
    if (!$row)
		$result = array('state' => 'error', 'response' => 'REQUEST_TIMEOUT');
	else if ($row['state'] == 'done')  {
        $response	= $row['response'];
		$data		= Array();
		$index		= 0;
        foreach(preg_split("/((\r?\n)|(\r\n?))/", $response) as $line) {
            $args = explode("\t", $line);
			
            if (count($args) != 10) continue;
            if ($args[0] != "APSCANELEM") continue;

			$data[] = array('band'		=> $args[1],
							'channel'	=> $args[2],
							'ssid'		=> $args[3],
							'bssid'		=> $args[4],
							'security'	=> $args[5],
							'signal'	=> $args[6],
							'mode'		=> $args[7],
							'extch'		=> $args[8],
							'type'		=> $args[9],
							'color'		=> $colors[$index % count($colors)]);
			$index++;
        }
		$result = array('state' => 'done', 'response' => 'DONE', 'data' => $data);
    }
    else
		$result = array('state' => 'error', 'response' => 'REQUEST_TIMEOUT');

	echo json_encode($result);		
?>