<?php
	include "mysql.php";
	include "const.php";
	include "utils.php";

	$filter = '';
	if (!empty($_POST['filter'])) {
		$arr	= array();
		$arr	= json_decode($_POST['filter'], true);
		$filter = $arr[0]['value'];
	}

	if (!empty($_POST['sort'])) {
		$arr = array();
		$arr = json_decode($_POST['sort'], true);
		if ($arr[0]['property'] == 'ap_ssid')
			$arr[0]['property'] = 'sta_bssid';
		else if ($arr[0]['property'] == 'sta_rssi')
			$arr[0]['property'] = 'avg_rssi';
		else if ($arr[0]['property'] == 'sta_quality')
			$arr[0]['property'] = 'avg_quality';
		else if ($arr[0]['property'] == 'sta_rxtx_bytes')
			$arr[0]['property'] = 'sum_rxtx';
		$order = 'ORDER BY '.$arr[0]['property'].' '.$arr[0]['direction'];
	}
	else
		$order = 'ORDER BY ap_host ASC';

	$sql	=	"SELECT * FROM
				(SELECT
					st_wlan_station_list_current.client_id 							AS client_id,
					CONV(LEFT(REPLACE(st_wlan_station_list_current.sta_mac, ':', ''), 12), 16, 10)		AS sta_id,
					UNIX_TIMESTAMP(st_wlan_station_list_current.timestamp) 					AS sta_timestamp,
					st_wlan_station_list_current.sta_mac 							AS sta_mac,
					st_wlan_station_list_current.conn_time 							AS sta_conn_time,
					IF(st_wlan_station_list_current.psm = 1, 'YES', 'NO') 					AS sta_psm,
					IF(st_wlan_station_list_current.mimops > 0, 'YES', 'NO') 				AS sta_mimops,
					st_wlan_station_list_current.mcs 							AS sta_mcs,
					st_wlan_station_list_current.bw 							AS sta_bw,
					IF(st_wlan_station_list_current.sgi > 0, 'YES', 'NO') 					AS sta_sgi,
					IF(st_wlan_station_list_current.stbc > 0, 'YES', 'NO') 					AS sta_stbc,
					IF(st_wlan_station_list_current.ldpc > 0, 'YES', 'NO') 					AS sta_ldpc,
					st_wlan_station_list_current.mode 							AS sta_mode,
					st_wlan_station_list_current.tx_rate 							AS sta_tx_rate,
					IF(st_wlan_station_list_current.rssi1 = 0, st_wlan_station_list_current.rssi0, CONCAT(st_wlan_station_list_current.rssi0, ',', st_wlan_station_list_current.rssi1)) 
																AS sta_rssi,
					IF(st_wlan_station_list_current.quality1 = 0, CONCAT(st_wlan_station_list_current.quality0, '%'), CONCAT(st_wlan_station_list_current.quality0, '%, ', st_wlan_station_list_current.quality1, '%')) 
																AS sta_quality,
					st_wlan_station_list_current.rx_bytes 							AS sta_rx_bytes,
					st_wlan_station_list_current.tx_bytes 							AS sta_tx_bytes,
					st_ssid_list_current.ssid 								AS sta_ssid,
					st_ssid_list_current.bssid 								AS sta_bssid,
					IF(st_wlan_current.bssid5 = st_ssid_list_current.bssid, '5GHz', '2.4GHz')		AS sta_band,
					(SELECT
						vendor
					 FROM
						macvendor
					 WHERE
						CONV(LEFT(REPLACE(st_wlan_station_list_current.sta_mac, ':', ''), 6), 16, 10) = mac
					) 											AS sta_vendor,
					(SELECT
						CONCAT(st_lan_current.hostname, ' (', st_wan_current.ip, ')')
					 FROM
						st_lan_current, st_wan_current
					 WHERE
						st_lan_current.client_id = st_wlan_station_list_current.client_id
						AND
						st_wan_current.client_id = st_wlan_station_list_current.client_id
					) 											AS ap_host,
					IF(st_wlan_station_list_current.rssi1 = 0, st_wlan_station_list_current.rssi0, ((st_wlan_station_list_current.rssi0 + st_wlan_station_list_current.rssi1) / 2))
																AS avg_rssi,
					IF(st_wlan_station_list_current.quality1 = 0, st_wlan_station_list_current.quality0, ((st_wlan_station_list_current.quality0 + st_wlan_station_list_current.quality1) / 2)) 
																AS avg_quality,
					(st_wlan_station_list_current.rx_bytes + st_wlan_station_list_current.tx_bytes) AS sum_rxtx
				FROM
					st_wlan_station_list_current
					LEFT JOIN st_ssid_list_current ON (st_ssid_list_current.client_id = st_wlan_station_list_current.client_id AND st_ssid_list_current.bssid = st_wlan_station_list_current.bssid)
					LEFT JOIN st_wlan_current ON st_wlan_current.client_id = st_wlan_station_list_current.client_id
				WHERE (".$time." - UNIX_TIMESTAMP(st_wlan_station_list_current.timestamp) < ".$down_timeout.")
				ORDER BY conn_time
				) T1
			GROUP BY sta_mac ".$order;

	$res		= mysql_query($sql) or die($sql);
	$data		= Array();
	$count		= 0;
	$summ_24	= 0;
	$summ_5		= 0;

	while ($row = mysql_fetch_assoc($res)) {
		$last_conn		= $time - $row["sta_timestamp"];
		$find			= true;
		$row["ap_ssid"]	= $row["sta_ssid"].' ('.$row["sta_bssid"].')';

		if ($last_conn < $down_timeout) {
			$find = false;
			if ($filter == '')
				$find = true;
			else
				foreach ($row as &$value) {
					if (substr_count(strtoupper($value), strtoupper($filter)) > 0) {
						$srch = ($filter == '.' || $filter == ')' || $filter == '(') ? '\\'.$filter : $filter;
						$value = preg_replace_callback(	'/'.$srch.'/i',
										function ($matches) {
											return '<span class="x-item-selected">'.$matches[0].'</span>';
										},
										$value
										);
						$find = true;
					}
				}

			if ($find) {
				$count++;

				$row["sta_vendor"]	= ($row["sta_vendor"] == "") ? "Unknown" : $row["sta_vendor"];
				$row["sta_rxtx_bytes"]	= getRXTX($row["sta_rx_bytes"], $row["sta_tx_bytes"]);
				$row["sta_conn_time"]	= getUptime($row["sta_conn_time"], false, false);
				if ($row["sta_band"] == '5GHz')
					$summ_5++;
				else
					$summ_24++;

				$data[] = $row;
			}
		}
	}

	for ($i = 0; $i < count($data); $i++) {
		$data[$i]["sta_total"]	= $count;
		$data[$i]["sta_24"]	= $summ_24;
		$data[$i]["sta_5"]	= $summ_5;
	}

	header("Content-Type: application/json;charset=utf-8");
	echo json_encode($data);
?>