<?php
	function getUptime($uptime, $showDays, $showText) {
		if (empty($showDays))
			$showDays = false;
		if (empty($showText))
			$showText = false;

		$uptime_d = floor($uptime / 86400);
		$uptime_h = floor(($uptime - $uptime_d * 86400) / 3600);
		$uptime_m = floor(($uptime - $uptime_d * 86400 - $uptime_h * 3600) / 60);
		$uptime_s = $uptime - $uptime_d * 86400 - $uptime_h * 3600 - $uptime_m * 60;
		if (!$showDays) {
			$uptime_h = $uptime_d * 24 + $uptime_h;
			$uptime_d = 0;
		}
		if ($showText) {
			$uptime_d = ($uptime_d > 0) ? ($uptime_d.' day, ') : '';
			$uptime_h = ($uptime_d > 0) ? ($uptime_h.' hour, ') : ($uptime_h > 0) ? ($uptime_h.' hour, ') : '';
			$uptime_m = ($uptime_h > 0) ? ($uptime_m.' min, ') : ($uptime_m > 0) ? ($uptime_m .' min, ') : '';
			$uptime_s = $uptime_s.' sec';
		}
		else {
			$uptime_d = ($uptime_d > 0) ? ($uptime_d.':') : '';
			$uptime_h = ($uptime_h < 10) ? ('0'.$uptime_h.':') : ($uptime_h.':');
			$uptime_m = ($uptime_m < 10) ? ('0'.$uptime_m.':') : ($uptime_m.':');
			$uptime_s = ($uptime_s < 10) ? ('0'.$uptime_s) : $uptime_s;
		}
		return $uptime_d.$uptime_h.$uptime_m.$uptime_s;
	}

	function getRXTX($rx, $tx) {
		if ($rx > 1000000000) {
			$rxtx = round($rx / 1000000000, 2).'G';
		}
		else if ($rx > 1000000) {
			$rxtx = round($rx / 1000000).'M';
		}
		else if ($rx > 1000) {
			$rxtx = round($rx / 1000).'K';
		}
		else {
			$rxtx = $rx;
		}
		if ($tx != '-') {
			if ($tx > 1000000000) {
				$rxtx = $rxtx.' / '.round($tx / 1000000000, 2).'G';
			}
			else if ($tx > 1000000) {
				$rxtx = $rxtx.' / '.round($tx / 1000000).'M';
			}
			else if ($tx > 1000) {
				$rxtx = $rxtx.' / '.round($tx / 1000).'K';
			}
			else {
				$rxtx = $rxtx.' / '.$tx;
			}
		}
		return $rxtx;
	}
?>